unit Flytredt;

{/*****************************************************************/
 /  Copyright (c) 1999 IMCA SYSTEMS
 /  All Rights Reserved.
 /  Creation Date: 10.01.99
 /  Last Modifications Date : 19.01.1999
 /  MODULE: TCustomFlyTreeView properties Editor
 //separate registration of Propertyeditor, Customize functions and FlyTree
 {/*****************************************************************/}
interface
{$I DFS.inc}

{R flytredt.res}
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,Menus, Buttons, FlyTree,FInplace,
  ComCtrls{, ImgList}, TypInfo, raptree,
  Grids, exgrid, treecoll, PropTree;
type

 tCustomizeMode =(tcmGeneral,tcmNodes); //Toutline
 type
  TFlyNodesFrm = class(TForm)
    OkBtn: TButton;
    CancelBtn: TButton;
    ApplyBtn: TButton;
    PropertyPage: TPageControl;
    General: TTabSheet;
    TabSheet1: TTabSheet;
    Label2: TLabel;
    ColAdd: TButton;
    ColDel: TButton;
    ColMoveUp: TButton;
    ColMoveDown: TButton;
    GeneralProperties: TPropertiesTree;
    TabSheet2: TTabSheet;
    ScrollBox1: TScrollBox;
    ColumnTree: TPropertiesTree;
    ImagesBox: TGroupBox;
    AddImage: TButton;
    Delete: TButton;
    Clear: TButton;
    ImageView: TListView;
    Label1: TLabel;
    LIButton: TButton;
    Button2: TButton;
    Button1: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    ColumnsList: TFlyTreeView;
    procedure SizeChanged(Index, Value : integer);
    procedure AddBtnClick(Sender: TObject);
    procedure AddSubbtnClick(Sender: TObject);
    procedure CopyTreeToDesigner(aTree : TCustomFlyTreeView);
    procedure CopyDesignerToTree(aTree : TCustomFlyTreeView);
    procedure widthEditKeyPress(Sender: TObject; var Key: Char);
    procedure OkBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure ApplyBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SelectedIndexKeyPress(Sender: TObject; var Key: Char);
    procedure ImageIndexKeyPress(Sender: TObject; var Key: Char);
    procedure AddImageClick(Sender: TObject);
    procedure DeleteClick(Sender: TObject);
    procedure ClearClick(Sender: TObject);
    procedure ImageViewDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ColAddClick(Sender: TObject);
    //procedure ColumnsListClick(Sender: TObject);
    procedure ColDelClick(Sender: TObject);
    procedure ColMoveUpClick(Sender: TObject);
    procedure ColMoveDownClick(Sender: TObject);
    procedure ImageViewDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ColumnTreeModified(Sender: TObject);
    procedure ImageViewKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ColumnsListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure LIButtonClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure ColumnsListSelectedChanged(OldNode, NewNode: TFlyNode);
  private
    { Private declarations }
    Fmodified : Boolean;
    CustomizedTreeView : TCustomFlyTreeView;
    OldPt : TPoint;
    procedure SetModified(Value : Boolean);
    procedure EnumerateImages;
    procedure ApplyFonts;
  public
    { Public declarations }
    OrigFlyTree : TCustomFlyTreeView;
    //FColumns : TTreeColumns;
    ClassColumn : string;
    property Modified : boolean read Fmodified write SetModified;
  end;

var
  FlyNodesFrm: TFlyNodesFrm;

  function CustomizeTree(aTree : TCustomFlyTreeView; aCustomMode : tCustomizeMode; AClass: TTreeCollectionClass) : boolean;
  procedure ReadComp(Astream : TStream; AComponent : TComponent);
  Function Loadtemplate(aTree : TCustomFlyTreeView) : Boolean;//Load image of aTree from file
  Function SaveTemplate(aTree : TCustomFlyTreeView): Boolean;//save image of aTree to file
  procedure RestoreCompFromStrings(Control : Tcomponent; Astrings : Tstrings);
  procedure SaveCompToStrings(Control : Tcomponent; Astrings : Tstrings);

  function InternalCustomizeTree(aTree : Pointer) : boolean;
  function InternalLoadTemplate(aTree : Pointer): Boolean;
  Function InternalSaveTemplate(aTree : Pointer): Boolean;//save image of aTree to file
  procedure InternalReadComp(Astream,AComponent : Pointer);
  procedure IntRestoreCompFromStrings(Control : Pointer; Astrings : String);
  procedure IntSaveCompToStrings(Control,Astrings : Pointer);

implementation
  uses isconst, extdlgs, Clipbrd;


 {$R *.DFM}
//do not use !!! - for internal purposes only
function InternalLoadTemplate(aTree : Pointer): Boolean;
begin
  Result := LoadTemplate(TCustomFlyTreeView(aTree));
end;

procedure InternalReadComp(Astream,AComponent : Pointer);
begin
   Readcomp(TStream(aStream), TComponent(aComponent));
end;

procedure IntRestoreCompFromStrings(Control : Pointer; Astrings : String);
var MStrings: TStringlist;
begin
   MStrings := TStringlist.Create;
   try
      MStrings.Text:=aStrings;
      RestoreCompFromStrings(TComponent(Control),MStrings);
   finally
      MStrings.Free;
   end;
end;

procedure IntSaveCompToStrings(Control,Astrings : Pointer);
begin
  SaveCompToStrings(TComponent(Control),TStrings(aStrings));
end;

Function InternalSaveTemplate(aTree : Pointer): Boolean;//save image of aTree to file
begin
  Result := InternalSaveTemplate(TCustomFlyTreeView(aTree));
end;

function InternalCustomizeTree(aTree : Pointer) : boolean;
begin
  Result := CustomizeTree(TCustomFlyTreeView(aTree), tcmGeneral, TTreeCollection );
end;


function  CustomizeTree(aTree : TCustomFlyTreeView; aCustomMode : tCustomizeMode; aClass: TTreeCollectionClass) : boolean;
var
   Dialog : TFlyNodesFrm;
begin
     Dialog := TFlyNodesFrm.Create(Application);
     Dialog.ClassColumn := AClass.ClassName;
     Dialog.OrigFlyTree := aTree.CreateTo(Dialog.ScrollBox1);//Dialog);
     Dialog.OrigFlyTree.Parent:=Dialog.ScrollBox1;
     Dialog.CustomizedTreeView:=aTree;
     if aCustomMode = tcmNodes then
       Dialog.PropertyPage.ActivePage:=Dialog.General
     else
     begin
       Dialog.PropertyPage.ActivePage:=Dialog.General;
     end;
    try
      Dialog.Caption := aTree.Name+' '+Dialog.Caption;
      Dialog.modified:=false;
      Dialog.showmodal;
      Result:=Dialog.modified;
    finally
       Dialog.free;
    end;

end;

procedure ReadComp(Astream : TStream; AComponent : TComponent);
var
   Reader : TReader;
begin
   Reader := TReader.Create(Astream, 4096);
   Reader.Parent := nil;//AComponent.GetParentComponent;
   Astream.ReadResHeader;
   try
      Reader.BeginReferences;
      Reader.ReadSignature;
      Reader.ReadComponent(AComponent);
      Reader.FixupReferences;
   finally
      Reader.EndReferences;
      Reader.Free;
   end;
end;

procedure RestoreCompFromStrings(Control : Tcomponent; Astrings : Tstrings);
Var
   a, b : TMemoryStream;
begin
   a := TMemoryStream.Create;
   b := TMemoryStream.Create;
   a.Clear;
   b.Clear;
   try
      Astrings.SaveToStream(b);
      b.Position := 0;
      ObjectTextToResource(b, a);
      a.Position := 0;
      ReadComp(a, Control);
   finally
      a.Free;
      b.Free;
   end;
end;

// Saving To File
procedure SaveCompToStrings(Control : Tcomponent; Astrings : Tstrings);
Var
   a, b : TMemoryStream;
begin
   a := TMemoryStream.Create;
   b := TMemoryStream.Create;
   try
      a.WriteComponentRes(Control.ClassName, Control);
      a.Position := 0;
      ObjectResourceToText(a, b);
      b.Position := 0;
      Astrings.LoadFromStream(b);
   finally
      a.Free;
      b.Free;
   end;
end;


Function Loadtemplate(aTree : TCustomFlyTreeView) : Boolean;
var Dialog : TOpenDialog;
begin
   Result:=false;
   Dialog := TOpenDialog.Create(nil);
   try//changefileext
      Dialog.Title :=teLoadTemplate;
      Dialog.Filter := teLoadtemplateFiles;
      Dialog.FilterIndex := 0;
      Dialog.DefaultExt := teTemplateext;
      Dialog.Options := [ofExtensionDifferent, ofFileMustExist];
      if (Dialog.Execute) and (Dialog.Filename<>'') then
      begin
         if Dialog.Filterindex = 0 then
            Dialog.Filename := ChangeFileExt(Dialog.Filename,'.otv');
         aTree.LoadTemplateFromFile(Dialog.Filename);
         Result:=true;
      end;

   finally
      Dialog.Free;
   end;
end;


Function SaveTemplate(aTree : TCustomFlyTreeView): Boolean;
var Dialog : TsaveDialog;
begin
   Result:=false;
   Dialog := TSaveDialog.Create(nil);
   try
      Dialog.Title :='Save Template...';
      Dialog.Filter := teLoadtemplateFiles;
      Dialog.DefaultExt := teTemplateext;
      Dialog.FilterIndex := 0;
      Dialog.Options := [ofExtensionDifferent,ofOverwritePrompt,ofCreatePrompt];
      if (Dialog.Execute) and (Dialog.Filename<>'') then
      begin
         if Dialog.Filterindex = 0 then
            Dialog.Filename := ChangeFileExt(Dialog.Filename,'.otv');
         aTree.SaveTemplateToFile(Dialog.Filename);
         Result:=true;
      end;

   finally
      Dialog.Free;
   end;

end;




procedure TFlyNodesFrm.CopyDesignerToTree(aTree : TCustomFlyTreeView);
begin
  try
     OrigFlyTree.Left := OldPt.X;
     OrigFlyTree.Top := OldPt.Y;
     OrigFlyTree.AssignTo(aTree);
     OrigFlyTree.Left := 0;
     OrigFlyTree.Top := 0;

     aTree.Updatecolumns;
  finally
     Modified:=false;
  end;
end;

procedure TFlyNodesFrm.CopyTreeToDesigner(aTree : TCustomFlyTreeView);
begin
  try
   aTree.AssignTo(OrigFlyTree);
   ImageView.LargeImages := TCustomFlyTreeView(OrigFlyTree).Images;
   EnumerateImages;
   TCustomFlyTreeView(OrigFlyTree).OnColumnWidthChanged := SizeChanged;
   TCustomFlyTreeView(OrigFlyTree).OnRowHeightChanged := SizeChanged;
  finally
     Modified:=false;
  end;
end;

procedure TFlyNodesFrm.SetModified(Value : Boolean);
begin
   ApplyBtn.enabled:=Value;
   if Value<>FModified then
   begin
      FModified:=Value;
   end;
end;

procedure TFlyNodesFrm.SizeChanged(Index, Value : integer);
begin
   Modified:=true;
end;

procedure TFlyNodesFrm.AddBtnClick(Sender: TObject);
begin
    Modified :=true;
end;

procedure TFlyNodesFrm.AddSubbtnClick(Sender: TObject);
begin
    Modified :=true;
end;

procedure TFlyNodesFrm.widthEditKeyPress(Sender: TObject; var Key: Char);
const NumericChars = ['0'..'9',#8];
begin
  //validation Process
  if not (Key in NumericChars) then
     Key:=#0
  else
     Modified:=true;
end;

procedure TFlyNodesFrm.OkBtnClick(Sender: TObject);
begin
    ApplyBtnClick(nil);
    OrigFlyTree.Free;
    ModalResult:=OkBtn.ModalResult;
end;

procedure TFlyNodesFrm.FormShow(Sender: TObject);
var
    aNode : TFlyNode;
    i : integer;
begin
    if CustomizedTreeView<> nil then
    begin
       try
        AssignProperties(CustomizedTreeView, OrigFlyTree, false,'Align, Left, Top');
        CopyTreeToDesigner(CustomizedTreeView);
        {$IFDEF ActiveX}
        GeneralProperties.ExcludePropertiesFilter := 'Left, Top, Width, Height, UseDockManager, Align,Hint,Name,ParentFont,ShowHint,TabStop,TabOrder,Tag,BiDiMode,Anchors,Constraints,DockSite,DragCursor,DragKind,HelpContext,ParentBiDiMode,ParentColor,ParentCtl3D,ParentShowHint';
        {$ENDIF}
        GeneralProperties.SelectComponent(OrigFlyTree);
        OldPt.X := CustomizedTreeView.Left;
        OldPt.Y := CustomizedTreeView.Top;
        OrigFlyTree.Left:=0;
        OrigFlyTree.Top:=0;
        OrigFlyTree.Customizing := True;
        //hide some properties
        aNode := GeneralProperties.items.GetfirstNode;
        while aNode<> nil do
        begin
           if (aNode.Caption = 'Columns') or
           (aNode.Caption = 'Left') or
           (aNode.Caption = 'Top') then
           begin
              aNode.hide;
              break;
           end;
           aNode := aNode.GetNextSibling;
        end;

        //Copy Columns
        ColumnsList.Items.Clear;
        for i:=0 to TCustomFlyTreeView(OrigFlyTree).columns.Count -1 do
           //new 22.1.2
           ColumnsList.items.add(nil, TCustomFlyTreeView(OrigFlyTree).Columns[i].caption);
        ColumnsList.Selected := ColumnsList.Items.GetFirstNode;//new 22.1.2

        
       finally
         Modified:=false;
       end;
    end;
end;

procedure TFlyNodesFrm.CancelBtnClick(Sender: TObject);
begin
    ModalResult:=CancelBtn.ModalResult;
end;

procedure TFlyNodesFrm.ApplyBtnClick(Sender: TObject);
begin
   if Modified then
   begin
       {$IFNDEF DONTCUSTOMIZE}
       CustomizedTreeView.BeforeApply;
       {$ENDIF}
       CustomizedTreeView.Images.Clear;
       CustomizedTreeView.Images.Assign(OrigFlyTree.Images);
       AssignProperties(OrigFlyTree, CustomizedTreeView, False,'Align, Left, Top');
       CustomizedTreeView.Wallpaper.Assign(OrigFlyTree.Wallpaper);
       CopyDesignerToTree(CustomizedTreeView);
       {$IFNDEF DONTCUSTOMIZE}
       CustomizedTreeView.AfterApply;
       {$ENDIF}
       ApplyBtn.enabled:=false;//Modified:=false;
       CustomizedTreeView.FullExpand;
   end;
end;

procedure TFlyNodesFrm.FormCreate(Sender: TObject);
begin
   //
 //prompts
 //for change values simply change strings in isconst.pas file
 General.Caption:=teGeneral;
 Tabsheet2.Caption := tePreview;
 TabSheet1.Caption := teColumns;
 OkBtn.Caption :=teOK;
 CancelBtn.Caption :=teCancel;
 ApplyBtn.Caption :=teApply;
 ImagesBox.Caption := teImages;
 AddImage.Caption := teAdd;
 Delete.Caption := teDelete;
 Clear.Caption :=teClear;
 Label2.Caption :=teColList;
 Label1.Caption :=teProperties;
 ColAdd.Caption:=teAdd;
 ColDel.Caption:=teDelete;
 ColMoveUp.Caption:=teMoveUp;
 ColMoveDown.Caption:=teMovedown;
 ApplyFonts;
end;

procedure TFlyNodesFrm.ApplyFonts;
begin
   Font.Handle := GetStockObject(DEFAULT_GUI_FONT);
   GeneralProperties.Indent := GetSystemMetrics(SM_CXMENUCHECK);
   GeneralProperties.Defaultrowheight := Canvas.Textheight('Yg')+4;
   ColumnTree.Indent := GeneralProperties.Indent;
   ColumnTree.Defaultrowheight := GeneralProperties.Defaultrowheight;
end;

procedure TFlyNodesFrm.SelectedIndexKeyPress(Sender: TObject; var Key: Char);
const NumericChars = ['0'..'9',#8];
begin
  //validation Process
  if not (Key in NumericChars) then
     Key:=#0
  else
     Modified:=true;
end;

procedure TFlyNodesFrm.ImageIndexKeyPress(Sender: TObject; var Key: Char);
const NumericChars = ['0'..'9',#8];
begin
  //validation Process
  if not (Key in NumericChars) then
     Key:=#0
  else
     Modified:=true;

end;

procedure TFlyNodesFrm.EnumerateImages;
var i : integer;
begin
   ImageView.items.Clear;
   for i:=0 to TCustomFlyTreeView(OrigFlyTree).Images.Count-1 do
   with ImageView.items.Add do
   begin
      Caption:=inttostr(i);
      Imageindex := i;
   end;
end;

procedure TFlyNodesFrm.AddImageClick(Sender: TObject);
var aBitmap : TBitmap;
    aPic : TPicture;
    aFormat : Word;
    aBmpHandle : THandle;
    aBmpPalette : HPalette;
    {$ifdef DFS_COMPILER_3_UP}
    Opendialog : TOpenPicturedialog;
    {$ELSE}
    Opendialog : TOpenDialog;
    {$ENDIF}
begin
 {$ifdef DFS_COMPILER_3_UP}
 OpenDialog := TOpenPicturedialog.Create(Application);
 {$ELSE}
 OpenDialog := TOpenDialog.Create(Application);
{$ENDIF}

 try
   OpenDialog.Filter:='All Files (*.*)|*.*|Bitmaps (*.bmp)|*.bmp';
   OpenDialog.title:= teAddToImgList;
   if (Opendialog.execute) then
   if (Opendialog.Filename<>'') then
   begin
     aBitmap:=TBitmap.Create;
     aPic := TPicture.Create;
     try
       //aBitmap.LoadFromFile(Opendialog.Filename);
       aPic.LoadFromFile(Opendialog.Filename);
       aFormat := CF_BITMAP;
       aPic.SaveToClipboardFormat(aFormat, aBmpHandle, aBmpPalette);
       if aBmpHandle = 0 then
         exit
       else
       begin
          aBitmap.Handle := abmpHandle;
          aBitmap.Palette := aBmpPalette;
       end;
       if (TCustomFlyTreeView(OrigFlyTree).Images.Width <> aBitmap.width) or (TCustomFlyTreeView(OrigFlyTree).Images.height <> aBitmap.height) then
       if Application.MessageBox(Pchar(teApplysize),Pchar(teApplyWidthHeight),MB_ICONQUESTION +MB_YESNO+MB_DEFBUTTON2) = IDYES        then
       begin
         TCustomFlyTreeView(OrigFlyTree).Images.Width := aBitmap.width;
         TCustomFlyTreeView(OrigFlyTree).Images.height := aBitmap.height;
       end
       else
       begin // create new dimension bitmap
         aBitmap.width := TCustomFlyTreeView(OrigFlyTree).Images.Width;
         aBitmap.height := TCustomFlyTreeView(OrigFlyTree).Images.height;
       end;
       TCustomFlyTreeView(OrigFlyTree).Images.Add(aBitmap,nil);
       TCustomFlyTreeView(OrigFlyTree).Invalidate;
       //assign images
       EnumerateImages;
       Modified:=true;

     finally
        if not aBitmap.empty then aBitmap.FreeImage;
        abitmap.Free;
        aPic.Free;
     end;
   end;
 finally
   OpenDialog.Free;
 end;
end;

procedure TFlyNodesFrm.DeleteClick(Sender: TObject);
begin
  if Imageview.selected<>nil then
  begin
   if MessageBox(Handle,Pchar(teSure),Pchar(teDeleteImage),MB_ICONQUESTION +MB_YESNO+MB_DEFBUTTON2) = IDYES   then
   with TCustomFlyTreeView(OrigFlyTree).Images do
   begin
      delete(ImageView.selected.index);
      //assign images
      EnumerateImages;
      Modified := true;
   end;
  end;
end;

procedure TFlyNodesFrm.ClearClick(Sender: TObject);
begin
   if MessageBox(Handle,Pchar(teSure),Pchar(teclearImage), MB_ICONQUESTION +MB_YESNO+MB_DEFBUTTON2) = IDYES then
   begin
      TCustomFlyTreeView(OrigFlyTree).Images.clear;
      //assign images
      EnumerateImages;
      Modified := true;
   end;
end;

procedure TFlyNodesFrm.ImageViewDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
//
   //Accept:=Source is TListView;
   Accept:= Source = Imageview;
end;

procedure TFlyNodesFrm.ImageViewDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
   Index,NewIndex : integer;
begin
//
  if not (Sender is TListView) then exit;
  if TlistView(Sender).Droptarget=nil then exit;
  if TListView(Sender).Selected<>TlistView(Sender).DropTarget then
  begin
       Index := TListview(Sender).Selected.index;
       NewIndex := TListview(Sender).DropTarget.index;
       TCustomFlyTreeView(OrigFlyTree).Images.Move(index,NewIndex );
       //assign images
  end
  else
       Beep;
end;

procedure TFlyNodesFrm.ColAddClick(Sender: TObject);
var newcol : string;
    aNode : TFlyNode;
begin
    newcol:='Column'+inttostr(TCustomFlyTreeView(OrigFlyTree).columns.Count+1);
    TCustomFlyTreeView(OrigFlyTree).Columns.Add(newcol,ClassColumn);
    TCustomFlyTreeView(OrigFlyTree).UpdateColumns;
    aNode := ColumnsList.Items.Add(nil, newcol);//new 22.1.2
    ColumnsList.Selected := aNode;//new 22.1.2
    //ColumnsList.itemindex:=ColumnsList.items.add(newcol);
    //ColumnsListClick(nil);
    ColumnsList.SetFocus;
    Modified:=true;
end;

//new 22.1.2
{procedure TFlyNodesFrm.ColumnsListClick(Sender: TObject);
var aList : TList;
    i : integer;
begin
  aList := TList.Create;
  try
    for i:=0 to ColumnsList.Items.Count-1 do
    begin
       if ColumnsList.Selected[i] then
          aList.Add(TCustomFlyTreeView(OrigFlyTree).Columns[i]);
    end;
    ColumnTree.SelectComponents(aList);
  finally
     aList.Free;
  end;
end;
}

procedure TFlyNodesFrm.ColDelClick(Sender: TObject);
var aNode : TFlyNode;

begin
   //delete
   ColumnTree.Deselect;
   if ColumnsList.Rowcount>0 then    // CEDR
     TCustomFlyTreeView(OrigFlyTree).Columns.DeleteItem(TCustomFlyTreeView(OrigFlyTree).Columns[ColumnsList.Row]);//new 22.1.2
   TCustomFlyTreeView(OrigFlyTree).UpdateColumns;

   //new 22.1.2
   aNode := ColumnsList.Items.GetFirstSelectedNode;
   ColumnsList.Items.BeginUpdate;
   try
     while aNode <> nil do
     begin
      ColumnsList.Items.Delete(aNode);
      aNode := ColumnsList.Items.GetFirstSelectedNode;
     end;
   finally
     ColumnsList.Items.EndUpdate;
   end;

   ColumnsList.Selected := ColumnsList.Items.GetFirstNode;//new 22.1.2
   ColumnsList.SetFocus;
   Modified:=true;
end;


//--------------------------------------------------------------
procedure TFlyNodesFrm.ColMoveUpClick(Sender: TObject);
var aIndex : integer;
    aNode, aNodeTo : TFlyNode;
begin
  if ColumnsList.Row > 0 then //new 22.1.2
  begin
    aIndex := ColumnsList.Row; //22.1.2
    aNode := ColumnsList.GetNodeAtRow(aIndex);

    TCustomFlyTreeView(OrigFlyTree).Columns.Exchange(aIndex, aIndex-1);
    TCustomFlyTreeView(OrigFlyTree).UpdateColumns;

    aNodeTo := ColumnsList.GetNodeAtRow(ColumnsList.Row-1);
    if aNodeTo <> nil then
      aNode.MoveTo(aNodeTo, nainsert);

    ColumnsList.Selected := aNode;
    //ColumnsList.items.Exchange(aIndex, aIndex-1);
    //ColumnsList.ItemIndex:=aIndex-1;
    ColumnsList.SetFocus;
    Modified:=true;
  end;
end;

procedure TFlyNodesFrm.ColMoveDownClick(Sender: TObject);
var aIndex : integer;
    aNode, aNodeTo : TFlyNode;
begin
  if ColumnsList.Row < ColumnsList.Items.Count-1 then //new 22.1.2
  begin
    aIndex := ColumnsList.Row;
    //ColumnsList.items.Exchange(aIndex, aIndex+1);
    TCustomFlyTreeView(OrigFlyTree).Columns.Exchange(aIndex, aIndex+1);
    TCustomFlyTreeView(OrigFlyTree).UpdateColumns;

    with ColumnsList do
    begin
    aNode := GetNodeAtRow(Row);
    if (aNode <> nil) and (Row < RowCount )then
    begin
      aNodeTo := GetNodeAtRow(Row+1);
      if aNodeTo <> nil then
        aNodeto.MoveTo(aNode, nainsert);
      ColumnsList.Selected := aNode;
    end;
   end;

    //ColumnsList.ItemIndex := aIndex+1;
    ColumnsList.SetFocus;
    Modified:=true;
  end;
end;

procedure TFlyNodesFrm.ColumnTreeModified(Sender: TObject);
begin
   Modified:=true;
end;

procedure TFlyNodesFrm.ImageViewKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    Case Key of
       VK_INSERT: AddImageClick(nil);
       VK_DELETE: DeleteClick(nil);
    end;
end;

procedure TFlyNodesFrm.ColumnsListKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    Case Key of
       VK_DELETE: ColAddClick(nil);
       VK_INSERT: ColDelClick(nil);
    end;

end;

procedure TFlyNodesFrm.LIButtonClick(Sender: TObject);
var Opendlg : TOpendialog;
begin
   Opendlg := TOpendialog.Create(Self);
   try
    OpenDlg.Filter:=teLoadImagesFiles;
    OpenDlg.FilterIndex :=2;
    OpenDlg.defaultExt := teDefImgExt;
    OpenDlg.title:= teLoadImagesCaption;
    if (Opendlg.execute) then
    if (Opendlg.Filename<>'') then
    begin
      ImageView.LargeImages := nil;
      OrigFlyTree.LoadImagesFromfile(Opendlg.Filename);
      ImageView.LargeImages := TCustomFlyTreeView(OrigFlyTree).Images;
      EnumerateImages;
      Modified:=true;
    end;
   finally
     Opendlg.free;
   end;
end;

procedure TFlyNodesFrm.Button2Click(Sender: TObject);
var Opendlg : TSavedialog;
begin
   Opendlg := TSaveDialog.Create(Self);
   try
    OpenDlg.Filter:=teLoadImagesFiles;
    OpenDlg.FilterIndex :=2;
    OpenDlg.defaultExt := teDefImgExt;
    OpenDlg.title:= tesaveImagesCaption;

    if (Opendlg.execute) or (Opendlg.Filename<>'') then
    begin
      OrigFlyTree.SaveImagesTofile(Opendlg.Filename);
    end;
   finally
     Opendlg.free;
   end;
end;

procedure TFlyNodesFrm.FormDestroy(Sender: TObject);
begin
    ImageView.LargeImages:=nil;
    ColumnTree.Deselect;
    ColumnTree.Free;
    GeneralProperties.Deselect;
    GeneralProperties.Free;
end;

procedure TFlyNodesFrm.Button1Click(Sender: TObject);
var Bmp : TBitmap;
    AData : THandle;
    APalette : HPalette;
    MyFormat : Word;
begin
 if ImageView.Selected <> nil then
 begin
  Bmp := TBitmap.Create;
  try
    TCustomFlyTreeView(OrigFlyTree).Images.GetBitmap(ImageView.Selected.Index, Bmp);
    Bmp.SaveToClipBoardFormat(MyFormat, AData, APalette);
    ClipBoard.SetAsHandle(MyFormat,AData);
  finally
    Bmp.Free;
  end;
 end;
end;

procedure TFlyNodesFrm.Button3Click(Sender: TObject);
var
  Bmp : TBitmap;
begin
 Bmp := TBitMap.create;
 try
   Bmp.LoadFromClipBoardFormat(cf_BitMap,ClipBoard.GetAsHandle(cf_Bitmap),0);
   if (not Bmp.empty) and (Bmp.Width = TCustomFlyTreeView(OrigFlyTree).Images.Width) and
   (Bmp.Height = TCustomFlyTreeView(OrigFlyTree).Images.Height) then
   begin
    TCustomFlyTreeView(OrigFlyTree).Images.Add(Bmp,nil);
    EnumerateImages;
    Modified:=true;
   end;
 finally
   Bmp.free;
 end;

end;

procedure TFlyNodesFrm.Button4Click(Sender: TObject);
begin
 try
  CustomizedTreeView.LoadTemplate_
 finally
  ModalResult:=OkBtn.ModalResult;
 end;
end;

procedure TFlyNodesFrm.Button5Click(Sender: TObject);
begin
 try
  CustomizedTreeView.SaveTemplate_
 finally
  ModalResult:=OkBtn.ModalResult;
 end;
end;

procedure TFlyNodesFrm.ColumnsListSelectedChanged(OldNode,
  NewNode: TFlyNode);
var aList : TList;
    i : integer;
begin
  aList := TList.Create;
  try
    if NewNode <> nil then
      aList.Add(TCustomFlyTreeView(OrigFlyTree).Columns[NewNode.Index]);
    for i:=0 to ColumnsList.Items.Count-1 do
    begin
       if ColumnsList.Items[i].Selected then //new 22.1.2
          aList.Add(TCustomFlyTreeView(OrigFlyTree).Columns[i]);
    end;
    ColumnTree.SelectComponents(aList);
  finally
     aList.Free;
  end;
end;

end.


