unit ISHTMLHintWindow;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;
{$I DFS.INC}
{$R *.RES}
type
   TISHTMLHintWindow = class(THintWindow)
   private
      FHTMLDrawing : Boolean;
    Fwordwrap: boolean;
    procedure SetHTMLDrawing(const Value: Boolean);
    procedure SetWordWrap(const Value: boolean);
   protected
      procedure Paint; override;
   public
      function CalcHintRect(MaxWidth: Integer; const AHint: string; AData: Pointer): TRect; override;
   published
      property HTMLDrawing : Boolean read FHTMLDrawing write SetHTMLDrawing;
      property Wordwrap : boolean read Fwordwrap write SetWordWrap;
   end;

procedure Register;

implementation

uses ISHTMLDRaw;

procedure TISHTMLHintWindow.Paint;
var
  R: TRect;
begin
  if FHTMLDrawing then
  begin
    R := ClientRect;
    Inc(R.Left, 2);
    Inc(R.Top, 2);
    Canvas.Font.Color := clInfoText;
    Canvas.Brush.Color := Color;
    DrawHTML(R, Canvas, Caption, FWordwrap, false, DT_LEFT, DT_VCENTER)
 end
 else
    inherited;
end;

function TISHTMLHintWindow.CalcHintRect(MaxWidth: Integer; const AHint: string; AData: Pointer): TRect;
begin
  if FHTMLDrawing then
  begin
    Result := Rect(0, 0, MaxWidth, 0);
    DrawHTML(Result, Canvas, aHint, FWordwrap, true, DT_LEFT,DT_VCENTER);
    Inc(Result.Right, 8);
    Inc(Result.Bottom, 2);
  end
  else
    Result := inherited CalcHintRect(MaxWidth, AHint, AData);
end;

procedure TISHTMLHintWindow.SetHTMLDrawing(const Value: Boolean);
begin
  FHTMLDrawing := Value;
end;

procedure TISHTMLHintWindow.SetWordWrap(const Value: boolean);
begin
  Fwordwrap := Value;
end;

procedure Register;
begin
  RegisterNoIcon([TISHTMLHintWindow]);
end;

end.
 