unit OLEDragDrop;
{/*****************************************************************
/  Copyright (c) 1998-2000 IMCA SYSTEMS
/  All Rights Reserved.
/  MODULE: OLE DragDrop supports routines and classes
/  Creation Date: 15.11.2000
/  Version 1.0
/*****************************************************************}

interface

uses
  Controls, Windows, ActiveX, Classes, CommCtrl, Graphics,ImgList;


const
  MAXFORMATS = 20;

type

  IS_IMoniker = interface;
  IS_IEnumMoniker = interface;
  IS_IEnumString = interface;

  PDVTargetDevice = ^TDVTargetDevice;
  TDVTargetDevice = record
    tdSize: Longint;
    tdDriverNameOffset: Word;
    tdDeviceNameOffset: Word;
    tdPortNameOffset: Word;
    tdExtDevmodeOffset: Word;
    tdData: record end;
  end;


  TClipFormat = Word;

  PISFormatEtc = ^TISFormatEtc;
  TISFormatEtc = record
    cfFormat: TClipFormat;
    ptd: PDVTargetDevice;
    dwAspect: Longint;
    lindex: Longint;
    tymed: Longint;
  end;

  ISFORMATETC = TISFormatEtc;

  POleStr = PWideChar;
  PCLSID = PGUID;
  TCLSID = TGUID;
  TIID = TGUID;
  Largeint = Int64;

  PISStgMedium = ^TISStgMedium;
  TISStgMedium = record
    tymed: Longint;
    case Integer of
      0: (hBitmap: HBitmap; unkForRelease: Pointer{IUnknown});
      1: (hMetaFilePict: THandle);
      2: (hEnhMetaFile: THandle);
      3: (hGlobal: HGlobal);
      4: (lpszFileName: POleStr);
      5: (stm: Pointer{IS_IStream});
      6: (stg: Pointer{IStorage});
  end;
  ISStgMedium = TISStgMedium;

  { IPictureDisp }
  //IPictureDisp = interface(IDispatch)
  //  ['{7BF80981-BF32-101A-8BBB-00AA00300CAB}']
  //end;
  //Picture = IPictureDisp;

   IS_IEnumFORMATETC = interface(IUnknown)
    ['{00000103-0000-0000-C000-000000000046}']
    function Next(celt: Longint; out elt;
      pceltFetched: PLongint): HResult; stdcall;
    function Skip(celt: Longint): HResult; stdcall;
    function Reset: HResult; stdcall;
    function Clone(out Enum: IS_IEnumFORMATETC): HResult; stdcall;
  end;

  IS_IPersist = interface(IUnknown)
    ['{0000010C-0000-0000-C000-000000000046}']
    function GetClassID(out classID: TCLSID): HResult; stdcall;
  end;

  PStatStg = ^TStatStg;
  TStatStg = record
    pwcsName: POleStr;
    dwType: Longint;
    cbSize: Largeint;
    mtime: TFileTime;
    ctime: TFileTime;
    atime: TFileTime;
    grfMode: Longint;
    grfLocksSupported: Longint;
    clsid: TCLSID;
    grfStateBits: Longint;
    reserved: Longint;
  end;


  IS_IStream = interface(IUnknown)
    ['{0000000C-0000-0000-C000-000000000046}']
    function Read(pv: Pointer; cb: Longint; pcbRead: PLongint): HResult;
      stdcall;
    function Write(pv: Pointer; cb: Longint; pcbWritten: PLongint): HResult;
      stdcall;
    function Seek(dlibMove: Largeint; dwOrigin: Longint;
      out libNewPosition: Largeint): HResult; stdcall;
    function SetSize(libNewSize: Largeint): HResult; stdcall;
    function CopyTo(stm: IS_IStream; cb: Largeint; out cbRead: Largeint;
      out cbWritten: Largeint): HResult; stdcall;
    function Commit(grfCommitFlags: Longint): HResult; stdcall;
    function Revert: HResult; stdcall;
    function LockRegion(libOffset: Largeint; cb: Largeint;
      dwLockType: Longint): HResult; stdcall;
    function UnlockRegion(libOffset: Largeint; cb: Largeint;
      dwLockType: Longint): HResult; stdcall;
    function Stat(out statstg: TStatStg; grfStatFlag: Longint): HResult;
      stdcall;
    function Clone(out stm: IS_IStream): HResult; stdcall;
  end;

  IS_IPersistStream = interface(IS_IPersist)
    ['{00000109-0000-0000-C000-000000000046}']
    function IsDirty: HResult; stdcall;
    function Load(const stm: IS_IStream): HResult; stdcall;
    function Save(const stm: IS_IStream; fClearDirty: BOOL): HResult; stdcall;
    function GetSizeMax(out cbSize: Largeint): HResult; stdcall;
  end;

  PBindOpts = ^TBindOpts;
  TBindOpts = record
    cbStruct: Longint;
    grfFlags: Longint;
    grfMode: Longint;
    dwTickCountDeadline: Longint;
  end;

  IS_IRunningObjectTable = interface(IUnknown)
    ['{00000010-0000-0000-C000-000000000046}']
    function Register(grfFlags: Longint; const unkObject: IUnknown;
      const mkObjectName: IS_IMoniker; out dwRegister: Longint): HResult; stdcall;
    function Revoke(dwRegister: Longint): HResult; stdcall;
    function IsRunning(const mkObjectName: IS_IMoniker): HResult; stdcall;
    function GetObject(const mkObjectName: IS_IMoniker;
      out unkObject: IUnknown): HResult; stdcall;
    function NoteChangeTime(dwRegister: Longint;
      const filetime: TFileTime): HResult; stdcall;
    function GetTimeOfLastChange(const mkObjectName: IS_IMoniker;
      out filetime: TFileTime): HResult; stdcall;
    function EnumRunning(out enumMoniker: IS_IEnumMoniker): HResult; stdcall;
  end;

  IS_IBindCtx = interface(IUnknown)
    ['{0000000E-0000-0000-C000-000000000046}']
    function RegisterObjectBound(const unk: IUnknown): HResult; stdcall;
    function RevokeObjectBound(const unk: IUnknown): HResult; stdcall;
    function ReleaseBoundObjects: HResult; stdcall;
    function SetBindOptions(const bindopts: TBindOpts): HResult; stdcall;
    function GetBindOptions(var bindopts: TBindOpts): HResult; stdcall;
    function GetRunningObjectTable(out rot: IS_IRunningObjectTable): HResult;
      stdcall;
    function RegisterObjectParam(pszKey: POleStr; const unk: IUnknown): HResult;
      stdcall;
    function GetObjectParam(pszKey: POleStr; out unk: IUnknown): HResult;
      stdcall;
    function EnumObjectParam(out Enum: IS_IEnumString): HResult; stdcall;
    function RevokeObjectParam(pszKey: POleStr): HResult; stdcall;
  end;

  IS_IEnumMoniker = interface(IUnknown)
    ['{00000102-0000-0000-C000-000000000046}']
    function Next(celt: Longint; out elt;
      pceltFetched: PLongint): HResult; stdcall;
    function Skip(celt: Longint): HResult; stdcall;
    function Reset: HResult; stdcall;
    function Clone(out enm: IS_IEnumMoniker): HResult; stdcall;
  end;

  IS_IEnumString = interface(IUnknown)
    ['{00000101-0000-0000-C000-000000000046}']
    function Next(celt: Longint; out elt;
      pceltFetched: PLongint): HResult; stdcall;
    function Skip(celt: Longint): HResult; stdcall;
    function Reset: HResult; stdcall;
    function Clone(out enm: IS_IEnumString): HResult; stdcall;
  end;

  { IS_IMoniker interface }

  PIS_IMoniker = ^IS_IMoniker;

  IS_IMoniker = interface(IS_IPersistStream)
    ['{0000000F-0000-0000-C000-000000000046}']
    function BindToObject(const bc: IS_IBindCtx; const mkToLeft: IS_IMoniker;
      const iidResult: TIID; out vResult): HResult; stdcall;
    function BindToStorage(const bc: IS_IBindCtx; const mkToLeft: IS_IMoniker;
      const iid: TIID; out vObj): HResult; stdcall;
    function Reduce(const bc: IS_IBindCtx; dwReduceHowFar: Longint;
      mkToLeft: PIS_IMoniker; out mkReduced: IS_IMoniker): HResult; stdcall;
    function ComposeWith(const mkRight: IS_IMoniker; fOnlyIfNotGeneric: BOOL;
      out mkComposite: IS_IMoniker): HResult; stdcall;
    function Enum(fForward: BOOL; out enumMoniker: IS_IEnumMoniker): HResult;
      stdcall;
    function IsEqual(const mkOtherMoniker: IS_IMoniker): HResult; stdcall;
    function Hash(out dwHash: Longint): HResult; stdcall;
    function IsRunning(const bc: IS_IBindCtx; const mkToLeft: IS_IMoniker;
      const mkNewlyRunning: IS_IMoniker): HResult; stdcall;
    function GetTimeOfLastChange(const bc: IS_IBindCtx; const mkToLeft: IS_IMoniker;
      out filetime: TFileTime): HResult; stdcall;
    function Inverse(out mk: IS_IMoniker): HResult; stdcall;
    function CommonPrefixWith(const mkOther: IS_IMoniker;
      out mkPrefix: IS_IMoniker): HResult; stdcall;
    function RelativePathTo(const mkOther: IS_IMoniker;
      out mkRelPath: IS_IMoniker): HResult; stdcall;
    function GetDisplayName(const bc: IS_IBindCtx; const mkToLeft: IS_IMoniker;
      out pszDisplayName: POleStr): HResult; stdcall;
    function ParseDisplayName(const bc: IS_IBindCtx; const mkToLeft: IS_IMoniker;
      pszDisplayName: POleStr; out chEaten: Longint;
      out mkOut: IS_IMoniker): HResult; stdcall;
    function IsSystemMoniker(out dwMksys: Longint): HResult; stdcall;
  end;

   IS_IAdviseSink = interface(IUnknown)
    ['{0000010F-0000-0000-C000-000000000046}']
    procedure OnDataChange(const formatetc: TISFormatEtc; const stgmed: TISStgMedium);
      stdcall;
    procedure OnViewChange(dwAspect: Longint; lindex: Longint);
      stdcall;
    procedure OnRename(const mk: IS_IMoniker); stdcall;
    procedure OnSave; stdcall;
    procedure OnClose; stdcall;
  end;

  { IEnumStatData interface }

  PStatData = ^TStatData;
  TStatData = record
    formatetc: TISFormatEtc;
    advf: Longint;
    advSink: IS_IAdviseSink;
    dwConnection: Longint;
  end;


  IS_IEnumSTATDATA = interface(IUnknown)
    ['{00000105-0000-0000-C000-000000000046}']
    function Next(celt: Longint; out elt;
      pceltFetched: PLongint): HResult; stdcall;
    function Skip(celt: Longint): HResult; stdcall;
    function Reset: HResult; stdcall;
    function Clone(out Enum: IS_IEnumSTATDATA): HResult; stdcall;
  end;

  IS_IDataObject = interface(IUnknown)
    ['{0000010E-0000-0000-C000-000000000046}']
    function GetData(const formatetcIn: TISFormatEtc; out medium: TISStgMedium):
      HResult; stdcall;
    function GetDataHere(const formatetc: TISFormatEtc; out medium: TISStgMedium):
      HResult; stdcall;
    function QueryGetData(const formatetc: TISFormatEtc): HResult;
      stdcall;
    function GetCanonicalFormatEtc(const formatetc: TISFormatEtc;
      out formatetcOut: TISFormatEtc): HResult; stdcall;
    function SetData(const formatetc: TISFormatEtc; var medium: TISStgMedium;
      fRelease: BOOL): HResult; stdcall;
    function EnumFormatEtc(dwDirection: Longint; out enumFormatEtc:
      IS_IEnumFORMATETC): HResult; stdcall;
    function DAdvise(const formatetc: TISFormatEtc; advf: Longint;
      const advSink: IS_IAdviseSink; out dwConnection: Longint): HResult; stdcall;
    function DUnadvise(dwConnection: Longint): HResult; stdcall;
    function EnumDAdvise(out enumAdvise: IS_IEnumSTATDATA): HResult;
      stdcall;
  end;

  IS_IDropSource = interface(IUnknown)
  ['{00000121-0000-0000-C000-000000000046}']
    function QueryContinueDrag(fEscapePressed: BOOL;
      grfKeyState: Longint): HResult; stdcall;
    function GiveFeedback(dwEffect: Longint): HResult; stdcall;
  end;

  IS_IDropTarget = interface(IUnknown)
    ['{00000122-0000-0000-C000-000000000046}']
    function DragEnter(const dataObj: IS_IDataObject; grfKeyState: Longint;
      pt: TPoint; var dwEffect: Longint): HResult; stdcall;
    function DragOver(grfKeyState: Longint; pt: TPoint;
      var dwEffect: Longint): HResult; stdcall;
    function DragLeave: HResult; stdcall;
    function Drop(const dataObj: IS_IDataObject; grfKeyState: Longint; pt: TPoint;
      var dwEffect: Longint): HResult; stdcall;
  end;


  TDragType = (dtCopy, dtMove, dtLink);
  TDragTypes = set of TDragType;

  TDragResult = (drDropCopy, drDropMove,
    drDropLink, drCancel, drOutMemory, drUnknown, drUnspec);

  TDropEvent = procedure(Sender: TObject;
    DragType: TDragType; var ContinueDrop: Boolean) of object;
  TFeedbackEvent = procedure(Sender: TObject;
    Effect: LongInt; var UseDefaultCursors: Boolean) of object;
  TSetDataEvent = procedure(Data : IS_IDataObject; Format : Integer) of object;

  TCompleteDragEvent= procedure(Effect: LongInt) of object;
  TStartDragEvent= procedure(Data : IS_IDataObject; var AllowedEffects : Longint) of object;

  TOleObjectWrapper = class(TObject)
  private
    dataObj : IS_IDataObject;
    FString : string;
    FList : TStringlist; //olevariant
    FMetafile : TMetafile;
    FBitmap : TBitmap;
    function GetInternalData(const FormatEtcIn: TISFormatEtc; out Medium: TISStgMedium ) : HRESULT;
  protected
    function GetFileList : TStringList;
    function GetString : string;
    function GetMetafile : TMetafile;
    function GetBitmap : TBitmap;

    procedure SetMetafile(Value : TMetafile);
    procedure SetBitmap(Value : TBitmap);
    Procedure SetString(Value : String);
  public
    constructor Create(Data : IS_IDataObject);
    destructor Destroy; override;
    procedure ClearData;
    function GetData(Format : integer) : OleVariant;
    procedure SetData(Value : OleVariant; Format : integer);
    function HasDataFormat(Format : integer) : boolean;
    function DataObject : IS_IDataObject;
    property FileList : TStringList read GetFileList;
    property StringData : string read GetString write SetString;
    property Bitmap : TBitmap read GetBitmap;
    property Metafile : TMetafile read GetMetafile;
  end;

  TInterfacedComponent = class(TComponent, IUnknown)
  private
    fRefCount: Integer;
  protected
    function QueryInterface(const IID: TGuid; out Obj): HRESULT; override; stdcall;
    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;
  end;

  TISDragImageList = class(TCustomImageList)
  private
    FDragCursor: TCursor;
    FDragging: Boolean;
    FDragHandle: HWND;
    FDragHotspot: TPoint;
    FDragIndex: Integer;
    procedure CombineDragCursor;
    procedure SetDragCursor(Value: TCursor);
  protected
    procedure Initialize; override;
  public
    function BeginDrag(Window: HWND; X, Y, HSX, HSY: Integer): Boolean;
    function DragLock(Window: HWND; XPos, YPos: Integer): Boolean;
    function DragMove(X, Y: Integer): Boolean;
    procedure DragUnlock;
    function EndDrag: Boolean;
    function GetHotSpot: TPoint; override;
    procedure HideDragImage;
    function SetDragImage(Index, HotSpotX, HotSpotY: Integer): Boolean;
    procedure ShowDragImage;
    property DragCursor: TCursor read FDragCursor write SetDragCursor;
    property Dragging: Boolean read FDragging;
  end;

  TOLEDropSource = class(TInterfacedComponent, IS_IDropSource, IS_IDataObject)
  private
    fDragTypes      : TDragTypes;
    fDropEvent      : TDropEvent;
    FOnCompleteDrag : TCompleteDragEvent;
    FonStartDrag    : TStartDragEvent;
    fFBEvent        : TFeedBackEvent;
    FOnSetData      : TSetDataEvent;
    fDataFormats    : array[0..MAXFORMATS-1] of TISFormatEtc;
    fDataFormatsCount: integer;
    fImages: TISDragImageList;
    fShowImage: boolean;
    fImageIndex: integer;
    fImageHotSpot: TPoint;
    FWrapper : TOleObjectWrapper;
    procedure SetShowImage(Value: boolean);
  protected
    FeedbackEffect  : LongInt;
     // IS_IDropSource implementation
    function QueryContinueDrag(fEscapePressed: bool;
      grfKeyState: LongInt): HRESULT; stdcall;
    function GiveFeedback(dwEffect: LongInt): HRESULT; stdcall;

    // IS_IDataObject implementation
    function GetData(const FormatEtcIn: TISFormatEtc;
      out Medium: TISStgMedium):HRESULT; stdcall;
    function GetDataHere(const FormatEtc: TISFormatEtc;
      out Medium: TISStgMedium):HRESULT; stdcall;
    function QueryGetData(const FormatEtc: TISFormatEtc): HRESULT; stdcall;
    function GetCanonicalFormatEtc(const FormatEtc: TISFormatEtc;
      out FormatEtcout: TISFormatEtc): HRESULT; stdcall;
    function SetData(const FormatEtc: TISFormatEtc; var Medium: TISStgMedium;
      fRelease: Bool): HRESULT; stdcall;
    function EnumFormatEtc(dwDirection: LongInt;
      out EnumFormatEtc: IS_IEnumFORMATETC): HRESULT; stdcall;
    function dAdvise(const FormatEtc: TISFormatEtc; advf: LongInt;
      const advsink: IS_IAdviseSink; out dwConnection: LongInt): HRESULT; stdcall;
    function dUnadvise(dwConnection: LongInt): HRESULT; stdcall;
    function EnumdAdvise(out EnumAdvise: IS_IEnumSTATDATA): HRESULT; stdcall;

    function DoGetData(const FormatEtcIn: TISFormatEtc;
             out Medium: TISStgMedium ) : HRESULT; virtual;
    procedure AddFormatEtc(cfFmt: TClipFormat;
                pt: PDVTargetDevice; dwAsp, lInd, tym: longint); virtual;
    function InternalCutCopyToClipboard(Effect: Integer): boolean;
    function CutOrCopyToClipboard: boolean; virtual;

    procedure SetImages(const Value: TISDragImageList);
    procedure SetImageIndex(const Value: integer);
    procedure SetPoint(Index: integer; Value: integer);
    function GetPoint(Index: integer): integer;
    procedure CompleteDrag(Effect : Longint);
    procedure StartDrag(Data : IS_IDataObject; var AllowedEffects : Longint);
    function OnOleSetData(Data : IS_IDataObject; Format : integer) : HRESULT;
    procedure ClearData;
  public
    constructor Create(aOwner : TComponent); override;
    destructor Destroy; override;
    function Execute(Window : Hwnd): TDragResult;
    function CutToClipboard: boolean; virtual;
    function CopyToClipboard: boolean; virtual;
    property Dragtypes: TDragTypes read fDragTypes write fDragTypes;
    property OnFeedback: TFeedbackEvent read fFBEvent write fFBEvent;
    property OnSetData : TSetDataEvent read FOnSetData Write FOnSetData;
    property OnDrop: TDropEvent read fDropEvent write fDropEvent;
    property OnCompleteDrag : TCompleteDragEvent read FOnCompleteDrag write FOnCompleteDrag;
    property OnStartDrag    : TStartDragEvent read FonStartDrag write FonStartDrag;
    property Images: TISDragImageList read fImages write SetImages;
    property ImageIndex: integer read fImageIndex write SetImageIndex;
    property ShowImage: boolean read fShowImage write SetShowImage;
    property ImageHotSpotX: integer index 1 read GetPoint write SetPoint;
    property ImageHotSpotY: integer index 2 read GetPoint write SetPoint;
    Property DataWrapper : TOleObjectWrapper read FWrapper;
  end;


  TDropTargetEvent = procedure(Sender: TObject; Data : IS_IDataObject;
    ShiftState: TShiftState; Point: TPoint; var Effect: Longint) of Object;

  TDropEffectEvent = procedure(Sender: TObject;
    ShiftState: TShiftState; Point: TPoint; var Effect: Longint) of Object;


  TOLEDropTarget = class(TInterfacedComponent, IS_IDropTarget)
  private
    FWrapper : TOleObjectWrapper;
    fDataObj: IS_IDataObject;
    fDragTypes: TDragTypes;
    fRegistered: boolean;
    fTarget: TWinControl;
    fGetDataOnEnter: boolean;
    fOnEnter: TDropTargetEvent;
    fOnDragOver: TDropTargetEvent;
    fOnLeave: TNotifyEvent;
    fOnDrop: TDropTargetEvent;
    fGetDropEffectEvent: TDropEffectEvent;
    fImages: TISDragImageList;
    fDragImageHandle: HImageList;
    fShowImage: boolean;
    fImageHotSpot: TPoint;
    fLastPoint: TPoint; //Point where DragImage was last painted (used internally)
    procedure SetShowImage(Show: boolean);
    procedure CreateWrapper(Data : IS_IDataObject);
  protected
    // IS_IDropTarget methods...
    function DragEnter(const DataObj: IS_IDataObject; grfKeyState: Longint;
      pt: TPoint; var dwEffect: Longint): HRESULT; StdCall;
    function DragOver(grfKeyState: Longint; pt: TPoint;
      var dwEffect: Longint): HRESULT; StdCall;
    function DragLeave: HRESULT; StdCall;
    function Drop(const dataObj: IS_IDataObject; grfKeyState: Longint; pt: TPoint;
      var dwEffect: Longint): HRESULT; StdCall;

    procedure DoEnter(Data : IS_IDataObject; ShiftState: TShiftState; Point: TPoint; var Effect: Longint); virtual;
    procedure DoDragOver(Data : IS_IDataObject; ShiftState: TShiftState; Point: TPoint; var Effect: Longint); virtual;
    procedure DoDrop(Data : IS_IDataObject; ShiftState: TShiftState; Point: TPoint; var Effect: Longint); virtual;
    procedure DoLeave; virtual;

    function DoGetData: boolean; Virtual;
    procedure ClearData; Virtual;
    function HasValidFormats: boolean; Virtual;
    function GetValidDropEffect(ShiftState: TShiftState;
      pt: TPoint; dwEffect: LongInt): LongInt;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Register(Target: TWinControl);
    procedure Unregister;
    function PasteFromClipboard: longint; Virtual;
    property Target: TWinControl read fTarget;
    property Dragtypes: TDragTypes read fDragTypes write fDragTypes;
    property GetDataOnEnter: Boolean read fGetDataOnEnter write fGetDataOnEnter;
    property OnEnter: TDropTargetEvent read fOnEnter write fOnEnter;
    property OnDragOver: TDropTargetEvent read fOnDragOver write fOnDragOver;
    property OnLeave: TNotifyEvent read fOnLeave write fOnLeave;
    property OnDrop: TDropTargetEvent read fOnDrop write fOnDrop;
    property OnGetDropEffect: TDropEffectEvent
      read fGetDropEffectEvent write fGetDropEffectEvent;
    property ShowImage: boolean read fShowImage write SetShowImage;
    Property DataWrapper : TOleObjectWrapper read FWrapper;
  end;

  var
    CF_PREFERREDDROPEFFECT: UINT;
//    CF_FILEGROUPDESCRIPTOR, CF_FILECONTENTS, CF_FILENAMEMAP, CF_FILENAMEMAPW,
//    CF_IDLIST, CF_PREFERREDDROPEFFECT, CF_URL: UINT; //see initialization.


  function ClientPtToWindowPt(Handle: HWND; pt: TPoint): TPoint;
  function RegisterDragDrop(wnd: HWnd; dropTarget: IS_IDropTarget): HResult; stdcall;
  function RevokeDragDrop(wnd: HWnd): HResult; stdcall;
  function DoDragDrop(dataObj: IS_IDataObject; dropSource: IS_IDropSource;
  dwOKEffects: Longint; var dwEffect: Longint): HResult; stdcall;
  function OleInitialize(pwReserved: Pointer): HResult; stdcall;
  procedure OleUninitialize; stdcall;

 const
  DVASPECT_CONTENT   = 1;
  DVASPECT_THUMBNAIL = 2;
  DVASPECT_ICON      = 4;
  DVASPECT_DOCPRINT  = 8;

  TYMED_HGLOBAL  = 1;
  TYMED_FILE     = 2;
  TYMED_ISTREAM  = 4;
  TYMED_ISTORAGE = 8;
  TYMED_GDI      = 16;
  TYMED_MFPICT   = 32;
  TYMED_ENHMF    = 64;
  TYMED_NULL     = 0;

  DATADIR_GET = 1;
  DATADIR_SET = 2;

  IS_DROPEFFECT_NONE   = 0;
  IS_DROPEFFECT_COPY   = 1;
  IS_DROPEFFECT_MOVE   = 2;
  IS_DROPEFFECT_LINK   = 4;
  IS_DROPEFFECT_SCROLL = DWORD($80000000);

  HDropFormatEtc: TISFormatEtc = (cfFormat: CF_HDROP;
    ptd: nil; dwAspect: DVASPECT_CONTENT; lindex: -1; tymed: TYMED_HGLOBAL);
  TexTISFormatEtc: TISFormatEtc = (cfFormat: CF_TEXT;
    ptd: nil; dwAspect: DVASPECT_CONTENT; lindex: -1; tymed: TYMED_HGLOBAL);

implementation

uses
  ShlObj,
  SysUtils,
  ClipBrd, Forms, {$ifdef ActiveX}XFrame{$else}AxCtrls{$endif};

// -----------------------------------------------------------------------------
//			Miscellaneous functions.
// -----------------------------------------------------------------------------
const
  ole32    = 'ole32.dll';

function RegisterDragDrop;              external ole32 name 'RegisterDragDrop';
function RevokeDragDrop;                external ole32 name 'RevokeDragDrop';
function DoDragDrop;                    external ole32 name 'DoDragDrop';
function OleInitialize;                 external ole32 name 'OleInitialize';
procedure OleUninitialize;              external ole32 name 'OleUninitialize';

function ClientPtToWindowPt(Handle: HWND; pt: TPoint): TPoint;
var
  Rect: TRect;
begin
  ClientToScreen(Handle, pt);
  GetWindowRect(Handle, Rect);
  Result.X := pt.X - Rect.Left;
  Result.Y := pt.Y - Rect.Top;
end;


// -----------------------------------------------------------------------------
//			TEnumFormatEtc
// -----------------------------------------------------------------------------

type

pFormatList = ^TFormatList;
TFormatList = array[0..255] of TISFormatEtc;

TEnumFormatEtc = class(TInterfacedObject, IS_IEnumFORMATETC)
private
  fFormatList: pFormatList;
  fFormatCount: Integer;
  fIndex: Integer;
public
  constructor Create(FormatList: pFormatList; FormatCount, Index: Integer);
  { IS_IEnumFORMATETC }
  function Next(Celt: LongInt; out Elt; pCeltFetched: pLongInt): HRESULT; stdcall;
  function Skip(Celt: LongInt): HRESULT; stdcall;
  function Reset: HRESULT; stdcall;
  function Clone(out Enum: IS_IEnumFORMATETC): HRESULT; stdcall;
end;
// -----------------------------------------------------------------------------

constructor TEnumFormatEtc.Create(FormatList: pFormatList;
            FormatCount, Index: Integer);
begin
  inherited Create;
  fFormatList := FormatList;
  fFormatCount := FormatCount;
  fIndex := Index;
end;
// -----------------------------------------------------------------------------

function TEnumFormatEtc.Next(Celt: LongInt;
  out Elt; pCeltFetched: pLongInt): HRESULT;
var
  i: Integer;
begin
  i := 0;
  WHILE (i < Celt) and (fIndex < fFormatCount) do
  begin
    TFormatList(Elt)[i] := fFormatList[fIndex];
    Inc(fIndex);
    Inc(i);
  end;
  if pCeltFetched <> NIL then pCeltFetched^ := i;
  if i = Celt then result := S_OK else result := S_FALSE;
end;
// -----------------------------------------------------------------------------

function TEnumFormatEtc.Skip(Celt: LongInt): HRESULT;
begin
  if Celt <= fFormatCount - fIndex then
  begin
    fIndex := fIndex + Celt;
    result := S_OK;
  end else
  begin
    fIndex := fFormatCount;
    result := S_FALSE;
  end;
end;
// -----------------------------------------------------------------------------

function TEnumFormatEtc.ReSet: HRESULT;
begin
  fIndex := 0;
  result := S_OK;
end;
// -----------------------------------------------------------------------------

function TEnumFormatEtc.Clone(out Enum: IS_IEnumFORMATETC): HRESULT;
begin
  enum := TEnumFormatEtc.Create(fFormatList, fFormatCount, fIndex);
  result := S_OK;
end;


// -----------------------------------------------------------------------------
//			TInterfacedComponent
// -----------------------------------------------------------------------------

function TInterfacedComponent.QueryInterface(const IID: TGuid; out Obj): HRESULT;
begin
  if GetInterface(IID, Obj) then result := 0 else result := E_NOINTERFACE;
end;
// -----------------------------------------------------------------------------

function TInterfacedComponent._AddRef: Integer;
begin
  result := InterlockedIncrement(fRefCount);
end;
// -----------------------------------------------------------------------------

function TInterfacedComponent._Release: Integer;
begin
  Result := InterlockedDecrement(fRefCount);
  if (Result = 0) then
    Free;
end;

// -----------------------------------------------------------------------------
//			TOLEDropSource
// -----------------------------------------------------------------------------

constructor TOLEDropSource.Create;//(aOwner : TComponent);
begin
  inherited Create(aOwner);
  DragTypes := [dtCopy]; //default to Copy.
  //to avoid premature release ...
  fDataFormatsCount := 0;
  fImageHotSpot := Point(16,16);
  fImages := nil;
  _AddRef;
  FWrapper := ToleObjectWrapper.Create(nil);
  AddFormatEtc(CF_TEXT, NIL, DVASPECT_CONTENT, -1, TYMED_HGLOBAL);
  AddFormatEtc(CF_BITMAP, NIL, DVASPECT_CONTENT, -1, TYMED_HGLOBAL);
  AddFormatEtc(CF_METAFILEPICT, NIL, DVASPECT_CONTENT, -1, TYMED_HGLOBAL);
  AddFormatEtc(CF_ENHMETAFILE, NIL, DVASPECT_CONTENT, -1, TYMED_HGLOBAL);
  AddFormatEtc(CF_HDROP, NIL, DVASPECT_CONTENT, -1, TYMED_HGLOBAL);
end;

destructor TOLEDropSource.Destroy;
begin
   if FWrapper <> nil then
     FWrapper.Free;
   inherited Destroy;
end;
// -----------------------------------------------------------------------------

function TOLEDropSource.DoGetData(const FormatEtcIn: TISFormatEtc;
  out Medium: TISStgMedium): HRESULT;
begin
    Result := FWrapper.GetInternalData(FormatEtcIn, Medium);
    if Result <> S_OK then //if data not loaded into dataObject
      OnOleSetData(Self, FormatEtcIn.cfFormat);
end;

function TOLEDropSource.OnOleSetData(Data : IS_IDataObject; Format : integer) : HRESULT;
begin
  Result := DV_E_FORMATETC;
  If Assigned(FOnSetData) then
    FOnSetData(Data, Format);
end;

procedure TOLEDropSource.ClearData;
begin
  FWrapper.ClearData;
end;

function TOLEDropSource.GiveFeedback(dwEffect: LongInt): HRESULT; stdcall;
var
  UseDefaultCursors: Boolean;
begin
  UseDefaultCursors := true;
  FeedbackEffect := dwEffect;
  if Assigned(OnFeedback) then
    OnFeedback(Self, dwEffect, UseDefaultCursors);
  if UseDefaultCursors then
    result := DRAGDROP_S_USEDEFAULTCURSORS
  else
    result := S_OK;
end;
// -----------------------------------------------------------------------------

function TOLEDropSource.GetCanonicalFormatEtc(const FormatEtc: TISFormatEtc;
         out FormatEtcout: TISFormatEtc): HRESULT;
begin
  result := DATA_S_SAMEFORMATETC;
end;
// -----------------------------------------------------------------------------

function TOLEDropSource.SetData(const FormatEtc: TISFormatEtc; var Medium: TISStgMedium;
         fRelease: Bool): HRESULT;
begin
  result := E_NOTIMPL;
end;
// -----------------------------------------------------------------------------

function TOLEDropSource.DAdvise(const FormatEtc: TISFormatEtc; advf: LongInt;
         const advSink: IS_IAdviseSink; out dwConnection: LongInt): HRESULT;
begin
  result := OLE_E_ADVISENOTSUPPORTED;
end;
// -----------------------------------------------------------------------------

function TOLEDropSource.DUnadvise(dwConnection: LongInt): HRESULT;
begin
  result := OLE_E_ADVISENOTSUPPORTED;
end;
// -----------------------------------------------------------------------------

function TOLEDropSource.EnumDAdvise(out EnumAdvise: IS_IEnumSTATDATA): HRESULT;
begin
  result := OLE_E_ADVISENOTSUPPORTED;
end;
// -----------------------------------------------------------------------------

function TOLEDropSource.GetData(const FormatEtcIn: TISFormatEtc;
  out Medium: TISStgMedium):HRESULT; stdcall;
begin
  result := DoGetData(FormatEtcIn, Medium);
end;
// -----------------------------------------------------------------------------

function TOLEDropSource.GetDataHere(const FormatEtc: TISFormatEtc;
  out Medium: TISStgMedium):HRESULT; stdcall;
begin
  result := E_NOTIMPL;
end;
// -----------------------------------------------------------------------------

function TOLEDropSource.QueryGetData(const FormatEtc: TISFormatEtc): HRESULT; stdcall;
var
  i: integer;
begin
  Result := DV_E_FORMATETC;
  for i := 0 to fDataFormatsCount-1 do
    with fDataFormats[i] do
      if (FormatEtc.cfFormat = cfFormat) and
         (FormatEtc.dwAspect = dwAspect) and
         (FormatEtc.tymed and tymed <> 0) then
      begin
          result:= S_OK;
          Break;
      end;

end;
// -----------------------------------------------------------------------------

function TOLEDropSource.EnumFormatEtc(dwDirection: LongInt;
  out EnumFormatEtc:IS_IEnumFORMATETC): HRESULT; stdcall;
begin
  if (dwDirection = DATADIR_GET) then
  begin
    EnumFormatEtc :=
      TEnumFormatEtc.Create(@fDataFormats, fDataFormatsCount, 0);
    result := S_OK;
  end
  else
  begin
    enumFormatEtc := nil;
    Result := E_NOTIMPL;
  end;

end;
// -----------------------------------------------------------------------------

function TOLEDropSource.QueryContinueDrag(fEscapePressed: bool;
  grfKeyState: LongInt): HRESULT; stdcall;
var
  ContinueDrop: Boolean;
  dragtype: TDragType;
begin
  if fEscapePressed then
    result := DRAGDROP_S_CANCEL
  // will now allow drag and drop with either mouse button.
  else if (grfKeyState and (MK_LBUTTON or MK_RBUTTON) = 0) then
  begin
    ContinueDrop := True;
    dragtype := dtCopy;
    if (FeedbackEffect and IS_DROPEFFECT_COPY <> 0) then DragType := dtCopy
    else if (FeedbackEffect and IS_DROPEFFECT_MOVE <> 0) then dragtype := dtMove
    else if (FeedbackEffect and IS_DROPEFFECT_LINK <> 0) then dragtype := dtLink
    else ContinueDrop := False;

    if not (DragType in dragtypes) then
       ContinueDrop := False;
    //if a valid drop then do OnDrop event if assigned...
    if ContinueDrop and Assigned(OnDrop) then
      OnDrop(Self, dragtype, ContinueDrop);

    if ContinueDrop then result := DRAGDROP_S_DROP
    else result := DRAGDROP_S_CANCEL;
  end else
    result := NOERROR;
end;

procedure TOLEDropSource.StartDrag(Data : IS_IDataObject; var AllowedEffects : Longint);
begin
  if assigned(FOnStartdrag) then
     FOnStartDrag(Data, AllowedEffects);
end;

procedure TOLEDropSource.CompleteDrag(Effect : Longint);
begin
  if assigned(FOnCompleteDrag) then
     FOnCompleteDrag(Effect);
end;

// -----------------------------------------------------------------------------
function TOLEDropSource.Execute(Window : Hwnd): TDragResult;
var
  res: HRESULT;
  okeffect, effect: longint;
  Pos : TPoint;
begin
  result := drUnknown;
  okeffect := IS_DROPEFFECT_NONE;
  if (dtCopy in fDragTypes) then okeffect := okeffect or IS_DROPEFFECT_COPY;
  if (dtMove in fDragTypes) then okeffect := okeffect or IS_DROPEFFECT_MOVE;
  if (dtLink in fDragTypes) then okeffect := okeffect or IS_DROPEFFECT_LINK;
  if fShowImage and (fImages <> nil) then
  begin
    GetCursorPos(Pos);
    ScreenToClient(Window, Pos);
    fImages.BeginDrag(Window, Pos.x, Pos.Y, fImageHotSpot.X, fImageHotSpot.Y);
  end;
  StartDrag(Self as IS_IDataObject, okeffect);

  res := DoDragDrop(Self as IS_IDataObject, Self as IS_IDropSource, okeffect, effect);

  CompleteDrag(Res);

  if Fimages.Dragging then
  begin
    Fimages.EndDrag;
  end;
  case res of
    DRAGDROP_S_DROP:
      begin
        if (okeffect and effect <> 0) then
        begin
          if (effect and IS_DROPEFFECT_COPY <> 0) then result := drDropCopy
          else if (effect and IS_DROPEFFECT_MOVE <> 0) then result := drDropMove
          else result := drDropLink;
        end else
          result := drCancel;
      end;
    DRAGDROP_S_CANCEL: result := drCancel;
    E_OUTOFMEMORY:     result := drOutMemory;
    else
       result := drUnspec;
  end;
end;
// -----------------------------------------------------------------------------

procedure TOLEDropSource.AddFormatEtc(cfFmt: TClipFormat;
  pt: PDVTargetDevice; dwAsp, lInd, tym: longint);
begin
  if fDataFormatsCount = MAXFORMATS then exit;
  fDataFormats[fDataFormatsCount].cfFormat := cfFmt;
  fDataFormats[fDataFormatsCount].ptd := pt;
  fDataFormats[fDataFormatsCount].dwAspect := dwAsp;
  fDataFormats[fDataFormatsCount].lIndex := lInd;
  fDataFormats[fDataFormatsCount].tymed := tym;
  inc(fDataFormatsCount);
end;
// -----------------------------------------------------------------------------

function TOLEDropSource.CutToClipboard: boolean;
begin
  //sets CF_PREFERREDDROPEFFECT...
  Result := InternalCutCopyToClipboard(IS_DROPEFFECT_MOVE);
end;
// -----------------------------------------------------------------------------

function TOLEDropSource.CopyToClipboard: boolean;
begin
  //sets CF_PREFERREDDROPEFFECT...
  Result := InternalCutCopyToClipboard(IS_DROPEFFECT_COPY);
end;
// -----------------------------------------------------------------------------

function TOLEDropSource.CutOrCopyToClipboard: boolean;
begin
  Result := False;
end;
// -----------------------------------------------------------------------------

//1. Renders the CF_PREFERREDDROPEFFECT clipboard dataobject.
//2. Encloses all calls to Clipboard.SetAsHandle() between Clipboard.Open and
//Clipboard.Close so multiple clipboard formats can be rendered in CutOrCopyToClipboard().
function TOLEDropSource.InternalCutCopyToClipboard(Effect: LongInt): boolean;
var
  FormatEtc: TISFormatEtc;
  Medium: TISStgMedium;
begin
  Clipboard.Open;
  try
    Result := CutOrCopyToClipboard;
    if not Result then exit;

    FeedbackEffect := Effect;
    FormatEtc.cfFormat := CF_PREFERREDDROPEFFECT;
    FormatEtc.dwAspect := DVASPECT_CONTENT;
    FormatEtc.tymed := TYMED_HGLOBAL;

    if GetData(FormatEtc, Medium) = S_OK then
    begin
      Clipboard.SetAsHandle(CF_PREFERREDDROPEFFECT, Medium.hGlobal);
    end else
      Result := False;
  finally
    Clipboard.Close;
  end;
end;
// -----------------------------------------------------------------------------

procedure TOLEDropSource.SetImages(const Value: TISDragImageList);
begin
  if fImages = Value then exit;
  fImages := Value;
//  if (csLoading in ComponentState) then exit;
  fImageIndex := 0;
  if (fImages <> nil) then
    fShowImage := true
  else
    fShowImage := False;
end;
// -----------------------------------------------------------------------------

procedure TOLEDropSource.SetImageIndex(const Value: integer);
begin
//  if (csLoading in ComponentState) then fImageIndex := Value
//  else
  if (Value < 0) or (FImages.Count = 0) or (FImages = nil) then
  begin
    fImageIndex := 0;
    fShowImage := False;
  end
  else if (Value < fImages.Count) then
    fImageIndex := Value;
end;
// -----------------------------------------------------------------------------

procedure TOLEDropSource.SetPoint(Index: integer; Value: integer);
begin
  if (Index = 1) then
    fImageHotSpot.x := Value
  else
    fImageHotSpot.y := Value;
end;
// -----------------------------------------------------------------------------

function TOLEDropSource.GetPoint(Index: integer): integer;
begin
  if (Index = 1) then
    Result := fImageHotSpot.x
  else
    Result := fImageHotSpot.y;
end;


// -----------------------------------------------------------------------------

procedure TOLEDropSource.SetShowImage(Value: boolean);
begin
  fShowImage := Value;
//  if (csLoading in ComponentState) then exit;
  if (fImages = nil) then
     fShowImage := False;
end;
// -----------------------------------------------------------------------------

// -----------------------------------------------------------------------------
//			TOLEDropTarget
// -----------------------------------------------------------------------------
procedure TOLEDropTarget.CreateWrapper(Data : IS_IDataObject);
begin
  if FWrapper <> nil then
     FWrapper.Free;
  FWrapper := ToleObjectWrapper.Create(Data);
end;

function TOLEDropTarget.DragEnter(const dataObj: IS_IDataObject; grfKeyState: Longint;
  pt: TPoint; var dwEffect: Longint): HRESULT;
var
  ShiftState: TShiftState;
//  TargetStyles: longint;
begin
  ClearData;
  fDataObj := dataObj;
  fDataObj._AddRef;
  result := S_OK;
  //Create Wrapper;
  CreateWrapper(FDataObj);

  pt := fTarget.ScreenToClient(pt);
  fLastPoint := pt;

  fDragImageHandle := 0;
  if ShowImage then
  begin
    fDragImageHandle := ImageList_GetDragImage(nil,@fImageHotSpot);
    if (fDragImageHandle <> 0) then
    begin
      //Currently we will just replace any 'embedded' cursor with our
      //blank (transparent) image otherwise we sometimes get 2 cursors ...
      ImageList_SetDragCursorImage(fImages.Handle,0,fImageHotSpot.x,fImageHotSpot.y);
      with ClientPtToWindowPt(fTarget.handle,pt) do
        ImageList_DragEnter(fTarget.handle,x,y);
    end;
  end;

  if not HasValidFormats then
  begin
    fDataObj := nil;
    dwEffect := IS_DROPEFFECT_NONE;
    ClearData;
    //result := E_FAIL;
    exit;
  end;

  //It's generally more efficient to get data only if a drop occurs
  //rather than on entering a potential target window.
  //However - sometimes there is a good reason to get it here.
  if fGetDataOnEnter then DoGetData;

  ShiftState := KeysToShiftState(grfKeyState);
  dwEffect := GetValidDropEffect(ShiftState,Pt,dwEffect);
  DoEnter(DataObj, ShiftState, pt, dwEffect);

end;
// -----------------------------------------------------------------------------

procedure TOLEDropTarget.DoEnter(Data : IS_IDataObject; ShiftState: TShiftState; Point: TPoint; var Effect: Longint);
begin
  if Assigned(fOnEnter) then
    fOnEnter(Self, Data, ShiftState, Point, Effect);
end;
// -----------------------------------------------------------------------------

function TOLEDropTarget.DragOver(grfKeyState: Longint;
  pt: TPoint; var dwEffect: Longint): HResult;
var
  ShiftState: TShiftState;
//  IsScrolling: boolean;
begin

  pt := fTarget.ScreenToClient(pt);

  if fDataObj = nil then
  begin
    //fDataObj = nil when no valid formats .... see DragEnter method.
    dwEffect := IS_DROPEFFECT_NONE;
    //IsScrolling := false;
  end else
  begin
    ShiftState := KeysToShiftState(grfKeyState);
    dwEffect := GetValidDropEffect(ShiftState, pt, dwEffect);
    DoDragOver(FDataObj, ShiftState, pt, dwEffect);
  end;

  if (fDragImageHandle <> 0) and
      ((fLastPoint.x <> pt.x) or (fLastPoint.y <> pt.y)) then
  begin
    fLastPoint := pt;
    with ClientPtToWindowPt(fTarget.handle,pt) do
     ImageList_DragMove(Pt.X, Pt.Y);
  end
  else
    fLastPoint := pt;
  RESULT := S_OK;
end;
// -----------------------------------------------------------------------------

procedure TOLEDropTarget.DoDragOver(Data : IS_IDataObject; ShiftState: TShiftState; Point: TPoint; var Effect: Longint);
begin
  if Assigned(fOnDragOver) then
    fOnDragOver(Self, Data, ShiftState, Point, Effect);
end;
// -----------------------------------------------------------------------------

function TOLEDropTarget.DragLeave: HResult;
begin
  ClearData;
  fDataObj := nil;

  if (fDragImageHandle <> 0) then
    ImageList_DragLeave(fTarget.handle);

  DoLeave;
  Result := S_OK;
end;
// -----------------------------------------------------------------------------

procedure TOLEDropTarget.DoLeave;
begin
  if Assigned(fOnLeave) then
     fOnLeave(Self);
end;
// -----------------------------------------------------------------------------

function TOLEDropTarget.Drop(const dataObj: IS_IDataObject; grfKeyState: Longint;
  pt: TPoint; var dwEffect: Longint): HResult;
var
  ShiftState: TShiftState;
begin
  RESULT := S_OK;

  if fDataObj = nil then
  begin
    dwEffect := IS_DROPEFFECT_NONE;
    exit;
  end;

//  fScrollTimer.enabled := false;

  if (fDragImageHandle <> 0) then
    ImageList_DragLeave(fTarget.handle);

  ShiftState := KeysToShiftState(grfKeyState);
  pt := fTarget.ScreenToClient(pt);
  dwEffect := GetValidDropEffect(ShiftState, pt, dwEffect);
  if (not fGetDataOnEnter) and (not DoGetData) then
    dwEffect := IS_DROPEFFECT_NONE
  else
    DoDrop(FdataObj, ShiftState, pt, dwEffect);

  // clean up!
  ClearData;
  fDataObj := nil;
end;
// -----------------------------------------------------------------------------

procedure TOLEDropTarget.DoDrop(Data : IS_IDataObject; ShiftState: TShiftState; Point: TPoint; var Effect: Longint);
begin
  if Assigned(fOnDrop) then
    fOnDrop(Self, Data, ShiftState, Point, Effect);
end;
// -----------------------------------------------------------------------------
constructor TOLEDropTarget.Create;//(AOwner: TComponent);
var
  bm: TBitmap;
begin
   inherited Create(AOwner);
   fGetDataOnEnter := false;
   fImages := TISDragImageList.create(nil);
   fDragTypes := [dtCopy, dtMove, dtLink];
   //Create a blank image for fImages which we...
   //will use to hide any cursor 'embedded' in a drag image.
   //This avoids the possibility of two cursors showing.
   bm := TBitmap.Create;
   with bm do
   begin
     height := 32;
     width := 32;
     Canvas.Brush.Color:=clWindow;
     Canvas.FillRect(Rect(0,0,31,31));
     fImages.AddMasked(bm,clWindow);
     free;
   end;

   fDataObj := nil;
   ShowImage := true;
   _AddRef;
end;
// -----------------------------------------------------------------------------

destructor TOLEDropTarget.Destroy;
begin
  if fImages <> nil then
    fImages.free;

  if FWrapper <> nil then
     FWrapper.Free;

  Unregister;
  inherited Destroy;
end;
// -----------------------------------------------------------------------------

procedure TOLEDropTarget.Register(Target: TWinControl);
begin
  if fTarget = Target then exit;
  if (fTarget <> nil) then Unregister;
  fTarget := target;
  if fTarget = nil then exit;

  if not RegisterDragDrop(fTarget.handle,self) = S_OK then
      raise Exception.create('Failed to Register '+ fTarget.name);
  fRegistered := true;
end;

// -----------------------------------------------------------------------------
procedure TOLEDropTarget.Unregister;
begin
  fRegistered := false;
  if (fTarget = nil) then exit;            // CEDR 05.10.02
  if fTarget.handleallocated then
    if not RevokeDragDrop(fTarget.handle) = S_OK then
      raise Exception.create('Failed to Unregister '+ fTarget.name);

  fTarget := nil;
end;

// -----------------------------------------------------------------------------
procedure TOLEDropTarget.SetShowImage(Show: boolean);
begin
  fShowImage := Show;
  if fDataObj <> nil then
    ImageList_DragShowNolock(fShowImage);
end;
// -----------------------------------------------------------------------------

function TOLEDropTarget.GetValidDropEffect(ShiftState: TShiftState;
  pt: TPoint; dwEffect: LongInt): LongInt;
begin
  //dwEffect 'in' parameter = set of drop effects allowed by drop source.
  //Now filter out the effects disallowed by target...
  if not (dtCopy in fDragTypes) then
    dwEffect := dwEffect and not IS_DROPEFFECT_COPY;
  if not (dtMove in fDragTypes) then
    dwEffect := dwEffect and not IS_DROPEFFECT_MOVE;
  if not (dtLink in fDragTypes) then
    dwEffect := dwEffect and not IS_DROPEFFECT_LINK;
  Result := dwEffect;

  //'Default' behaviour can be overriden by assigning OnGetDropEffect.
  if Assigned(fGetDropEffectEvent) then
    fGetDropEffectEvent(self, ShiftState, pt, Result)
  else
  begin
    //As we're only interested in ssShift & ssCtrl here
    //mouse buttons states are screened out ...
    ShiftState := ([ssShift, ssCtrl] * ShiftState);

    if (ShiftState = [ssShift, ssCtrl]) and
      (dwEffect and IS_DROPEFFECT_LINK <> 0) then result := IS_DROPEFFECT_LINK
    else if (ShiftState = [ssShift]) and
      (dwEffect and IS_DROPEFFECT_MOVE <> 0) then result := IS_DROPEFFECT_MOVE
    else if (dwEffect and IS_DROPEFFECT_COPY <> 0) then result := IS_DROPEFFECT_COPY
    else if (dwEffect and IS_DROPEFFECT_MOVE <> 0) then result := IS_DROPEFFECT_MOVE
    else if (dwEffect and IS_DROPEFFECT_LINK <> 0) then result := IS_DROPEFFECT_LINK
    else result := IS_DROPEFFECT_NONE;
  end;
end;




function TOLEDropTarget.HasValidFormats: boolean;
begin
  Result := (fDataObj.QueryGetData(TexTISFormatEtc) = S_OK);
  if not Result then //
    Result := (fDataObj.QueryGetData(HDropFormatEtc) = S_OK);
end;
// -----------------------------------------------------------------------------

procedure TOLEDropTarget.ClearData;
begin
if FWrapper <> nil then
   FWrapper.Free;
   FWrapper := nil;
end;
// -----------------------------------------------------------------------------

function TOLEDropTarget.DoGetData: boolean;
begin
  result := false;
  if (FWrapper <> nil) then
  begin
     if (fDataObj.QueryGetData(TexTISFormatEtc) = S_OK) then
       Result := FWrapper.GetString <> ''
     else if (fDataObj.QueryGetData(HDropFormatEtc) = S_OK) then
       Result := (FWrapper.GetFileList <> nil);

  end;
end;

// -----------------------------------------------------------------------------
function TOLEDropTarget.PasteFromClipboard: longint;
var
  Global: HGlobal;
  TextPtr: pChar;
begin
  result := IS_DROPEFFECT_NONE;
  if not ClipBoard.HasFormat(CF_TEXT) then exit;
  Global := Clipboard.GetAsHandle(CF_TEXT);
  TextPtr := GlobalLock(Global);
  if (FWrapper <> nil) then
      FWrapper.SetString(TextPtr);
  GlobalUnlock(Global);
  result := IS_DROPEFFECT_COPY;
end;
// -----------------------------------------------------------------------------

{ TISDragImageList }

function ClientToWindow(Handle: HWND; X, Y: Integer): TPoint;
var
  Rect: TRect;
  Point: TPoint;
begin
  Point.X := X;
  Point.Y := Y;
  ClientToScreen(Handle, Point);
  GetWindowRect(Handle, Rect);
  Result.X := Point.X - Rect.Left;
  Result.Y := Point.Y - Rect.Top;
end;

procedure TISDragImageList.Initialize;
begin
  inherited Initialize;
  DragCursor := crNone;
end;

procedure TISDragImageList.CombineDragCursor;
var
  TempList: HImageList;
  Point: TPoint;
begin
  if DragCursor <> crNone then
  begin
    TempList := ImageList_Create(GetSystemMetrics(SM_CXCURSOR),
      GetSystemMetrics(SM_CYCURSOR), ILC_MASK, 1, 1);
    try
      ImageList_AddIcon(TempList, Screen.Cursors[DragCursor]);
      ImageList_AddIcon(TempList, Screen.Cursors[DragCursor]);
      ImageList_SetDragCursorImage(TempList, 0, 0, 0);
      ImageList_GetDragImage(nil, @Point);
      ImageList_SetDragCursorImage(TempList, 1, Point.X, Point.Y);
    finally
      ImageList_Destroy(TempList);
    end;
  end;
end;

function TISDragImageList.SetDragImage(Index, HotSpotX, HotSpotY: Integer): Boolean;
begin
  if HandleAllocated then
  begin
    FDragIndex := Index;
    FDragHotspot.x := HotSpotX;
    FDragHotspot.y := HotSpotY;
    ImageList_BeginDrag(Handle, Index, HotSpotX, HotSpotY);
    Result := True;
    FDragging := Result;
  end
  else Result := False;
end;

procedure TISDragImageList.SetDragCursor(Value: TCursor);
begin
  if Value <> DragCursor then
  begin
    FDragCursor := Value;
    if Dragging then CombineDragCursor;
  end;
end;

function TISDragImageList.GetHotSpot: TPoint;
begin
  Result := inherited GetHotSpot;
  if HandleAllocated and Dragging then
    ImageList_GetDragImage(nil, @Result);
end;

function TISDragImageList.BeginDrag(Window: HWND; X, Y, HSX, HSY: Integer): Boolean;
begin
  Result := False;
  if HandleAllocated then
  begin
    if not Dragging then
       SetDragImage(FDragIndex, HSX, HSY);//FDragHotspot.x, FDragHotspot.Y);
    CombineDragCursor;
    Result := DragLock(Window, X, Y);
    //if Result then ShowCursor(False);
  end;
end;

function TISDragImageList.DragLock(Window: HWND; XPos, YPos: Integer): Boolean;
begin
  Result := False;
  if HandleAllocated and (Window <> FDragHandle) then
  begin
    DragUnlock;
    FDragHandle := Window;
    with ClientToWindow(FDragHandle, XPos, YPos) do
      Result := ImageList_DragEnter(FDragHandle, X, Y);
  end;
end;

procedure TISDragImageList.DragUnlock;
begin
  if HandleAllocated and (FDragHandle <> 0) then
  begin
    ImageList_DragLeave(FDragHandle);
    FDragHandle := 0;
  end;
end;

function TISDragImageList.DragMove(X, Y: Integer): Boolean;
begin
  if HandleAllocated then
    with ClientToWindow(FDragHandle, X, Y) do
      Result := ImageList_DragMove(X, Y)
  else
    Result := False;
end;

procedure TISDragImageList.ShowDragImage;
begin
  if HandleAllocated then
    ImageList_DragShowNoLock(True);
end;

procedure TISDragImageList.HideDragImage;
begin
  if HandleAllocated then
    ImageList_DragShowNoLock(False);
end;

function TISDragImageList.EndDrag: Boolean;
begin
  if HandleAllocated and Dragging then
  begin
    DragUnlock;
    Result := ImageList_EndDrag;
    FDragging := False;
    DragCursor := crNone;
//    ShowCursor(True);
  end
  else Result := False;
end;

{ TOleObjectWrapper }

constructor TOleObjectWrapper.Create(Data: IS_IDataObject);
begin
   inherited Create;
   dataObj := Data;
end;

destructor TOleObjectWrapper.Destroy;
begin
  ClearData;
  inherited Destroy;
end;

function TOleObjectWrapper.DataObject: IS_IDataObject;
begin
   Result := DataObj;
end;

procedure TOleObjectWrapper.ClearData;
begin
   if FMetafile <> nil then
      FMetafile.Free;
   FMetafile := nil;

   if FBitmap <> nil then
      FBitmap.Free;
   FBitmap := nil;

   if FList <> nil then
      Flist.Free;
   Flist := nil;

   FString :='';
end;
procedure TOleObjectWrapper.SetMetafile(Value : TMetafile);
begin
   ClearData;
   FMetafile := TMetafile.Create;
   FMetafile.Assign(Value);
end;

procedure TOleObjectWrapper.SetBitmap(Value : TBitmap);
begin
   ClearData;
   FBitmap := TBitmap.Create;
   FBitmap.Assign(Value);
end;

Procedure TOleObjectWrapper.SetString(Value : String);
begin
   ClearData;
   FString := Value;
end;


procedure TOleObjectWrapper.SetData(Value : OleVariant; Format : integer);
var Pict : TPicture;
    aIPict : IPictureDisp;
begin
   if (Format = CF_TEXT) then
      SetString(Value)
   else if HasDataFormat(CF_METAFILEPICT) or HasDataFormat(CF_ENHMETAFILE) or
        HasDataFormat(CF_BITMAP) then
   begin
     Pict := TPicture.Create;
     if HasDataFormat(CF_METAFILEPICT) or HasDataFormat(CF_ENHMETAFILE) then
     begin
      aIPict := IUnknown(Value) as IPictureDisp;
      SetOlePicture(Pict, aIPict);
      if HasDataFormat(CF_METAFILEPICT) or HasDataFormat(CF_ENHMETAFILE) then
         SetMetafile(Pict.Metafile)
      else
         SetBitmap(Pict.Bitmap)
     end;
   end;
end;


function TOleObjectWrapper.GetData(Format : integer) : OleVariant;
var Pict : TPicture;
    aIPict : IPictureDisp;
begin
   // check up format
   if HasDataFormat(Format) then exit;

   Case Format of
     CF_HDROP: Result := GetFileList.StringsAdapter;
     CF_TEXT:  Result := GetString;
     CF_METAFILEPICT,CF_ENHMETAFILE,CF_BITMAP:
     begin
       Pict := TPicture.Create;
       if (Format = CF_METAFILEPICT) or (Format = CF_ENHMETAFILE) then
        Pict.Metafile := GetMetafile
       else
        Pict.Bitmap := GetBitmap;

       GetOlePicture(Pict, aIPict);
       Result := aIPict;
     end;
   end;
end;

function TOleObjectWrapper.GetInternalData(const FormatEtcIn: TISFormatEtc;
  out Medium: TISStgMedium ) : HRESULT;
var aDataHandle : THandle;
    pText : PChar;
    aFiles : string;
    pDrop: PDropFiles;
    Format : Word;
    Palette : HPalette;
    i : integer;
    aFList : TStringList;
begin
  medium.tymed := 0;
  medium.hGlobal := 0;
  medium.unkForRelease := nil;
  Result := DV_E_FORMATETC;
  Case FormatEtcIn.cfFormat of
    CF_TEXT:
    begin
      Medium.tymed := TYMED_HGLOBAL;
      Medium.hGlobal := GlobalAlloc(GMEM_SHARE or GMEM_ZEROINIT, Length(FString));
      if (Medium.hGlobal = 0) then
      begin
        result := E_OUTOFMEMORY;
        Exit;
      end;
      pText := PChar(GlobalLock(Medium.hGlobal));
      try
        StrCopy(pText, PChar(FString));
      finally
        GlobalUnlock(Medium.hGlobal);
      end;
      result := S_OK;
    end;
    CF_HDROP:
    if Stringdata <> '' then
    begin
     Medium.UnkForRelease := nil;
     Medium.Tymed := TYMED_HGlobal;
     Format := FormatEtcIn.cfFormat;
     aFList := TStringList.Create;
     aFList.Text := StringData;
     try
      aFiles := '';
      if aFList.Count > 0  then
      begin
        for I := 0 to aFList.Count - 1 do aFiles := aFiles + aFList[i] + #0;
        aFiles := aFiles + #0;
        Medium.hGlobal := GlobalAlloc(GMEM_MOVEABLE or GMEM_DDESHARE, Length(aFiles) + 20);
        pDrop := GlobalLock(Medium.hGlobal);
        try
          pDrop^.pFiles := 20;
          pdrop^.fWide := False;
          pText := Pointer(pDrop);
          Inc(pText, pDrop^.pFiles);
          for I := 1 to Length(aFiles) do
          begin
           pText^ := aFiles[I];
           Inc(pText);
          end;
        finally
          GlobalUnLock(Medium.hGlobal);
        end;
        Result := S_OK;
      end
      else
        Medium.hGlobal := 0;
     finally
       aFList.Free;
     end;
      //Result := DV_E_FORMATETC;
    end;
    CF_BITMAP:
    if FBitmap <> nil then
    begin
      Medium.tymed := TYMED_GDI;
      Format := FormatEtcIn.cfFormat;
      Palette :=0;
      FBitmap.SaveToClipboardFormat(Format, aDataHandle, Palette);
      Medium.hBitmap := aDataHandle;
      Medium.UnkForRelease := nil;
      result := S_OK;
    end
    else Result := DV_E_FORMATETC;

    CF_METAFILEPICT, CF_ENHMETAFILE:
    if FMetafile <> nil then
    begin
      Medium.tymed := TYMED_GDI;
      Format := FormatEtcIn.cfFormat;
      Palette :=0;
      FBitmap.SaveToClipboardFormat(Format, aDataHandle, Palette);
      Medium.hBitmap := aDataHandle;
      Medium.UnkForRelease := nil;
      result := S_OK;
    end
//    else Result := DV_E_FORMATETC;


//  else
//
  end;
end;

function TOleObjectWrapper.GetMetafile: TMetafile;
var
  mdm : TISStgMedium;
  fmt : TISFormatEtc;
  Data : THandle;
  Palette : HPALETTE;
  EnumFormatEtc : IS_IEnumFORMATETC;
begin
  Result := nil;
  if (not assigned(DataObj)) Or (not HasDataFormat(CF_ENHMETAFILE)) or (not HasDataFormat(CF_METAFILEPICT)) then exit;
  if dataObj.EnumFormatEtc(DATADIR_GET, EnumFormatEtc) <> S_OK then exit;

  if Fmetafile <> nil then
  begin
     Result := FMetafile;
     exit;
  end;
  Fmetafile := TMetafile.Create;
  EnumFormatEtc.Reset;
  while EnumFormatEtc.Next(1, fmt, nil) = S_OK do
  begin
    if (fmt.cfFormat = CF_METAFILEPICT) or (fmt.cfFormat = CF_ENHMETAFILE) then
    begin
      try
        if (DataObj.GetData(fmt, mdm) <> S_OK) or (mdm.tymed <> TYMED_GDI) then
        begin
          Fmetafile.Free;
          Fmetafile := nil;
          exit;
        end;
        Data := mdm.hBitmap;
      finally
        if Assigned(mdm.unkForRelease) then
          Iunknown(mdm.unkForRelease)._Release;
      end;
      if mdm.tymed <> TYMED_GDI then
      begin
        Fmetafile.Free;
        Fmetafile := nil;
        exit;
      end;
      EnumFormatEtc.Reset;
      Palette := 0;
      fillchar(fmt, sizeof(fmt), 0);
      try
        FMetafile.LoadFromClipboardFormat(fmt.cfFormat, Data, Palette);
        result := FMetafile;
      except
        on E : Exception do ;
      end;
      exit;
    end;
  end;
end;

function TOleObjectWrapper.GetBitmap: TBitmap;
var
  mdm : TISStgMedium;
  fmt : TISFormatEtc;
  Data : THandle;
  Palette : HPALETTE;
  EnumFormatEtc : IS_IEnumFORMATETC;
begin
  Result := nil;
  if (not assigned(DataObj)) or (not HasDataFormat(CF_BITMAP)) then exit;
  if dataObj.EnumFormatEtc(DATADIR_GET, EnumFormatEtc) <> S_OK then exit;

  if FBitmap <> nil then
  begin
     Result := FBitmap;
     exit;
  end;

  FBitmap := TBitmap.Create;
  EnumFormatEtc.Reset;
  while EnumFormatEtc.Next(1, fmt, nil) = S_OK do
  begin
    if (fmt.cfFormat = CF_BITMAP) then
    begin
      try
        if (DataObj.GetData(fmt, mdm) <> S_OK) or (mdm.tymed <> TYMED_GDI) then
        begin
          FBitmap.Free;
          FBitmap := nil;
          exit;
        end;
        Data := mdm.hBitmap;
      finally
        if Assigned(mdm.unkForRelease) then
          Iunknown(mdm.unkForRelease)._Release;
      end;
      if mdm.tymed <> TYMED_GDI then
      begin
        FBitmap.Free;
        FBitmap := nil;
        exit;
      end;
      EnumFormatEtc.Reset;
      Palette := 0;
      fillchar(fmt, sizeof(fmt), 0);
      try
        FBitmap.LoadFromClipboardFormat(CF_BITMAP, Data, Palette);
        result := FBitmap;
      except
        on E : Exception do ;
      end;
      exit;
    end;
  end;
end;


function TOleObjectWrapper.GetFileList: TStringList;
var
  mdm : TISStgMedium;
  pz : pchar;
  pdf : PDropFiles;
  fmt : TISFormatEtc;
  s : string;

  function PWideCharLen( aPWideChar : PWideChar ) : integer;
  begin
    Result := 0;
    while aPWideChar[result] <> #0 do
      Inc(result);
  end;

begin
  Result := nil;
  if (not assigned(DataObj)) or (not HasDataFormat(CF_HDROP)) then exit;

  if FList <> nil then
  begin
    Result := FList;
    exit;
  end;

  FList := TStringList.Create;// create dinamcally
  Result := FList;
  FList.Clear;
  FillChar(fmt, sizeof(fmt), 0);
  fmt.cfFormat := CF_HDROP;
  fmt.tymed := TYMED_HGLOBAL;
  fmt.lindex := -1;
  if dataobj.GetData(fmt, mdm) <> S_OK then
  begin
    Result := nil;
    raise Exception.Create('IDataObject.GetData failed');
  end;
  try
    if mdm.tymed = TYMED_HGLOBAL then
    begin
      pdf := GlobalLock(mdm.HGlobal);
      pz := pchar(pdf);
      Inc(pz, pdf^.pFiles);
      if not (pdf.fWide) then
        while (pz[0] <> #0) do
        begin
          FList.Add(string(pz));
          Inc(pz, 1 + strlen(pz));
        end
      else
        while (pz[0] <> #0) do
        begin
          s := WideCharToString(PWideChar(pz));
          FList.Add(s);
          Inc(pz,PWideCharLen(PWideChar(pz))*2+2);
        end;
      GlobalUnlock(mdm.HGlobal);
    end;
  finally
    if Assigned(mdm.unkForRelease) then
      IUnknown(mdm.unkForRelease)._Release;
  end;
end;

function TOleObjectWrapper.GetString: string;
var
  mdm : TISStgMedium;
  pz : pchar;
  fmt : TISFormatEtc;
  efe : IS_IEnumFORMATETC;
  fmtCount : LongInt;
begin
  if FString <> '' then
  begin
    Result := FString;
    exit;
  end;

  if (not assigned(DataObj)) or (not HasDataFormat(CF_TEXT)) then
    exit;
  fillchar(fmt, sizeof(fmt), 0);
  DataObj.EnumFormatEtc(datadir_get, efe);
  efe.Reset;
  repeat
    fmtCount := 0;
    efe.Next(1, fmt, @fmtCount);
  until (fmt.cfFormat = CF_TEXT) or (fmtCount = 0);

  if (fmt.cfFormat <> CF_TEXT) then
  begin
    FString := '';
    result := FString;
    exit;
  end;
  fmt.tymed := TYMED_HGLOBAL;
  fmt.lindex := -1;
  if dataobj.GetData(fmt, mdm) <> S_OK then
  begin
    FString := '';
    result := FString;
  end
  else
  try
    if (fmt.cfFormat = CF_TEXT)  and (mdm.tymed = TYMED_HGLOBAL) then
    begin
      pz := GlobalLock(mdm.HGlobal);
      //FString := StrPas(pz);
      StrLCopy(Pchar(FString), pz, Strlen(pz)+1);
      Result := FString;
      GlobalUnlock(mdm.HGlobal);
    end;
  finally
    if Assigned(mdm.unkForRelease) then
      Iunknown(mdm.unkForRelease)._Release;
  end;
end;

function TOleObjectWrapper.HasDataFormat(Format: integer): boolean;
var
  fmt : TISFormatEtc;
  efe : IS_IEnumFORMATETC;
  fmtCount : LongInt;
begin
  if not assigned(Dataobj) then
  begin
    Result := False;
    exit;
  end;
  fillchar(fmt, sizeof(fmt), 0);
  DataObj.EnumFormatEtc(datadir_get, efe);
  efe.Reset;
  repeat
    fmtCount := 0;
    if efe.Next(1, fmt, @fmtCount) <> S_OK then
       break;
  until (fmt.cfFormat = Format) or (fmtCount = 0);

  Result := (fmt.cfFormat = Format);
end;


initialization
  OleInitialize(NIL);
    CF_PREFERREDDROPEFFECT := RegisterClipboardFormat('Preferred DropEffect');
{ CF_FILECONTENTS := RegisterClipboardFormat(CFSTR_FILECONTENTS);
  CF_FILEGROUPDESCRIPTOR := RegisterClipboardFormat(CFSTR_FILEDESCRIPTOR);
  CF_IDLIST := RegisterClipboardFormat(CFSTR_SHELLIDLIST);
  CF_URL := RegisterClipboardFormat('UniformResourceLocator');
  CF_FILENAMEMAP := RegisterClipboardFormat(CFSTR_FILENAMEMAPA);
  CF_FILENAMEMAPW := RegisterClipboardFormat(CFSTR_FILENAMEMAPW);
}
//  ShGetMalloc(ShellMalloc);
finalization
  OleUninitialize;

end.
