unit PropertiesTreeCust;

interface

uses
 PropTree, Windows, Messages, SysUtils, Classes, Graphics, ExtCtrls,Controls, Forms, Dialogs,
  exgrid, finplace, RapTree, Flytree, RtProps, TypInfo {$IFDEF DFS_DELPHI_5_UP},Menus,Contnrs{$ENDIF};

type
  TPropertiesTreeCust = class(TPropertiesTree)
  private
    { Private declarations }
    ProtectedStringList : TStringList;
  protected
    { Protected declarations }
  procedure AddPropertiesFromList(aList : Tlist; Node : TFlyNode); override;
  public
    { Public declarations }
  constructor Create(AOwner: TComponent); override;
  published
    { Published declarations }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('9Rays.Net', [TPropertiesTreeCust]);
end;

{ TPropertiesTreeCust }

procedure TPropertiesTreeCust.AddPropertiesFromList(aList: Tlist;
  Node: TFlyNode);
var
  PropName, PrevPropName : String;
  i : integer;
  aNode : TFlyNode;
  listindex : integer;
begin
  PropName :='';
  PrevPropName :='';
  listindex := -1;
   for i:=0 to aList.Count-1 do
   begin
    try
     PropName := TRTPropertyEditor(aList[i]).GetName;
     if (PropName <> PrevPropName) and (not ProtectedStringList.Find(PropName, listindex)) then
     begin
       aNode:=Items.AddChildObject(Node, PropName, aList[i]);
       if TRTPropertyEditor(aList[i]).GetAttributes * [rtSubProperties] <> [] then
       begin
         AddSubproperties(aNode,TRTPropertyEditor(aList[i]));
       end;
     end;
    except
       ShowMessage('Error on '+PropName);
    end;
     PrevPropName := PropName;
  end;
end;

constructor TPropertiesTreeCust.Create(AOwner: TComponent);
begin
  ProtectedStringList := TStringList.Create;
  ProtectedStringList.Add('Name');
  ProtectedStringList.Add('Tag');
  inherited;
end;

end.
