unit flyedit;

interface
{$I DFS.inc}
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, TreeColl,Typinfo, ExtCtrls, RapTree, exgrid, Menus;

type
  TModifiedProc = procedure of object;
  
  TFlyEditor = class(TForm)
    Panel1: TPanel;
    Add: TButton;
    Button2: TButton;
    Button1: TButton;
    ImageText: TEdit;
    SelectedText: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Closebtn: TButton;
    CancelBtn: TButton;
    Button4: TButton;
    Button5: TButton;
    ApplyBtn: TButton;
    MoveUpBtn: TButton;
    MovedownBtn: TButton;
    DeptsTree: TRapidTree;
    Button3: TButton;
    Button6: TButton;
    StateText: TComboBox;
    Button7: TButton;
    Button8: TButton;
    Aligns: TRadioGroup;
    PopupMenu1: TPopupMenu;
    EnumerateImageIndexes1: TMenuItem;
    EnumerateSelectedIndexes1: TMenuItem;
    EnumerateBoth1: TMenuItem;
    Label4: TLabel;
    Label5: TLabel;
    procedure ApplyBtnClick(Sender: TObject);
    //procedure AssignNodesToTree(aTree : TCustomRapidTree);
    //procedure AssignTreeToNodes(aTree : TCustomRapidTree);
    procedure ImageTextKeyPress(Sender: TObject; var Key: Char);
    procedure SelectedTextChange(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure AddClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure DeptsTreeKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MoveUpBtnClick(Sender: TObject);
    procedure MovedownBtnClick(Sender: TObject);
    procedure DeptsTreeEdited(Sender: TObject; Node: TFlyNode;
      var S: String);
    //procedure DeptsTreeSelectCell(Sender: TObject; ACol, ARow: Integer;
    //  var CanSelect: Boolean);
    procedure Button3Click(Sender: TObject);
    procedure DeptsTreeSelectCell(Sender: TObject; ACol, ARow: Longint;
      var CanSelect: Boolean);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure DeptsTreeColumnMoved(Sender: TObject; FromIndex,
      ToIndex: Integer);
    procedure DeptsTreeColumnWidthChanged(Index, Value: Integer);
    procedure AlignsClick(Sender: TObject);
    procedure ImageIndex1Click(Sender: TObject);
    procedure EnumerateSelectedIndexes1Click(Sender: TObject);
    procedure EnumerateBoth1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    ModifiedProc : TModifiedProc;
    FEditChange : boolean; //flag for changing from editors to tree
    aNodes : TFlyNodes;
    //FDefaultImageindex,FDefaultSelectedindex,FDefaultStateindex : integer;//default values for adding
    EnableModified, Fmodified : Boolean;

    procedure SetModified(Value : Boolean);
    procedure EnumerateNodes(aImageIndex, aSelectedIndex : Boolean);
  public
    { Public declarations }
    property Modified : boolean read Fmodified write SetModified;
  end;

  function EditNodes(aNodes : TFlyNodes; aModifiedProc : TModifiedProc) : boolean;
  function EditSectionNodes(aNodes : TFlyNodes; aColCount, aStructureCol : integer; var Widths, Alignments : TStringList; aModifiedProc : TModifiedProc) : boolean;

var
  FlyEditor: TFlyEditor;
  FColCount, FStructureCol : integer;
  UseColInfo : Boolean;
  FWidths : TStringList;
  FAlignments : TStringList;

implementation
uses isconst;
{$R *.DFM}

  function EditSectionNodes(aNodes : TFlyNodes; aColCount, aStructureCol : integer; var Widths, Alignments : TStringList; aModifiedProc : TModifiedProc) : boolean;
  begin
     FColCount:= aColCount;
     FStructureCol := aStructureCol;
     UseColInfo := True;
     FAlignments := Alignments;
     FWidths := Widths;
     Result := EditNodes(aNodes, aModifiedProc);
     FAlignments :=nil;
     FWidths := nil;
  end;

  type CrackRTree = Class(TCustomRapidTree);

  function EditNodes(aNodes: TFlyNodes; aModifiedProc : TModifiedProc) : boolean;
  var aFlyEdit : TFlyEditor;
      I : integer;
  begin
    aFlyEdit := TFlyEditor.Create(Application);
    try
      aFlyEdit.ModifiedProc := aModifiedProc;
      aFlyEdit.aNodes := aNodes;
      //usi - unique tags support 
      if aNodes.Tree <> nil then
         aFlyEdit.DeptsTree.UniqueTags := aNodes.Tree.UniqueTags;

      aFlyEdit.DeptsTree.Items.Assign(aNodes);
      if aFlyEdit.DeptsTree.items.count>0 then
         aFlyEdit.DeptsTree.Row:=0;

      aFlyEdit.Modified := false;
      aFlyEdit.DeptsTree.FullExpand;
      // Tree Setup
      if aNodes.Tree <> nil then
      with aNodes.Tree, aFlyEdit do
      begin
         DeptsTree.ColCount := ColCount;
         DeptsTree.FixedCols := FixedCols;
         DeptsTree.FixedRows := FixedRows;
         DeptsTree.StructureCol := StructureCol;
         DeptsTree.Options := DeptsTree.Options + [goColMoving, goColSizing, gofixedVertLine, govertLine];
         for i := 0 to ColCount-1 do
          DeptsTree.ColWidths[i] := ColWidths[i];
         CrackRTree(DeptsTree).InitColumnsMap;
      end;
      if UsecolInfo then
      with aFlyEdit.DeptsTree do
      begin
         aFlyEdit.Aligns.Visible :=True;
         ColCount := FColCount;
         StructureCol := FStructureCol;
         Options := Options + [goColMoving, goColSizing, gofixedVertLine, govertLine];
         for i := 0 to ColCount-1 do
          ColWidths[i] := strToInt(FWidths[i]);
         CrackRTree(aFlyEdit.DeptsTree).InitColumnsMap;
      end;

      if (aFlyEdit.Showmodal = mrOk) then
      begin
        if aFlyEdit.ApplyBtn.enabled then
           aNodes.Assign(aFlyEdit.DeptsTree.Items);
        Result := aFlyEdit.Modified;
      end
      else Result := false;

    finally
      aFlyEdit.Free;
    end;
  end;


procedure TFlyEditor.SetModified(Value : Boolean);
begin
 if EnableModified then
 begin
   ApplyBtn.enabled:=Value;
   if Value then
   begin
      if Assigned(ModifiedProc) then
         ModifiedProc;
      FModified:=Value;
   end;
 end;
end;

procedure TFlyEditor.ApplyBtnClick(Sender: TObject);
begin
    //aNodes.AssignTreeNodesToFlyNodes(DeptsTree);
    if aNodes.Tree<>nil then
       aNodes.Tree.StructureCol := DeptsTree.StructureCol;

    aNodes.Assign(DeptsTree.Items);

    if aNodes.Tree<>nil then
    Modified:=false;
    CancelBtn.Enabled:=false;
    ApplyBtn.Enabled:=false;
end;

procedure TFlyEditor.ImageTextKeyPress(Sender: TObject; var Key: Char);
begin
    if not (Key in  [#8,'0'..'9','-']) then Key:=#0;
    ApplyBtn.Enabled:=true;
end;

procedure TFlyEditor.SelectedTextChange(Sender: TObject);
var aNode : TFlyNode;
    function isInteger(Text : String) : Boolean;
    begin
       Result := False;
       try
         strToInt(Text);
         Result := True;
       except
       end;
    end;
begin
  if (FEditChange) then
      Exit;
   aNode := DeptsTree.items.GetFirstNode;
   while aNode <> nil do
   begin
    if aNode.Selected then
    with aNode do
    begin
      FEditChange :=True;
      if isInteger(ImageText.Text) then Imageindex := strtoint(ImageText.Text) else Imageindex :=0;
      if isInteger(SelectedText.Text) then Selectedindex := strtoint(SelectedText.Text) else Selectedindex :=0;
      //if isInteger(StateText.Text) then
      Stateindex := StateText.ItemIndex;// else Stateindex :=0;

      FEditChange :=false;
      Modified:=true;
    end;
    aNode := aNode.GetNext;
   end;

end;

procedure TFlyEditor.Button5Click(Sender: TObject);
begin
  //set default values
  with DeptsTree.Items do
  begin
    if ImageText.Text<>'' then DefaultImageindex := StrToint(ImageText.Text) else DefaultImageindex :=0;
    if SelectedText.Text<>'' then DefaultSelectedindex := StrToint(SelectedText.Text) else DefaultSelectedindex :=0;
    if StateText.Text<>'' then DefaultStateindex := StateText.ItemIndex;//StrToint(StateText.Text) else DefaultStateindex :=0;
  end;
end;

procedure TFlyEditor.AddClick(Sender: TObject);
var aNode : TFlyNode;
begin
     aNode := DeptsTree.items.Add(DeptsTree.Selected, 'New Node');
     DeptsTree.Selected := aNode;
     DeptsTree.SetFocus;
     Modified:=true;

end;

procedure TFlyEditor.Button2Click(Sender: TObject);
var aNode : TFlyNode;
begin
     aNode := DeptsTree.items.AddChild(DeptsTree.Selected, 'New Node');
     aNode.MakeVisible;
     DeptsTree.Selected := aNode;
     DeptsTree.SetFocus;
     Modified := true;


end;

procedure TFlyEditor.Button1Click(Sender: TObject);
begin
   if DeptsTree.Selected <> nil then
      DeptsTree.items.Delete(DeptsTree.Selected);
        Modified := true;
   DeptsTree.SetFocus;
end;

procedure TFlyEditor.Button4Click(Sender: TObject);
begin
    DeptsTree.items.Clear;
    Modified := true;
end;

procedure TFlyEditor.DeptsTreeKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
// if (Key = VK_F2) and (DeptsTree.Selected<>nil) then
//    DeptsTree.Selected.Edittext
// else
 if (Key = VK_F3) and (DeptsTree.Selected<>nil) then
 begin
    if ssctrl in Shift then
      Button2Click(nil) //add
    else
      AddClick(nil); //add child
 end
 else if (Key = VK_F4) and (DeptsTree.Selected<>nil) then
    Button1Click(nil); //delete
end;

procedure ExchangeTreeNodes(Node1, Node2: TFlyNode);
var tmpNode : TFlyNode;
//    i : integer;
begin
  if (Node1<> nil) and (Node2 <>nil) then
  begin
    Node2.Owner.BeginUpdate;
    if Node1.Owner<>Node2.Owner then
       Node1.Owner.BeginUpdate;
    try
       tmpNode:=Node2.Owner.insert(Node2,'');

       //copy childs of Node1 to tmpNode add
       //Movenode Node1
       if Node1 = Node1.Owner[0] then
          Node2.MoveTo(Node1,naAddFirst)
       else
          node2.MoveTo(Node1,naInsert);

       if tmpnode = Node2.Owner[0] then
          Node1.MoveTo(tmpnode,naAddFirst)
       else
          Node1.MoveTo(tmpnode,naInsert);

       tmpNode.Delete;
    finally
      Node2.Owner.EndUpdate;
      if Node1.Owner<>Node2.Owner then
       Node1.Owner.EndUpdate;
    end;
  end;
end;

procedure TFlyEditor.MoveUpBtnClick(Sender: TObject);
begin
  if (DeptsTree.Selected)<> nil then
   with DeptsTree.selected do
    if GetPrev <>nil then
     begin
       ExchangeTreeNodes(GetPrev,DeptsTree.selected);
       Modified := true;
     end;

end;

procedure TFlyEditor.MovedownBtnClick(Sender: TObject);
begin
   if (DeptsTree.Selected)<> nil then
   with DeptsTree.selected do
    if GetNext <>nil then
     begin
      ExchangeTreeNodes(DeptsTree.Selected,GetNext);
      Modified := true;
    end;

end;

procedure TFlyEditor.DeptsTreeEdited(Sender: TObject; Node: TFlyNode;
  var S: String);
begin
   //Node.Caption :=S;
   Modified:=true;
end;

procedure TFlyEditor.Button6Click(Sender: TObject);
begin
   with TSaveDialog.Create(application) do
   try
      Title := teSaveFileforNode;
      if Execute then
      begin
         DeptsTree.Items.SaveToFile(Filename);
      end;
   finally
      Free;
   end;
end;

procedure TFlyEditor.Button3Click(Sender: TObject);
begin
   with TOpenDialog.Create(application) do
   try
      Title := teLoadFileforNode;
      if Execute then
      begin
         DeptsTree.Items.LoadFromFile(Filename);
      end;
   finally
      Modified:=true;
      Free;
   end;

end;

procedure TFlyEditor.DeptsTreeSelectCell(Sender: TObject; ACol,
  ARow: Longint; var CanSelect: Boolean);
var aNode : TFlyNode;
begin
  aNode := DeptsTree.GetNodeAtrow(aRow);
  if (aNode <> nil) then
   with aNode do
   begin
      FEditChange :=True;
      ImageText.Text :=inttostr(Imageindex);
      SelectedText.Text := inttostr(Selectedindex);
      //StateText.Text := inttostr(Stateindex);
      StateText.ItemIndex := Stateindex;
      Label5.Caption := inttostr(UniqueTag);
      if (Aligns.Visible) and (FAlignments<>nil) then
      begin
        Aligns.ItemIndex := strToInt(FAlignments[aCol]);
      end;
      FEditChange :=false;
   end;

end;

procedure TFlyEditor.Button7Click(Sender: TObject);
begin
  DeptsTree.ColCount := DeptsTree.ColCount+1;
  if UsecolInfo then
  begin
   FWidths.Add(inttostr(exgrid.DefColWidth));
   FAlignments.Add('0');
  end;
end;

procedure TFlyEditor.Button8Click(Sender: TObject);
begin
 with DeptsTree do
 begin
  Items.ClearCells;
  Invalidate;
  Modified := True;
 end;
end;

procedure TFlyEditor.DeptsTreeColumnMoved(Sender: TObject; FromIndex,
  ToIndex: Integer);
var aNode : TFlyNode;
    aList : TStringList;
    aCellsText : String;
begin
  CrackRTree(DeptsTree).InitColumnsMap;
  aNode := DeptsTree.Items.GetFirstNode;
  aList := TStringList.Create;
  Cursor := crHourGlass;
  try
   while aNode <> nil do
   begin
     aCellsText := aNode.CellsText;
     if aCellsText <> '' then
     begin
       aList.Text := aCellsText;
       aList.Move(FromIndex, ToIndex);
       aNode.CellsText := aList.Text;
     end;
     aNode := aNode.GetNext;
   end;
   if UsecolInfo then
  begin
   FWidths.Move(FromIndex, ToIndex);
   FAlignments.Move(FromIndex, ToIndex);
   AlignsClick(nil);
  end;
  finally
     aList.Free;
     Cursor := crDefault;
     Modified :=True;
  end;
end;

procedure TFlyEditor.DeptsTreeColumnWidthChanged(Index, Value: Integer);
begin
if not (csLoading in ComponentState) then
begin
 if FWidths<>nil then
   FWidths[Index] := IntToStr(Value);
   Modified :=true;
end;
end;

procedure TFlyEditor.AlignsClick(Sender: TObject);
begin
  if not FEditChange then
  begin
     FAlignments[DeptsTree.Col] := IntToStr(Aligns.ItemIndex);
     Modified := True;
  end;
end;

procedure TFlyEditor.EnumerateNodes(aImageIndex, aSelectedIndex : Boolean);
var aNode : TFlyNode;
    i : integer;
begin
 aNode := DeptsTree.Items.GetFirstNode;
 Cursor := crHourglass;
 try
   i := 0;
   while aNode<>nil do
   begin
     if aImageIndex then
       aNode.ImageIndex := i;
     if aSelectedIndex then
       aNode.SelectedIndex := i;
     aNode := aNode.GetNext;
     inc(i);
   end;
 finally
   Cursor := crDefault;
   Modified := True;
 end;
end;

procedure TFlyEditor.ImageIndex1Click(Sender: TObject);
begin
  EnumerateNodes(True, False);
end;

procedure TFlyEditor.EnumerateSelectedIndexes1Click(Sender: TObject);
begin
 EnumerateNodes(False, True);
end;

procedure TFlyEditor.EnumerateBoth1Click(Sender: TObject);
begin
  EnumerateNodes(True, True);
end;

procedure TFlyEditor.FormShow(Sender: TObject);
begin
  EnableModified := True;
end;

procedure TFlyEditor.FormCreate(Sender: TObject);
begin
  EnableModified :=False;
end;

initialization
  UseColInfo := False;
  FColCount := 1;
  FStructureCol := 0;
  FWidths := nil;
  FAlignments := nil;

finalization

end.
