unit pledreg;

interface
{$I DFS.INC}
procedure Register;

implementation
uses SysUtils, Classes, ISPlugEdit, {$IFDEF DFS_DELPHI_6_UP} DesignEditors, DesignIntf {$ELSE} DsgnIntf{$endif}, flyEdit, Raptree, ISCalendar;
type
  TFlyNodesEdit = class(TPropertyEditor)
    function  GetAttributes : TPropertyAttributes; override;
    function  GetValue : string; override;
    procedure Edit; override;
  end;

{  TISPlugTextEdit = class(TPropertyEditor)
   function  GetAttributes : TPropertyAttributes; override;
   function  GetValue : string; override;
   procedure Edit; override;
  end;
}

function  TFlyNodesEdit.GetAttributes : TPropertyAttributes;
begin
   result := [paDialog];
end;

function  TFlyNodesEdit.GetValue : string;
begin
   if GetOrdValue = 0 then
      result := '(None)'
   else
      result := '(Items,Columns, Alignments)';
end;

procedure TFlyNodesEdit.Edit;
var I : integer;
    Widths, Alignments : TStringList;
begin
  Widths := TStringList.Create;
  Alignments := TStringList.Create;
  with TIsPlugsection(GetComponent(0)) do
  try
    for i:= 0 to DropDownColcount-1 do
    begin
       Widths.Add(IntToStr(DropDownColwidth[i]));
       Alignments.Add(IntTostr(Ord(DropDownColAlignment[i])));
    end;
    if EditSectionNodes(items, DropDownColcount, DropDownStructureCol, Widths, Alignments, Modified) then
    for i:= 0 to DropDownColcount-1 do
    begin
       DropDownColwidth[i] := StrToInt(Widths[i]);
       DropDownColAlignment[i] := TAlignment(StrtoInt(Alignments[i]));
    end;
  finally
    Widths.Free;
    Alignments.Free;
  end;
end;


{function  TISPlugTextEdit.GetAttributes : TPropertyAttributes;
begin
  result := [paDialog];
end;

function  TISPlugTextEdit.GetValue : string;
begin
  Result := TISCustomPlugEdit(GetComponent(0)).Text;
end;

procedure TISPlugTextEdit.Edit;
begin

    Designer.Modified;
end;
}
procedure Register;
begin
  RegisterComponents('9Rays.Net', [TISPlugEdit, TISCalendar]);
  RegisterPropertyEditor(TypeInfo(TFlyNodes), TIsPlugsection, '', TFlyNodesEdit);
end;

end.
