unit trColled;

interface
{$I DFS.INC}
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, TreeColl,
  {$IFDEF DFS_COMPILER_6_UP} DesignEditors, DesignIntf, {$ELSE} Dsgnintf, {$ENDIF} ExtCtrls, Typinfo;

type
  TTreeCollEdit = class(TForm)
    DeptsTree: TTreeView;
    DeptList: TListBox;
    Panel1: TPanel;
    Add: TButton;
    Button2: TButton;
    Button1: TButton;
    Header1: THeader;
    Closebtn: TButton;
    procedure AddClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure DeptListDblClick(Sender: TObject);
    procedure DeptsTreeChange(Sender: TObject; Node: TTreeNode);
    procedure ClosebtnClick(Sender: TObject);
    procedure Header1Sized(Sender: TObject; ASection, AWidth: Integer);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    intCollection : TTreeCollection;
    //aFD : {$ifdef DFS_COMPILER_4_UP}IFormDesigner{$else}TFormDesigner{$endif};
    aFD : TPropertyEditor;
    procedure RefreshDeptsTree;

  public
    { Public declarations }

  end;
//procedure EditTreeCollection(DeptCollection : TTreeCollection; aFormDesigner : {$ifdef DFS_COMPILER_4_UP}IFormDesigner{$else}{$ifdef DFS_CPPB_4}IFormDesigner{$else}TFormDesigner{$endif}{$endif});
procedure EditTreeCollection(DeptCollection : TTreeCollection; aEditor : TPropertyEditor);

var
  TreeCollEdit: TTreeCollEdit;

implementation

{$R *.DFM}

  procedure EditTreeCollection(DeptCollection : TTreeCollection; aEditor : TPropertyEditor);
  var Dialog : TTreeCollEdit;
      I: Integer;
  begin
     Dialog := TTreeCollEdit.Create(Application);
     try
      {$ifdef DFS_COMPILER_3_UP}
       Dialog.Caption := 'Editing '+ DeptCollection.PropName;
      {else}
       Dialog.Caption := 'Editing TTreeCollection';
      {$endif}

      Dialog.IntCollection :=DeptCollection;
      if DeptCollection.IsList then
        Dialog.Button2.enabled:=false;

      Dialog.aFD := aEditor;//aFormDesigner;

      //fill out TTreeCollection classes
      with DeptCollection do
      for I := 0 to Count-1 do
          Dialog.DeptList.items.add(DeptCollection.items[I].Classname);

      Dialog.RefreshDeptsTree;
       {$ifdef DFS_COMPILER_3_UP}
       if Dialog.aFD<>nil then
       begin
         Dialog.show;//StayonTop;
       end
       else
       begin
         Dialog.showModal;
       end;
       {$else}
        Dialog.showModal;
       {$endif}
      finally
      {$ifdef DFS_COMPILER_3_UP}
      if Dialog.aFD=nil then
          Dialog.Free;
      {$else}
       Dialog.Free;
      {$endif}
      end;
  end;

procedure TTreeCollEdit.RefreshDeptsTree;
var i : integer;
    aNode : TTreeNode;
  procedure RefreshBranches(Node : TtreeNode; item : TTreeCollection);
  var i : integer;
      aNode : TTreeNode;
  begin
     for i:=0 to item.Count-1 do
     begin
       aNode := Node.Owner.AddChildObject(Node, item[i].Classname,item[i]);
       RefreshBranches(aNode,item[i]);
     end;
  end;
begin
   DeptsTree.items.Clear;
   for i:=0 to intCollection.Count-1 do
   begin
      aNode := Deptstree.Items.AddObject(nil, intCollection[i].Classname,intCollection[i]);
      RefreshBranches(aNode,intCollection[i]);
   end;
end;

Type TCRPropertyEd = Class(TPropertyEditor);

procedure TTreeCollEdit.AddClick(Sender: TObject);
var aCollection : TTreeCollection;
begin
  if Deptlist.itemindex<>-1 then
  begin
     if DeptsTree.Selected <> nil then
     begin
       aCollection:=TTreeCollection(DeptsTree.Selected.Data).TreeCollection;
       aCollection.beginUpdate;
       try
       aCollection.Add(Deptlist.items[Deptlist.itemindex],Deptlist.items[Deptlist.itemindex]);
       finally
        aCollection.EndUpdate;
       end;
     end
     else
     begin
       intCollection.BeginUpdate;
       try
        intCollection.Add(Deptlist.items[Deptlist.itemindex],Deptlist.items[Deptlist.itemindex]);
       finally
        intCollection.EndUpdate;
       end;

     end;
     RefreshDeptsTree;
  end;

  if aFD<>nil then
     TCRPropertyEd(aFD).Modified;

end;

procedure TTreeCollEdit.Button2Click(Sender: TObject);
var aCollection : TTreeCollection;
begin
  if Deptlist.itemindex<>-1 then
  begin
     if DeptsTree.Selected <> nil then
     begin
       aCollection:=TTreeCollection(DeptsTree.Selected.Data);
       aCollection.BeginUpdate;
       try
       aCollection.Add(Deptlist.items[Deptlist.itemindex],Deptlist.items[Deptlist.itemindex]);
       finally
         aCollection.EndUpdate;
       end;
     end
     else
     begin
       intCollection.BeginUpdate;
       try
         intCollection.Add(Deptlist.items[Deptlist.itemindex],Deptlist.items[Deptlist.itemindex]);
       finally
         intCollection.endUpdate;
       end;
     end;
     RefreshDeptsTree;

  end;

  if aFD<>nil then
  TCRPropertyEd(aFD).Modified;

end;

procedure TTreeCollEdit.Button1Click(Sender: TObject);
begin
  if DeptsTree.Selected <> nil then
  begin
     TTreeCollection(DeptsTree.Selected.Data).TreeCollection:=nil;
     RefreshDeptsTree;
  end;

  if aFD<>nil then
    TCRPropertyEd(aFD).Modified;

end;

procedure TTreeCollEdit.DeptListDblClick(Sender: TObject);
begin
     AddClick(nil);
end;

procedure TTreeCollEdit.DeptsTreeChange(Sender: TObject; Node: TTreeNode);
begin
  //changed selection
  {$ifdef DFS_COMPILER_3_UP}
  if (Node = DeptsTree.Selected) and (aFD<>nil) then
  begin
     aFd.Designer.SelectComponent(TPersistent(Node.Data));
  end;
  {$endif}

end;




procedure TTreeCollEdit.ClosebtnClick(Sender: TObject);
begin
   Close;
end;

procedure TTreeCollEdit.Header1Sized(Sender: TObject; ASection,
  AWidth: Integer);
begin
   if aSection =0 then
      DeptsTree.Width := aWidth;
end;

procedure TTreeCollEdit.FormCreate(Sender: TObject);
begin
  Header1Sized(nil,0,Header1.SectionWidth[0]);
end;

end.
