unit GraphForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ctypes, cconsts, xygraph, ExtCtrls, Menus;

type
  TfrmGraph = class(TForm)
    GraphPopUp: TPopupMenu;
    ShowHidegraphpoints: TMenuItem;
    N1: TMenuItem;
    Addgraphcaption1: TMenuItem;

    procedure FormCreate(Sender: TObject);
    procedure ShowHidegraphpointsClick(Sender: TObject);
    procedure GraphPopUpPopup(Sender: TObject);
  private
    ShowPoints : boolean;
    fGraphNames: TListNames;
    procedure SetGraphNames(const Value: TListNames);
  published
    graph: TxyGraph;
  public
    { Public declarations }
    procedure AddPoint(const x, y : double);
    procedure InitializeGraph();
    property GraphNames : TListNames read FGraphNames write SetGraphNames;
  end;

implementation

{$R *.dfm}

procedure TfrmGraph.AddPoint(const x, y : double);
begin
  graph.Series[1].Add(x, y);
end;

procedure TfrmGraph.FormCreate(Sender: TObject);
begin
  InitializeGraph();
end;

procedure TfrmGraph.InitializeGraph;
begin
  graph.ClearAll;

  graph.XAxis.AutoSizing := true;
  graph.YAxis.AutoSizing := true;
  graph.XAxis.AutoStepping := true;
  graph.YAxis.AutoStepping := true;

  graph.Series[1].DrawLine := true;
  graph.Series[1].DrawPoints := false;
  graph.Series[1].LineStyle := psSolid;
  
  fGraphNames := TTime;

  ShowPoints := false;
end;

procedure TfrmGraph.SetGraphNames(const Value: TListNames);
begin
  FGraphNames := Value;
end;

procedure TfrmGraph.ShowHidegraphpointsClick(Sender: TObject);
var s : TSeries;
begin
  ShowPoints := not graph.Series[1].DrawPoints;

  s := graph.serieshandle;
  while (s <> nil) do
  begin
     s.DrawPoints := ShowPoints;
     s := s.NextSeries;
  end;
end;

procedure TfrmGraph.GraphPopUpPopup(Sender: TObject);
begin
  if ShowPoints
    then ShowHidegraphpoints.Caption := 'Hide points'
    else ShowHidegraphpoints.Caption := 'Show points';
end;

end.
