unit ctypes;

interface

 type
   TMessageType = (TMInfo, TMWarning, TMError);

 type TComState = (SReady, SRtoDiag, SRtoStart, SRtoAbort, SCharging,
                   SRtoFlashStart, SRToWriteBlock);

 type TChargerStateName =
 (
   STARTING,
   STOPPING,
   STOPPED,
   WAITING,
   TRICLE_TERM,
   RAPID,
   ACTIVATE,
   DISCHARGE
  );


 type
  TAddMessage = procedure (const mtype : TMessageType; const msg : String) of object;
  TAddPoint = procedure (const x, y : double) of object;
  TBatSettings = function : string of object;

  TListNames = (TTime, TVoltage, TCurrent, TTemperature, TChState, TError);

  TListItemChange = procedure (const Item: TListNames; const Value : double) of object;

  TRStruct = record Rterms, Rground, Rup, Rsense : double end;
  TErrorStruct = record UError, IError : double end;

  {
    BYTE discharge_before_charge;
  INT  discharge_thl_voltage;

  BYTE temperature_min, temperature_max;

  INT waiting_charge_voltage;
  INT waiting_charge_current;

  INT  tricle_charge_voltage;
  INT  tricle_charge_current;
  WORD tricle_time;

  INT  charge_term_voltage;
  BYTE total_charge_time;

  INT  activation_charge_voltage;
  INT  activation_charge_current;
  WORD activatiom_time;

  INT  rapid_charge_voltage;
  INT  rapid_charge_current;
  INT  rapid_start_voltage;
  INT  rapid_stop_voltage;
  WORD rapid_time_deactive;
  WORD rapid_time;

  BYTE rapid_check_temperature_rising;
  INT rapid_temperature_rising;

  BYTE rapid_check_max_voltage_decay;
  INT  rapid_voltage_decay;

  BYTE rapid_check_current_decay;
  INT  rapid_current_decay;
  }

  {$A-}
  TBatSettingsValues = packed record
     discharge_before_charge : byte;
     discharge_thl_voltage : SmallInt;

     temperature_min, temperature_max : byte;

     waiting_charge_voltage : SmallInt;
     waiting_charge_current : SmallInt;

     tricle_charge_voltage : SmallInt;
     tricle_charge_current : SmallInt;
     tricle_time : Word;

     charge_term_voltage   : SmallInt;
     total_charge_time : byte;

     activation_charge_voltage : SmallInt;
     activation_charge_current : SmallInt;
     activatiom_time : Word;

     rapid_charge_voltage : SmallInt;
     rapid_charge_current : SmallInt;
     rapid_start_voltage  : SmallInt;
     rapid_stop_voltage   : SmallInt;

     rapid_time_deactive : Word;
     rapid_time : Word;

     rapid_check_temperature_rising : byte;
     rapid_temperature_rising : SmallInt;

     rapid_check_voltage_decay : byte;
     rapid_voltage_decay : SmallInt;

     rapid_check_current_decay : byte;
     rapid_current_decay : SmallInt;
  end;
  PBatSettingsValues = ^TBatSettingsValues;

  TByteArraySettings = packed array[0..sizeof(TBatSettingsValues)] of byte;
  PByteArraySettings = ^TByteArraySettings;

  {$A+}

  TErrorCode = (
    NOERRORS, INVALID_VOLTAGE, TIMEOUT_EXPIRED, FLASH_WRITE);


implementation

end.
