unit functions;

interface
uses classes, cconsts, ctypes;

function Range(value, min, max : double) : double; overload;
function CheckRange(value, min, max : double) : boolean; overload;
function Range(value, min, max : integer) : integer; overload;
function CheckRange(value, min, max : integer) : boolean; overload;

function CheckRangeEx(const min, max, value : integer) : integer; overload;
function CheckRangeEx(
  const name : string; const min, max, value : integer) : integer; overload;

procedure ro(x : pointer; const size : integer);

implementation

uses SysUtils;

type TByteArray = packed array[0..MAXINT div 2] of byte;
     PByteArray = ^TByteArray;

function Range(value, min, max : double) : double;
begin
  if value < min then result := min
  else if value > max then result := max
                      else result := value;
end;

function CheckRange(value, min, max : double) : boolean;
begin
  if (value > min) and (value < max) then result := true
                                     else result := false;
end;

function Range(value, min, max : integer) : integer;
begin
  if value < min then result := min
  else if value > max then result := max
                      else result := value;
end;

function CheckRange(value, min, max : integer) : boolean;
begin
  if (value > min) and (value < max) then result := true
                                     else result := false;
end;

//reverses the byte order in the any type variable
procedure ro(x : pointer; const size : integer);
var i, k : integer;
    p : PByteArray;
    temp : byte;
begin
  p := PByteArray(x);
  if (size > 1) then
  begin
    k := (size div 2)-1;
    for i := 0 to k do
    begin
      temp := p^[i];
      p^[i] := p^[size-i-1];
      p^[size-i-1] := temp;
    end;
  end;
end;

function CheckRangeEx(const min, max, value : integer) : integer;
begin
  result := Range(value, min, max);
  if (Value < min) or (Value > max) then
    raise ERangeError.CreateFmt('Invalid range in parameter calculation, '+
      'must be [%d..%d], is %d', [min, max, value]);
end;

function CheckRangeEx(
  const name : string; const min, max, value : integer) : integer;
begin
  result := Range(value, min, max);

  if (Value < min) or (Value > max) then
    raise ERangeError.CreateFmt('Invalid range in the %s parameter calculation, '+
      'must be [%d..%d], is %d', [name, min, max, value]);
end;

end.
