unit packet;

interface

uses Windows, Messages, SysUtils, Variants, Classes, Graphics,
     ctypes, cconsts, Buttons, GraphForm, BatterySettings, CPort,
     Dialogs, MsgForm;


  type TPacketProcess = class (TThread)
  private
    event : Cardinal;
    packetstr : string;
    messagestr : string;
    messagetype : TMessageType;
    fMessageForm: TfrmMessages;
    procedure AddMessage();
  public
    procedure Execute; override;
    procedure ProcessPacket(Sender: TObject; const Str: string);
    constructor Create();
    property MessageForm : TfrmMessages read fMessageForm write fMessageForm;
  end;


  type TPacket = class(TComponent)
  private
    ComPort: TComPort;
    ComDataPacket: TComDataPacket;
    function ConvStr(const str : string; const left, right : integer) : integer;
  public
    constructor Create(AOwner: TComponent); override;
    procedure SetComport();
  end;
implementation

{ TPacket }

function TPacket.ConvStr(const str: string; const left,
  right: integer): integer;
var l : integer;
    tmp : string;
begin
  l := Length(str);

  if ((l < left) or (l < right))
  then raise EComponentError.Create('The string lenght less then index');

  tmp := Copy(str, left, right-right+1) + 'h';
  result := StrToInt(tmp);
end;

constructor TPacket.Create(AOwner: TComponent);
begin
  inherited;
  ComPort := TComPort.Create(AOwner);
  ComDataPacket := TComDataPacket.Create(AOwner);

  try
    ComPort.LoadSettings(stRegistry, REGCOMPORT);
  except
    ShowMessage(CCOMSETTINGS);
  end;

  ComDataPacket.ComPort := ComPort;
  with ComDatapacket do
  begin
    IncludeStrings := False;
    Size := 0;
    CaseInsensitive := false;
    StartString := CCOMSTARTSTR;
    StopString := CCOMSTOPSTR;
  end;

end;

procedure TPacket.SetComport;
begin
  try
    ComPort.LoadSettings(stRegistry, REGCOMPORT);
  except
  end;
  ComPort.ShowSetupDialog();
  ComPort.StoreSettings(stRegistry, REGCOMPORT);

end;

{ TProcessThread }

procedure TPacketProcess.AddMessage;
begin
  if Assigned(MessageForm) then
  MessageForm.AddMessage(messagetype, messagestr);
end;

constructor TPacketProcess.Create;
begin
  inherited Create(True);
  event := CreateEvent(nil, FALSE, FALSE, nil);
  MessageForm := nil;
  messagetype := TMInfo;
  messagestr := '';
end;

procedure TPacketProcess.Execute;
var res : DWORD;
    i : integer;
begin
  while (not Terminated) do
  begin
    res := WaitForSingleObject(event, CWAITPACKETTIMEOUT);

    case res of
      WAIT_OBJECT_0:
      begin

      end;

      WAIT_TIMEOUT:
      begin

      end;

      WAIT_ABANDONED:
      begin

      end;
    end;
  end;
end;

procedure TPacketProcess.ProcessPacket(Sender: TObject; const Str: string);
begin
  packetstr := Str;
  SetEvent(event);
end;

end.
