unit xtypes;
interface
uses constants, sysutils;

type
TIndexParams = -1..MaxModelParams - 1;
TIndexSubModels = -1..MaxSubModels;


TDataIndex = 0..MaxLines - 1;
TDataResult = 0..MaxPointsInLine - 1;
ItemState = (stNoOptimize, stOptimize, stFixed, stDefault, stTempCoef);
TNameType =string[ParamNameLength];

 TOneDimDistrArray = array of record
                               X, Xn, P : double
                               end;

 DistParamsArray =   array of TOneDimDistrArray;



ItemParam = record
 IV,//OptimValue
 OV,//InitValue
 MinValue,
 MaxValue,
 DefaultValue,
 ErrorVal,
 Dependancy,
 StartValue,
 MinStartValue,
 MaxStartValue : Double;
 NameParam : TNameType;
 State : ItemState;
 isOptim : boolean;
 DArray : TOneDimDistrArray;
            end;


TListParams = array[0..MaxModelParams-1] of ItemParam;
TModelsParamsList = array of TListParams;

{ A T T E N T I O N !!!

Alyternative using of TModelsParamsList :
MPL[0,j] used for:
 StartValue - measuring Temperature
 MinValue - Min in array
 MaxValue - Max -//-
 IV - Step
 ErrorVal - Spice distribution "Value"
}

TValueCheck = (Minus, Any, Plus);

TFunction = function (Sender : TObject) : boolean;

TParamElement = record
 Name : string;
 Value : double
               end;

PData = array[0..(MaxPointsInLine-1)*MaxLines] of Double;
TDataExperimental = ^PData;

TZIndex = array[0..MaxLines-1] of record
 L, H : Word;
 Z : Double;
 W : Double;
          end;

TNameIndex = (GraficTitle, XAxis, YAxis, ZAXisTo, ZAxisAfter, ModelTitle,
              FileExtension, NameInList);
TNames = array[TNameIndex] of string;

TPIndex = 0..MaxModelParams;
TParamsArray = array[TPIndex] of Double;

TVectorArray = TParamsArray;
TMatrixArray = array[TPIndex, TPIndex] of Double;

TVectorIntArray = array[TPIndex] of Integer;
TMatrixIntArray = array[TPIndex, TPIndex] of Integer;

TConvertArray = array[TPINdex] of TPIndex;

 TGraficFunction = function (const ValueX, ValueZ : Double) : Double;
 TSingleFunction  =  function (const Params : TParamsArray;
                               const ValueX, ValueZ : Double) : Double;
 TVectorFunction = array [1..MaxDimension] of TSingleFunction;
 TMatrixFunction = array [1..MaxDimension, 1..MaxDimension] of TSingleFunction;
TOptionsIndex = (SwapAxis, LogX, LogY);
TOptions = array[TOptionsIndex] of boolean;

TValueIndex = (ISet, IMes, USet, UMes, CMeas);

TErrorFunction = function (const Index : Integer) : double;

ANFunction = function (const X : double; const P : array of double) : double;
AVFunction = function (const X : array of double; const P : array of double) : double;

AVFunctionVect = array[1..MaxDimension] of AVFunction;
AVFunctionMatr = array[1..MaxDimension] of AVFunction;

TDataFileIndex = (MU1, MI1, MU2, MI2);
TChannel = (ChannelN1, ChannelN2);

TComplex = record Re, Im : double end;

TAxisIndex = (AxisX, AxisY, AxisZ);
TDataIndexArray = array[TAxisIndex] of integer;

TDialogUsedFor = (fDistribution, fTemperature);

DeviceInformation = array of record
                              Index : Integer;
                              Text : string;
                             end;
EProgramMathAllError = class(EMathError)
 public
 Info  : Integer;
                       end;

ENextIteration = class(EAbort)
                 end;

EMethodError = class(EProgramMathAllError)
               end;

EFunctionError = class(EProgramMathAllError)
                 end;

EProcessError = class(EAbort)
                end;

EInvalidModelType = class(EAbort)
                  end;
              
EDiffrDevT = class(EAbort)
             end;

type
 TNotifyString = procedure(Sender : TObject; const InfoStr : string) of object;


type
TAproxTempFunction =
 function (const MeasurementTemperature: double;
           const ModelParamList : TListParams;
           const TempParamsList : TParamsArray) : double;

 TDfunction = function : double;

type
 Int = Integer;
 

 TOpenIntArray = array of integer;
 TOpenFloatArray = array of double;
 TOpenStringArray = array of string;

 TMacroItem = record
  ItemName : string;
  IndexesInt :  TOpenIntArray;
  IndexesStr :  TOpenStringArray;
  end;

 PMacroItem = ^TMacroItem;

implementation

end.
