unit RapTree;
{-----------------------------------------------------------------
   Copyright (c) 1999 IMCA SYSTEMS
   All Rights Reserved.
   Creation Date: 16.05.99//
   Version :
   Module: "Rapid" -  technology TreeView
           with full support TCustomGrid and Tree possibilities
           and polymorphic TFlyNodes
   Initial Version:0.15 Alpha
   Added TFlyNode, TFlyNodes - polymorphic objects (Polymorphic TTreeCollection descendent)
   Increased Speed of manipulation With Nodes
   Added TTreeNode, TTreeNode similar functionality
   Added GetHittestinfo, GetNodeAt methods
   added HotTrack possibilities
   10/09/02:  StructureCol saved and restored after show/hide/move operations, and can be -1 if need to hide structure

   Version : 0.33 Alpha---------
   StructureCol can be fixed column (Node Caption can be placed in
   Fixed Colulmn, but cannot be edited);
   Added Logic StateIndex support - Showlogic
   Added DefaultImageindex,DefaultStateIndex, DefaultSelectedIndex
   for improved adding speed.
   implement EditText/EndEdit for editing TFlyNode Caption;
   added Sorting procedures and SortType for RapidTree
   Support for Images
   Added standard TreeView events
   RowMoving instead DragDrop nodes
   Version : 0.42 Alpha---------
   TFlyNode.Getrow bug fixed
   Added TFlyNode.Cells[aCol : integer] like TStringGrid functionality
   02.06.99 Version 0.43//
   Added GetNodeData,SetNodeData procs for virtual management imput/output/validate/translate datas
   Separated drawing methods for improve speed of drawing:
    For DrawCell:
     DrawStructure
     DrawData
     DataFixed (may be Structure (Tree))
   02.06-10.06.99 v.0.56
    Added InserRows/DeleteRows procs for saving heights of each node
    and (expected) for smooth expand/collapse/delete/insert nodes
    Added public property Height for Node
    Added dynamic procs : ColSized and RowSized for determine changing
     NodeHeight
    Added WordWrap property
   11.06 - 0.72
    Some bugs fixed
    Added PropertiesEditor for editing FlyNodes
   11.06 - 1.0
    Fixed some bugs and memory leaks
    Improved functionality
    16.06 - 1.08
    Added support property Selected of TFlyNode for MultiSelection Mode
    Added Multiselection support
    Bug with redrawing selected Cells fixed
    Improved mechanism of drawing Nodes
    Removed bug with Items property editing
    8.07 - 1.26
    Added incremental search on Node.text
    Removed bug with setting fixedrows prop
    Removed and optimized problem with expanding/collapsing Nodes
    Added Tooltips  management
    Corrected Items properties editor
   13.07 - 1.27
    Added Autoexpand property
    Wordwrap property bug fixed
   18.07 - 1.28
    Added dynamic proc DrawBackground(aRect : TRect);
    Improved speed of drawing
   01.08-3.08 - ver2.01-2.06
         Now based on ExGrid - specifical functionality Grid
         for improve some operations
         Improved operation on RapidTree
         Improved operations with dragging columns and fetching datas 
   03.08-07.08 - ver 2.4 - More faster in operation
   Improved speed of Drawing (new acrchitecture)
   Improved speed of many functions such as:
      GetRow, GetNodeAtRow, Expanding/Collapsing for big arrays of Nodes etc.
   Improved speed for moving through big number of rows
   Improved sort technology
   11.08.99 v. 2.41
   Prevented error message on set Fixedrows
   12.08.99
   Added service utilities for more convenient work with Nodes
         AssignTreeNodesToFlyNodes
         AssignFlyNodesToTreeNodes
   24.08.99 - 2.43
   Removed bug for drawing multiselect cells //begindrag
   Some optimizations
   25.08.99 - 2.5
    Drag'n'Drop Support
    Really Multiselection Drag'n'Drop
    AutoScroll on drag
    Resolved scroll bar operating
   26.08 - 2.53
   Improved Drag'n'drop Operations to Ole Drag'n'Drop
   Improved style of Draw Structure Column
   01-03.09.99 - 2.6
   Improved Drag'n'drop to Ole Drag'n'Drop
   Improved MoveTo procedure for moving nodes to/from different trees
    08-10 .99 - 2.61
    Some minor bugs fixed
   11.09.99 - 2.62
   Added CreateNode function for conveninent implementing nodes
   12-22.09.99 - 2.65
   Some minor improvements, bug fixes, corrections
   Improved Tooltips support for each cell in tree
   22.09-01.10.1999 - 3.0
   - Now TFlyNodes have version indenpendent
     streaming systems - add new properties you don't loose your data
   - Corrected Dragging column operating (drag position drawed after mouse
     moving instead mousedown)
   - Added full support for RightToleft Alignment for MiddleEast
   - some bugs fixed
   08.10.99 3.01
     Added to FlyNodes 2 functions:
       GetItemText and SetItemText - for search item on Full search path
     Corrected bug with FlyNode.Data property
   15.10.99 3.02
     Improved work with Drag'n'Drop operations
     Improved Drawing operations on Drag (Drawing InsertMark)
   10.11.99 - v3.3
      Added Show/hide node features - now you can show/hide nodes in the tree
   03.12.99 - v.3.41
      Improved Tooltips and Hint support
      Bug with showeditor removed (images in node not displayed)
   20.12.99 - 3.41b1
      corrected using imagelist
   20.01.2000 - 3.42
      Corrected onExpandevent
   30.01.2000 - V3.45
      Added streaming functions for TFlyNode and TFlyNodes:
      // streaming procs for load/save nodes in hex format with properties information
         SaveToText,LoadFromText
         LoadFromStream,SaveToStream
         SaveToFile,LoadFromFile

      // streaming procs for load/save nodes in Text format (with tabs)
         LoadNodesFromFile
         SaveNodesToFile
         SaveNodesToStream
         LoadNodesFromStream
    05.02.2000 - 3.47
       Improved selection mechanism/multiselect/drag'n'drop
       Some incorrectness fixed
    07.02.2000 - 4.0
       Added some useful events: OnDeletion, OnCompare etc
       Improved Expand and Collapse procedures
       Improved Selection and Hide/Show operations
    11.02.2000 - 4.01
       MoveTo bug fixed
    24.02.2000 - 4.1
       New events added:
          OnColumnWidthChanged;
          OnColumnWidthChanging;
          OnRowHeightChanged;
          OnRowHeightChanging;
       Added :
          LineColor property
          FixedLineColor property
          FixedColAsButton property
          FixedRowAsButton property
          AssignTo function for copying all properties of control
          Possibility for resizing fixed columns
          Improved mechanism for save extradata in Cells[x], where x > Colcount
      !!! Corrected showing of Inplace editor for editing node
    17.03.200 4.5
      - Now more faster!!! - on Huge arrays more than 20000 - speed increased more than 2 times!!!
      - TFlyNodes editor allowed multiselection settings
      - Fixed bug with draw relation lines
      - Improved drawing techniques
      - Added FitToHeight property for fit heights to node text.
      - Full rework nodes Drag'n'Drop with hiliting droptarget node
      - Full rework move columns - modern way - with sliding header (flicker free)

   26.04.2000 v 5.0:
       Changed and optimized drawing technique for:
       1. All drawings can be maked into another canvas
        a. Convenient Printing (also into metafile);
        b. Added DrawButton virtual function for custom drawing states of Node: Collapsed/expanded/checked etc...
          it maked for precisioned build of printed image independent from printing devices
        c. StatesDrawed property for drawing states - from resource bitmap or from DrawButton function
       2. Reworked FitToHeight property management
   09.05.2000 - 5.02
    Added Cut/Copy/Paste management
    Some incorrectness fixed
   21.05.2000 - 5.1
     1. Prepared for RtfDrawing
     2.Corrected OnGetImageIndex, OnGetSelectedIndex events
     3.Added support for Multiselection:
       TFlyNodes.GetFirstSelectedNode
       TFlyNodes.GetNextSelectedNode
       TFlyNodes.GetPrevSelectedNode
       TFlyNodes.GetLastSelectedNode
     4. Corrected increment searcing for correct support GeteditText
   23.05.2000 v.5.5
     1. Added RTF_Drawing support:
       a. added RtfDraw unit with DrawRTFText function.
          with calulate rect possibility.
       b. Added load RTF text from file in Nodes property editor 
   30/07/2000 - 5.58
   Improved selection functionality - ajusted to MSTreeView standard selection
   Added MouseWheel scroll support - also on Shift, Control press
   01/08/2000 5.6
    Added RightClickSelect
    Some minor improvements
    KeyPress now working properly on readonly RapidTree
    Some speed improvements 
   13.08.00 5.7
      - improved speed of add/insert nodes
      - improved selection mechannism and RightClickSelect functionality corrected
      - selection mechanism adjusted to standard selection technique of MSTreeView
   15.08.00 -5.71
      - corrected GetfirstSelectednode, GetNextSelected ...etc methods
   17.08.00 5.72
      - corrected clearing nodes at design time and in Customize Dialog
   29.08.00 5.8
    - improved work with with inplace editors
    - RTFDrawing feature as depend from OS replaced by HTMLDrawing - independent function,
    - some minor corrections and improvements
   20.09.2000 - 5.9
      Added to Nodes properties editor LoadNodes/SaveNodes functionality for load/save nodes to file
      Improvements on fetch data,
      Easy of use TFlyNode.Cells[] array for virtual fetch data
   25.09.2000 - 6.0
      Added new property - OutlineStyle
      Node you can draw outlines as in standard TreeView, Explorer, Excel outline styles
      Corrected bug with draw extra-width text with center and right alignment
   12.10.2000 6.1
      Improved HTMLDrawing technique
   26.10.2000 - 6.1
      Improved addition nodes technique, incresed speed
      Some memory optimizations
   18.11.2000 6.5
      Improved RightToleft support
      Some improvements and fixes
      Added DragType property for support Delphi standard or OLE dragdrop technique
      Full support (OLE events, can act as OLE target and source)
      Added OutlineColor property
      Some improvements in selection technique - combined selection of Tree and Grid - nodes and blocks of cells
      3 ways to drag:
       OleDrag - DragType=DtOle, Dragmode=dmAutomatic
       DelphiDrag - DragType=dtStandard, Dragmode=dmAutomatic
       Grid row moving - DragType=dtStandard, Dragmode=dmManual, Options=+goRowMoving, also AutoMove=true for automoving selected rows
    20.12.2000 6.5
     - Optimized Tooltips management
     - Added HotTrackColor
    20.02.2001 6.8
       Some corrections and optimizations
       Add possibility to fill Cells array at design time
       Reworked Items Editor - allows to fill cells information
    17.04.2001 6.9
       Some improvements
       Added more imporved hide nodes, if all childrens of Node are hidden it will be displayed
       without +/- Button
    9/06/2001 6.92
       Added Options to SaveNodesToFile method for more convenient save node with associated additional info

   Expected:
      Smoothing Expand/Collapse/scroll

-----------------------------------------------------------------}
interface
{$I DFS.inc}

uses
   Windows, Messages, SysUtils, CommCtrl, Classes, Graphics, Controls, extctrls, {Forms,} Dialogs, Forms,
   ISHTMLHintWindow, ExGrid, Comctrls, Treecoll, {$ifdef DFS_COMPILER_3_UP}ActiveX{$ENDIF}{$ifdef DFS_COMPILER_4_UP}, ImgList, OLEDragDrop {$endif};


{$R raptree}

const
   STATE_EMPTY                        = 0; //componentstate
   STATE_UNCHECKED                    = 1;
   STATE_CHECKED                      = 2;
   STATE_GRAYEDCHECKED                = 3;
   STATE_OPTIONED                     = 4;
   STATE_UNOPTIONED                   = 5;
   STATE_GRAYEDUNCHECKED              = 6; //new 10/07/01
   STATE_GRAYEDOPTIONED              = 7; // --
   STATE_GRAYEDUNOPTIONED            = 8; // --
   STATE_DOUBLECHECKED               = 9;
   STATE_GRAYEDDOUBLECHECKED         = 10;

   aSaveOptions = 'SaveOptions:';
const
  TabChar = #9;
  EndOfLine = #13#10;

   ISInfo: packed array[0..7] of Pchar=
   ('յϽ',//'IMCA SYSTEMS (c) Copyright 1996-2000',
   '',//'TCustomFlyTreeView',
   '',//'E-mail: imcasys@xoommail.com',
   '繤ř',//'Visit Our HomePage: http://members.xoom.com/imcasys/',
   '',//'About TCustomFlyTreeView...',
   'Customize...',
   'ϗߚՃ',
   {$IFNDEF Registered}
   ''//'UnRegistered version!'
   {$Else}
    ''//'Registered version!'
   {$ENDIF}
   );

type
   ERapidTreeError = class(Exception);
   TCustomRapidTree = class;
   TFlyNodes = class;

   PInt = ^Integer;


   TBitmapArrayRange = 0..14;
   TRapidBitmap = (obExpanded, obCollapsed, obOpen, obClose, obEmpty, obChecked, obUnchecked, obGrayedChecked, obOptioned, obUnoptioned, obGrayedUnchecked, obGrayedOptioned, ObGrayedUnoptioned, ObDoubleChecked, ObGrayedDoubleChecked);
   TDrawOption = (doDrawlines,doDrawbuttons, doDrawStates, doDrawImages, doDrawText);
   TDrawOptions = set of TDrawOption;

   TFlyNode = class;

   {$ifdef DFS_COMPILER_3_UP}
   INodeAdapter = interface
     ['{3EF21996-E3D1-11D3-86A2-00E04CAAC9BF}'] 
     procedure ReferenceNode(Node: TFlyNode);
     procedure ReleaseNode;
   end;
   {$ENDIF}
    TFlyNode = class(TTreeCollection)
      private
         FUniquetag : integer;
         {$ifdef DFS_COMPILER_3_UP}
         FNodeAdapter          : INodeAdapter;
         {$ENDIF}
         FAllHidden, FHidden              : Boolean;
         FDeleting, Fexpanding, Fexpanded : Boolean;
         FSelected             : Boolean;
         FSorted              : boolean;
         FmovedIn             : Boolean;
         FhasChildren         : boolean;
         FOwner               : TFlyNodes;
         FCells               : TStringlist;
         FHeight              : integer;
         FnodeState           : TNodeState;
         {$ifdef ACTIVEX}
         FBookmark            : Pointer;
         Funbound             : Boolean;
         {$endif}
         FImageIndex          : Integer;
         FStateIndex          : Integer;
         FSelectedIndex       : Integer;
         FOverlayIndex        : Integer;

         //FInTree: Boolean;
         {$ifdef DFS_COMPILER_3_UP}
         procedure SetNodeAdapter(const Value: INodeAdapter);
         {$ENDIF}

         function DoCanExpand(Expand: Boolean): Boolean;
         procedure DoExpand(Expand: Boolean);
         procedure ExpandItem(Expand: Boolean; Recurse: Boolean);
         procedure CollapseNodeList(aNode: TFlyNode; Recurse : Boolean);//removing from Nodelist collapsed values
         procedure ExpandNodeList(aNode: TFlyNode; var atIndex : Longint; Recurse : Boolean);
         function GetNextVisibleSibling : TFlyNode;
//         function GetLastVisibleNode : TFlyNode;
         function GetAbsoluteIndex: Integer;

         function GetExpandedCount : Longint;
         function GetExpanded: Boolean;
         function GetLevel: Integer;
         function GetParent: TFlyNode;
         function GetChildren: Boolean;
         function GetCut: Boolean;
         function GetDropTarget: Boolean;
         function GetFocused: Boolean;
         //function GetIndex: Integer;
         function GetItem(Index: Integer): TFlyNode;
         function GetSelected: Boolean;
         function GetState(NodeState: TNodeState): Boolean;
         procedure SetState(NodeState: TNodeState);
         function GetTree: TCustomRapidTree;

         //function IsEqual(Node: TFlyNode): Boolean;
         function IsNodeVisible: Boolean;
         procedure SetChildren(Value: Boolean);
         procedure SetCut(Value: Boolean);
         procedure SetData(Value: Pointer);
         {$IFDEF ACTIVEX}
         procedure SetBookmark(Value: Pointer);
         {$ENDIF}
         function  Getdata : Pointer;
         procedure SetDropTarget(Value: Boolean);
         procedure SetItem(Index: Integer; Value: TFlyNode);
         procedure SetExpanded(Value: Boolean);
         procedure SetFocused(Value: Boolean);
         procedure SetImageIndex(Value: Integer);
         procedure SetOverlayIndex(Value: Integer);
         procedure SetSelectedIndex(Value: Integer);
         procedure SetSelected(Value: Boolean);
         procedure SetStateIndex(Value: Integer);
         procedure SetText(const S: string);
         Function GetText : String;
         procedure SetHeight(Value : integer);
         function GetHeight : integer;
         //procedure Added(aNode: TFlyNode);
         Procedure Removed(aNode: TFlyNode);
         Procedure SetHidden(Value : boolean);
         //new methods for support virtual add/remove
         procedure SetOwner(aOwner : TFlyNodes);
//         function Unpack(AtIndex : Integer): TTreeCollectionClass; override;
         function GetCellsText : String;
         procedure SetCellsText(const Value : String);
         function CellsStored : Boolean;
         //usi
         procedure SetUniqueTag(Value : Integer);
         function GetUniqueTag : integer;
      protected
         procedure Update(Item: TTreeCollection); override;   // CEDR 06.10.02 moved from private
         procedure SetIndex(Value: Integer); override;        // CEDR 06.10.02 moved from private
         function InternalGetClass(aClassname : String) : TTreeCollectionClass; override;  // CEDR 06.10.02 moved from private
         function _Add(AtIndex : Integer): TTreeCollectionClass; override;//Inserts a new item to the end of a Collection.    // CEDR 06.10.02 moved from private
         procedure SetCaption(value : string); override;
         Function GetCell(aCol : integer) : String; virtual;
         procedure SetCell(aCol : integer; Value : String); virtual;
      public
         constructor Create(AOwner : TTreeCollection); override;
         destructor Destroy; override;
         procedure Show(Recursive : boolean);
         procedure Hide;
         // new 30.01.2000
         function SaveToText(SplitToStrings: Boolean) : string;
         procedure LoadFromText(Text : string);
         procedure LoadFromStream(Stream : TStream);
         procedure SaveToStream(Stream : TStream);
         procedure SaveToFile(const Filename : string);
         procedure LoadFromFile(const Filename : string);
         {$IFDEF ACTIVEX}
         property Bookmark_: Pointer read Fbookmark write SetBookmark;
         property Unbound : boolean read FUnbound write FUnbound;
         {$ENDIF}

         //Call AlphaSort to sort the subtree of the tree alphabetically. If successful, the method returns True.
         function AlphaSort: Boolean;
         //Copies the properties of another tree view node.
         procedure Assign(Source: TPersistent); override;
         //Collapses a node.
         procedure Collapse(Recurse: Boolean);
         //returns physical row of node
         function GetRow : integer;
         //Destroys the node and all its children.
         procedure Delete;
         //Deletes all children of the node.
         procedure DeleteChildren;
         //Returns the bounding rectangle for a tree node.
         function DisplayRect(TextOnly: Boolean): TRect;
         //Begins in-place editing of the specified node's text
         function EditText: Boolean;
         //Ends the editing of a node's label.
         procedure EndEdit(Cancel: Boolean);
         //Expands the node to display all child nodes.
         procedure Expand(Recurse: Boolean); 
         //Returns the first child node of a tree node.
         function getFirstChild: TFlyNode;
         //Returns the last immediate child node of the calling node.
         function GetLastChild: TFlyNode;
         //Returns the next node after the calling node in the tree
         function GetNext: TFlyNode;
         //Returns the next child node after Value.
         function GetNextChild(Value: TFlyNode): TFlyNode;
         //Returns the next node in the tree at the same level as the calling node.
         function GetNextSibling: TFlyNode;
         //Returns the next visible node in the tree view after the calling node.
         function GetNextVisible: TFlyNode;
         //Returns the previous node in the tree view before the calling node.
         function GetPrev: TFlyNode;
         //Returns the previous child node before Value.
         function GetPrevChild(Value: TFlyNode): TFlyNode;
         //Returns the previous node before the calling node and at the same level.
         function getPrevSibling: TFlyNode;
         //Returns the previous visible node before the calling node.
         function GetPrevVisible: TFlyNode;
         //Returns True if Value is a parent node of the calling node.
         function HasAsParent(Value: TFlyNode): Boolean;
         //Returns the position of an immediate child node of the calling node.
         function IndexOf(Value: TFlyNode): Integer;
         //Expands the parent nodes of a node.
         procedure MakeVisible;
         //Moves the node to another location in the tree or another tree.
         procedure MoveTo(Destination: TFlyNode; Mode: TNodeAttachMode); virtual;
         //Specifies the vertical size (in pixels) of the Node.
         property Height : integer read GetHeight write SetHeight;
         //Indicates which TFlynodes object contains the tree node.
         property Owner : TFlyNodes read FOwner write SetOwner;
         //Indicates the index of the tree node relative to the first tree node in a tree node
         property AbsoluteIndex: Integer read GetAbsoluteIndex;
         //Indicates if the tree node object is drawn as if selected as part of a cut and paste operation.
         property Cut: Boolean read GetCut write SetCut;
         //Points to application-defined data associated with the node.
         property Data: Pointer read GetData write SetData;
         //Indicates whether a node's Destroy method has been called and it is in the process of being deleted
         property Deleting: Boolean read FDeleting;
         //Indicates whether the node appears to have focus.
         property Focused: Boolean read GetFocused write SetFocused;
         //Indicates whether the node is a drag and drop target.
         property DropTarget: Boolean read GetDropTarget write SetDropTarget;
         //Determines whether the node is selected.
         property Selected: Boolean read GetSelected write SetSelected;
         //Specifies whether the tree node is expanded.
         property Expanded: Boolean read GetExpanded write SetExpanded;
         //Indicates whether a node has any children.
         property HasChildren: Boolean read GetChildren write SetChildren;
         //Indicates whether the tree node is currently visible in the tree image.
         property IsVisible: Boolean read IsNodeVisible;
         //Provides access to a child node by its position in the list of child nodes.
         property Item[Index: Integer]: TFlyNode read GetItem write SetItem; default;
         //Indicates the level of indentation of a node within the tree control.
         property Level: Integer read GetLevel;
         //Indicates which Root - TFlynodes object contains the tree node.
         property Root: TFlyNodes read FOwner;
         //Identifies the parent node of the tree node.
         property Parent: TFlyNode read GetParent;
         //Specifies the tree that displays the node.
         property Tree: TCustomRapidTree read GetTree;
         //Determines which image from the image list is used as an overlay mask.
         property OverlayIndex: Integer read FOverlayIndex write SetOverlayIndex;
         //Lists the strings for each cell in the node.
         property Cells[aCol : integer] : string read GetCell write SetCell;
         // added for future COM support
         {$ifdef DFS_COMPILER_3_UP}
         property NodeAdapter : INodeAdapter read FNodeAdapter write SetNodeAdapter;
         {$ENDIF}
         //Usi
      published
         property UniqueTag : Integer Read GetUniqueTag write SetUniqueTag default -1;
         property Hidden : boolean read FHidden write SetHidden default True;// stored  HiddenStored;
         //Specifies which image is displayed when a node is in its normal state and is not currently selected
         property ImageIndex: Integer read FImageIndex write SetImageIndex default -1;// stored ImageIndexStored;
         //Specifies the index in the tree views image list of the image displayed for the node when it is selected.
         property SelectedIndex: Integer read FSelectedIndex write SetSelectedIndex default -1;// stored SelectedIndexStored;
         //Indicates which image from the StateImages list to display for the node.
         property StateIndex: Integer read FStateIndex write SetStateIndex default -1;// stored StateIndexStored;
         //Specifies the label that identifies a tree node.
         property Text : string read GetText write SetText;
         //specifies array of cells in text format
         property CellsText : string read GetCellsText write SetCellsText stored CellsStored;

   end;


   TSaveNodesOption = (tsnIncludeImageIndex, tsnIncludeSelectedIndex, tsnIncludeStateIndex, tsnIncludeCells, tsnIncludeExpands{new}, tsnIncludeHiddens{new}, tsnIncludeUniqueTags{new});
   TSaveNodesOptions = set of TSaveNodesOption;
   
   TFlyNodes = class(TTreeCollection)
   private
         //usi
         FEnumerating : Boolean;
         FMaxTag : Integer;
         
         FLock: TRTLCriticalSection;
         FSorted           : boolean;
         FOwner            : TCustomRapidTree;
//         FUpdateCount      : Integer;
         FNodeList         : TList;
         //FAddedCount       : Longint;
         FDefStateIndex    : integer;
         FDefImageIndex    : integer;
         FDefSelectedIndex : Integer;
         FItemseparator : String;
         procedure AddedNode(Value: TFlyNode);
         function GetNodeFromIndex(Index: Integer): TFlyNode;
         procedure Repaint(Node: TFlyNode);

         //procedure Added(aNode: TFlyNode);
         Procedure Removed(aNode: TFlyNode);
         //thread functions
         procedure LockList;
         procedure UnlockList;
         procedure SetItemSeparator(Value : String);
         function GetTree : TCustomRapidTree;

      protected
         function InternalAddObject(Node: TFlyNode; const S: string;
         Ptr: Pointer; AddMode: TAddMode): TFlyNode;
         procedure SetItem(Index: Integer; Value: TFlyNode);
         procedure SetUpdateState(Updating: Boolean);
         procedure Update(Item: TTreeCollection); override;
         function InternalGetClass(aClassname : String) : TTreeCollectionClass; override;
         function _Add(AtIndex: Integer): TTreeCollectionClass; override;
      public
         constructor Create(AOwner: TCustomRapidTree);{$ifdef DFS_COMPILER_4_UP} reintroduce; {$endif}
         destructor Destroy; override;
         // Usi
         Function GetNodeOnUniqueTag(aTag : Integer) : TFlyNode;
         // 25.02.2000 - clearing
         procedure ClearCells;
         //new feature
         procedure ShowAll;
         procedure Hide(aNode : TFlyNode);
         // new 30.01.2000 //Trect
         // streaming procs for load/save nodes in hex format with properties information
         function SaveToText(SplitToStrings: Boolean) : string;
         procedure LoadFromText(Text : string);
         procedure LoadFromStream(Stream : TStream);
         procedure SaveToStream(Stream : TStream);
         procedure SaveToFile(const Filename : string);
         procedure LoadFromFile(const Filename : string);
         // streaming procs for load/save nodes in Text format (with tabs)
         procedure LoadNodesFromFile(const FileName: string);
         procedure SaveNodesToFile(const FileName: string; SaveOptions : TSaveNodesOptions);
         procedure SaveNodesToStream(Stream: TStream; SaveOptions : TSaveNodesOptions);
         procedure LoadNodesFromStream(Stream: TStream);

         //get full search path to needed node
         function GetItemText(Node: TFlyNode) : String;
         //get node on Full search path
         function SetItemText(text : String) : TFlyNode;

         //Adds a new node to a tree.
         function AddChildFirst(Node: TFlyNode; const S: string): TFlyNode;
         //Adds a new node to a tree .
         function AddChild(Node: TFlyNode; const S: string): TFlyNode;
         //Adds a new node containing data to a tree.
         function AddChildObjectFirst(Node: TFlyNode; const S: string;
         Ptr: Pointer): TFlyNode;
         //Adds a new node containing data to a tree.
         function AddChildObject(Node: TFlyNode; const S: string;
         Ptr: Pointer): TFlyNode;
         //Adds a new node to a tree.
         function AddFirst(Node: TFlyNode; const S: string): TFlyNode;
         //Adds a new node to a tree control.
         function Add(Node: TFlyNode; const S: string): TFlyNode;
         //Adds a new node containing data to a tree .
         function AddObjectFirst(Node: TFlyNode; const S: string;
         Ptr: Pointer): TFlyNode;
         //Adds a new node containing data to a tree .
         function AddObject(Node: TFlyNode; const S: string;
         Ptr: Pointer): TFlyNode;
         //Discards any current property information and replaces it with the information from the Source
         procedure Assign(Source: TPersistent); override;
         //Prevents the updating of the tree until the EndUpdate method is called.
         procedure BeginUpdate; override;
         //procedure BeginUpdateMinCapacity(MinCapacity : integer); override;
         //Re-enables screen repainting and node reindexing that was turned off with the BeginUpdate method.
         procedure EndUpdate; override;
         //service functions
         //Assign TreeNodes property information to FlyNodes object
         //procedure AssignTreeNodesToFlyNodes(aTTree : TTreeView);
         //Assign FlyNodes object property information to TreeNodes object of standard TreeView control
         //procedure AssignFlyNodesToTreeNodes(aTTree : TTreeView);
         //Deletes all nodes contained from the list managed by TFlyNodes.
         procedure Clear;
         // Removes a node from the tree.
         procedure Delete(Node: TFlyNode);
         //Returns the first tree node in the tree
         function GetFirstNode: TFlyNode;
         function GetLastNode : TFlyNode;
         function GetFirstSelectedNode : TFlyNode;
         function GetLastSelectedNode : TFlyNode;
         function GetNextSelectedNode(aNode : TFlyNode) : TFlyNode;
         function GetPrevSelectedNode(aNode : TFlyNode) : TFlyNode;
         //Call AlphaSort to sort the tree alphabetically. If successful, the method returns True.
         function AlphaSort: Boolean;
         //Inserts a tree node into the tree before the node specified by the Node parameter
         function Insert(Node: TFlyNode; const S: string): TFlyNode;
         //Inserts a tree node containing data into the tree before the node specified by the Node parameter
         function InsertObject(Node: TFlyNode; const S: string;
         Ptr: Pointer): TFlyNode;
         //Lists all nodes managed by the TFlyNodes object
         property Item[Index: Integer]: TFlyNode read GetNodeFromIndex; default;
         //Specifies the tree control that uses the tree nodes object to implement its Items property
         property Tree: TCustomRapidTree read GetTree;
         //Specifies default StateIndex on creating new node
         property DefaultStateIndex : integer read FDefStateIndex write FDefStateIndex default 0;
         //Specifies default ImageIndex on creating new node
         property DefaultImageIndex : integer read FDefImageIndex write FDefImageIndex default 0;
         //Specifies default SelectedIndex on creating new node
         property DefaultSelectedIndex : integer read FDefSelectedIndex write FDefSelectedIndex default 0;
         property ItemSeparator : String read FItemSeparator Write SetItemSeparator;
   end;

   TFTVChangingEvent = procedure(Sender: TObject; Node: TFlyNode;
   var AllowChange: Boolean) of object;
   TFTVChangedEvent = procedure(Sender: TObject; Node: TFlyNode) of object;
   TFTVEditingEvent = procedure(Sender: TObject; Node: TFlyNode;
   var AllowEdit: Boolean) of object;
   TFTVEditedEvent = procedure(Sender: TObject; Node: TFlyNode; var S: string) of object;
   TFTVExpandingEvent = procedure(Sender: TObject; Node: TFlyNode;
   var AllowExpansion: Boolean) of object;
   TFTVCollapsingEvent = procedure(Sender: TObject; Node: TFlyNode;
   var AllowCollapse: Boolean) of object;
   TFTVExpandedEvent = procedure(Sender: TObject; Node: TFlyNode) of object;
   TFTVCompareEvent = procedure(Sender: TObject; Node1, Node2: TFlyNode;
   var Compare: Integer) of object;


   TSelectionDirection = (sdNone, sdGoUp, sdGoDown);
   TOutlineStyle = (olsStandardTree, olsExplorer, olsExcel);
   TNodeSelectionStyle = (tnsCell, tnsTextOnly);
   TISDragType = (dtStandard, dtOLE);

{   TCachedNode = record
     Node : TFlyNode;
     H : integer;
   end;
}

   TISVertAlign = (tvaTop, tvaBottom, tvaCenter);

   TCustomRapidTree = class(TCustomExGrid)
   private
         { Private declarations }
         //usi
         FEnumerateNodes : Boolean;
         FAnimatedEC : Boolean;
         FExpanding : boolean;
         FRightClickSelect: Boolean;
         FHTMLDrawing : boolean;
         //FMousedown : boolean;
         FFitHeight, FFitWidth  : boolean;
         FButtonSize : integer;
         //new
         FNodeSelectionStyle : TNodeSelectionStyle;
         FOutlineStyle : TOutlineStyle;
         //FRClickNode: TFlyNode;
         FanchorNode,LastSel      : TFlyNode;
         FOleDragPoint : TPoint;
         FImageHotSpot : TPoint;
         FNeedToShowEditor                                  : boolean;
         FAutoMove                                          : Boolean;
         FColumnsMap                                        : TList;
         FStructureCol                                      : integer;
         FAutoExpand                                        : Boolean;
         FColSized, FRowSized                               : integer;//use for determine sizing cols/rows
         FWithoutFixup                                      : boolean;
         FRootNode                                          : TFlyNodes;
         FHotTrack                                          : Boolean;
         FHotTrackColor                                     : TColor;
         FDragBeginned, FDragged                            : Boolean;
         //tooltip management
         FToolTips                                          : Boolean;
         FOutlineColor, FTooltipColor                                      : TColor;
         FToolTipPause                                      : integer;
         FtoolTip                                           : TISHTMLHintWindow;//THintWindow;
         FToolTipNode                                       : TFlyNode;
         FtooltipCol                                        : integer;
         FDragNode                                          : TFlyNode;
         FStatesDrawed : Boolean;
         FTimer                                             : TTimer;
         //hottrack
         FHotTrackedRow                                     : integer;
         FIndicators                                        : TImagelist;
         FSortType                                          : TSortType;
         //
         FDragImage                                         : {$IFDEF DFS_COMPILER_4_UP} TISDragImageList{$ELSE}TCustomImagelist{$ENDIF};
         FInternalDragImage                                 : {$IFDEF DFS_COMPILER_4_UP} TDragImageList{$ELSE}TCustomImagelist{$ENDIF};
         {$IFDEF ACTIVEX}
         {$IFNDEF Registered}
         FSkipProp : Boolean;
         {$ENDIF}
         {$ENDIF}
         {$IFDEF DFS_COMPILER_4_UP}
           Fimages : TCustomImagelist;
         {$ELSE}
         Fimages                                            : TImagelist;
         {$ENDIF}

         FImageChangeLink                                   : TChangeLink;
         FTransparentMode                                   : Boolean;
         //FMoveIndex, FMovePos: Longint;

         FLastDropTarget                                    : TFlyNode;
         FManualNotify                                      : boolean;
         FHideSelection                                     : Boolean;
         FWordwrap                                          : boolean;
         //cut/copy/paste management
         FOnPasteSelection : TNotifyEvent;
         FOnCopySelection : TNotifyEvent;
         FOnCutSelection : TNotifyEvent;

         FOnEditing                                         : TFTVEditingEvent;//
         FOnEdited                                          : TFTVEditedEvent;
         FOnExpanded                                        : TFTVExpandedEvent;
         FOnExpanding                                       : TFTVExpandingEvent;
         FOnCollapsed                                       : TFTVExpandedEvent;
         FOnCollapsing                                      : TFTVCollapsingEvent;
         FOnChanging                                        : TFTVChangingEvent;
         FOnChange                                          : TFTVChangedEvent;
         FOnCompare                                         : TFTVCompareEvent;
         FOnDeletion                                        : TFTVExpandedEvent;
         FOnGetSelectedIndex                                : TFTVExpandedEvent;
         FOnGetImageIndex                                   : TFTVExpandedEvent;

         Findent                                            : integer;
         FShowButtons, FShowLines, FShowRoot, FShowLogic, FShowImages: boolean;

         FFirstLevel : Boolean;
         //Ole-drag-drop support
         {$ifdef DFS_COMPILER_4_UP}
         FDragType  : TISDragType;
         FDropTarget: TOLEDropTarget;
         FDropSource : TOLEDropSource;

         //ole-drag-drop support
         //target support
         FOnOLEDragOver : TDropTargetEvent;
         FOnOLEDragDrop : TDropTargetEvent;
         FonOLEGiveFeedback : TFeedbackEvent;
         FOnCompleteDrag : TCompleteDragEvent;
         FonStartDrag    : TStartDragEvent;
         FOnSetData      : TSetDataEvent;
         procedure DoOleDrag(X,Y : integer);
         {$endif}
         function GetCX(NLevel : integer) : integer; // center lvertical line unified
         procedure SetButtonSize(const Value : integer);
         //AOD
         function ExtractNodeFromMetaNode(aIndex: Integer; MetaNode : TMetaNode): TFlyNode;
         procedure SelectOne(aRow : integer);
         procedure SetTransparentMode(Value : boolean);
         procedure WriteData(Stream: TStream);
         procedure ReadData(Stream: TStream);
         procedure SetNodes(Value: TFlyNodes);
         procedure SetIndent(Value : integer);
         procedure SetShowButtons(Value : Boolean);
         procedure SetShowLines(Value : Boolean);
         procedure SetShowLogic(Value : Boolean);
         procedure SetShowRoot(Value : Boolean);
         procedure SetShowImages(Value : Boolean);
         procedure SetStructureCol(Value : integer);
         function GetStructureCol : integer;
         procedure SetWordWrap(Value : Boolean);
         function GetSelection: TFlyNode;
         procedure SetSelection(Value: TFlyNode);
         procedure SetOutlineColor(Value : TColor);
         function GetTopItem: TFlyNode;
         procedure SetTopItem(Value: TFlyNode);
         procedure SetHotTrack(Value: Boolean);
         procedure SetHotTrackColor(Value : TColor);
         procedure SetTrackedNode(aRow : Integer);
         procedure SetAutoExpand(Value: Boolean);
         procedure SetHideSelection(Value: Boolean);
//         procedure WMTimer(var Msg: TWMTimer); message WM_TIMER;
         procedure WMMouseMove(var Message: TMessage); message WM_MOUSEMOVE;
         //procedure WMMouseLeave(var Message: TMessage); message WM_MOUSELEAVE;
//         procedure WMSetCursor(var Msg: TWMSetCursor); message WM_SETCURSOR;
         procedure WMLButtonUp(var Message: TWMLButtonUp); message WM_LBUTTONUP;
         procedure WMRButtonUp(var Message: TWMRButtonUp); message WM_RBUTTONUP;
         procedure CMMouseLeave(var message: TMessage); message CM_MOUSELEAVE;
         procedure WMChar(var Msg: TWMChar); message WM_CHAR;
         procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
//         procedure WMSize(var Message: TWMSize); message WM_SIZE;
         //drag'n'drop

         //cut/copy/paste management
         //procedure WMCopy(var Message: TMessage); message WM_COPY;
         //procedure WMPaste(var Message: TMessage); message WM_PASTE;
         //procedure WMCut(var Message: TMessage); message WM_CUT;
         //images manipulation
         procedure SetImages(Value: {$IFDEF DFS_COMPILER_4_UP} TCustomImageList {$ELSE} TImagelist {$ENDIF});
         procedure ImageListChange(Sender: TObject);//notifaction
         //procedure InvalidateImages(aCanvas : TCanvas; aRow : Longint; aNode: TFlyNode);
         //sort
         procedure SetSortType(Value: TSortType);
         function GetFixedRows : integer;
         procedure SetFixedRows(Value : integer);
         //incsearch
         function IncSearch(aNode : TFlyNode; aKey : Char) : TFlyNode;
         //tooltip managament
         function ActivateToolTips(X,Y : integer) : Boolean;
         procedure SetToolTips(Value: Boolean);//tt
         procedure StopToolTipTimer;//tt
         procedure StartToolTipTimer(Value: Integer);//tt
         procedure TimerProc(Sender : Tobject);//
         procedure HideToolTip;//
         procedure DrawStructureButtonsLines(aCanvas : TCanvas; aNode : TFlyNode; aRow : Longint; aCol : integer; var aRect : TRect; aState : TExGridDrawState; aDrawOptions : TDrawOptions);
         procedure InternalLineTo(aCanvas : TCanvas; X,Y  : integer; VLine : boolean);
         //drag'n'drop
         procedure CMDrag(var Message: TCMDrag); message CM_DRAG;
         procedure DoDragOver(Source: TDragObject; X, Y: Integer; CanDrop: Boolean);
         function GetDropTarget: TFlyNode;
         procedure SetDropTarget(Value: TFlyNode);
         function DrawImagelistPic(aCanvas : TCanvas; aNode : TFlyNode; index :  integer; DrawRect : TRect) : TRect;
         procedure DrawButton(aCanvas : TCanvas; aNode : TFlyNode; aindex :  integer; aRect : TRect);
         procedure SetFitToHeight(Value : boolean);
         procedure SetFitToWidth(Value : boolean);
         procedure SetStatesDrawed(Value : boolean);
         procedure SetHTMLDrawing(Value : boolean);
//         procedure SetRClickNode(aNode : TFlyNode);
         procedure SetOutlineStyle(Value : TOutlineStyle);
         procedure SetNodeSelectionStyle(Value : TNodeSelectionStyle);

         //ole drag/drop support
         {$ifdef DFS_COMPILER_4_UP}
         procedure SetDragType(Value: TISDragType);
         procedure UpdateDropTarget;
         function GetDragText : String;
         {$endif}
         //usi
         procedure SetEnumerateNodes(Value : Boolean);
         procedure EnumerateNodes;
         function CalcNodeHeight(aNode : TFlyNode; aCol : integer) : integer;
         procedure InvalidateRectBelow(aNode : TFlyNode);
         procedure RefreshRowHeights;
      protected
         FAsFocused : Boolean;
         procedure InternalSetRow(Value: Longint); override;//4/26/2
         function BeginColumnDrag(var Origin, Destination: Longint;
           const MousePt: TPoint): Boolean; override;
         procedure ColumnWidthChanged(Index, Value : integer); override;
         procedure CalcSizingState(X, Y: Integer; var State: TGridState; var Index: Longint; var SizingPos, SizingOfs: Integer; var FixedInfo: TExGridDI); override;
         procedure SetRowHeights(Index: Longint; Value: Integer);override;//new 3/4/2
         function GetRowHeights(Index: Longint): Integer; override;
         function GetColWidths(Index: Longint): Integer; override;//new 11/9/1
//         procedure RecalcRowHeight(aRow: Integer); dynamic;//, ColWidth : Integer); dynamic;
         procedure CreateWindowHandle(const Params: TCreateParams); override;
         function GetAlignment(Col : integer) : TAlignment; virtual;


         {$ifdef DFS_COMPILER_4_UP}
         function DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean; override;
         function DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean; override;
         procedure OLEDragDrop(Sender: TObject; Data : IS_IDataObject; ShiftState: TShiftState; Point: TPoint; var Effect: Longint); dynamic;
         procedure OLEDragOver(Sender: TObject; Data : IS_IDataObject; ShiftState: TShiftState; Point: TPoint; var Effect: Longint); dynamic;
         {$endif}
         //cut/copy/paste management
         procedure PasteSelection; dynamic;
         function GetImages : {$IFDEF DFS_COMPILER_4_UP} TCustomImageList {$ELSE} TImagelist {$ENDIF}; virtual;
         procedure CopySelection;  dynamic;
         procedure CutSelection;   dynamic;
         function SaveNodes : Boolean; virtual;
         Procedure SetFirstLevelDrawMode(aValue : boolean);
         procedure MoveEditor(aCol, aRow : integer; aRect : TRect; Redraw : boolean); override;
         //
         procedure DblClick; override;
         procedure DragOver(Source: TObject; X, Y: Integer; State: TDragState;
            var Accept: Boolean); override;
         //procedure Paint; override;
         function NeedToShowEditor : boolean; override;
         procedure FocusCell(ACol, ARow: Longint; MoveAnchor: Boolean;  Shift: TShiftState; SelWay : TSelectionWay); override;
         function InSelection(aCol, aRow : integer) : Boolean; override;
         //drag'n'drop
         //procedure WndProc(var Message: TMessage); override;
         procedure DoEndDrag(Target: TObject; X, Y: Integer); override;
         procedure DoStartDrag(var DragObject: TDragObject); override;
         function GetDragImages: {$IFDEF DFS_COMPILER_4_UP} TDragImageList{$ELSE}TCustomImagelist{$ENDIF}; override;
         procedure PrepareDragImages(Node : TFlyNode; X,Y : integer; Images : TCustomImagelist);
         function BeginRowDrag(var Origin, Destination: LongInt;
         const MousePt: TPoint): Boolean; override;
         function EndRowDrag(var Origin, Destination: Longint;
         const MousePt: TPoint): Boolean; override;
         //columnsmap
         procedure InitColumnsMap;
         procedure ColCountChanged; override;
         procedure SetSaveCellExtents(Value : Boolean);
         procedure StructureColChanged(OldVal, NewVal : integer); dynamic;
//         procedure Updatewidths; override;
         procedure DefineProperties(Filer: TFiler); override;
         procedure Notification(AComponent: TComponent; Operation: TOperation); override;
         procedure Loaded; override;

         procedure DrawCell(aCanvas : TCanvas; ACol, ARow: Longint; ARect: TRect;
         AState: TExGridDrawState; Var Continue : boolean); override;
         procedure SizeChanged(OldColCount, OldRowCount: Longint); override;
         function SelectCell(var ACol, ARow: Longint; MoveAnchor : Boolean;  Shift: TShiftState; SelWay : TSelectionWay): Boolean; override;
         function ChangeState(Node: TFlyNode; StateIndex : integer): Boolean; virtual;
         //new proc
         procedure Selecting(aCol, aRow : Longint; Node : TFlyNode; Shift: TShiftState; MoveAnchor : Boolean);
         procedure DrawFixed(aCanvas : TCanvas; aRect : TRect; aCol, aRow : Longint; AState: TExGridDrawState; Var Continue : boolean); dynamic;
         procedure DrawDataNode(aCanvas : TCanvas; aNode : TFlyNode; aRect : TRect; aCol, aRow : Longint; AState: TExGridDrawState; Var Continue : boolean); dynamic;
         procedure DrawFixedFrame(aCanvas : TCanvas; aRect : TRect; aCol, aRow : integer; Down : Boolean); override;
         procedure DrawBackground(aCanvas : TCanvas; aRect : TRect; aCol, aRow : Longint; AState: TExGridDrawState); dynamic;
         procedure DrawStructureNode(aCanvas : TCanvas; aNode : TFlyNode; aRect : TRect; aCol, aRow : Longint; AState: TExGridDrawState; Var Continue : boolean); dynamic;
         procedure DrawStructureCellContents(aCanvas : TCanvas; var aRect : TRect; AState: TExGridDrawState; aCol, aRow : Longint; aNode : TFlyNode; aData : string; Valign : TISVertAlign; var aRestore : Boolean; CalcRect : boolean); dynamic;
         //procedure DrawNode(aCanvas : TCanvas; aNode : TFlyNode; aRect : TRect; aCol, aRow : Longint; AState: TExGridDrawState; Var Continue : boolean);
         procedure GetImage(aNode : TFlyNode; index :  integer; Image : TBitmap); dynamic;
         procedure GetBitmap(aNode : TFlyNode; index :  integer; Image : TBitmap);dynamic;
         procedure GetColor(aNode : TFlyNode; aCol, aRow : Longint; AState: TExGridDrawState; var aColor, aFontColor : TColor; var aChanged : boolean); dynamic;
         function CanCollapse(Node: TFlyNode): Boolean; dynamic;
         function CanExpand(Node: TFlyNode): Boolean; dynamic;
         function CanChange(Node: TFlyNode): Boolean; dynamic;//rowchang
         procedure Edited(Node: TFlyNode; var S: string); dynamic;
         procedure Change(Node: TFlyNode); dynamic;

         function CanEditShow: Boolean; override; //

         procedure Expand(Node: TFlyNode); dynamic;
         procedure Collapse(Node: TFlyNode); dynamic;
         procedure Delete(Node: TFlyNode); dynamic;
         //procedure Click; override;

         procedure ColSized(aCol, OldWidth, Width : integer); dynamic;
         procedure RowSized(aRow, OldHeight, Height : integer); dynamic;

         procedure ExpandItem(Node : TFlyNode; Expand : Boolean);virtual;
         procedure SelectItem(Node : TFlyNode);dynamic;
         function CreateNode(AOwner: TTreeCollection) : TFlyNode;virtual;//new
         //mouse manipulation
         procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
         procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
         procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
         X, Y: Integer); override;
         function MouseHit(X,Y : integer) : boolean; override;
         //keyboard
         procedure KeyDown(var Key: Word; Shift: TShiftState); override;
         //procedure KeyPress(var Key: Char); override;

         function GetEditText(ACol, ARow: Longint): string; override;
         procedure SetEditText(ACol, ARow: Longint; const Value: string); override;
         //drag-drop
         procedure RowMoved(FromIndex, ToIndex: Longint); override;
         procedure ColumnMoved(FromIndex, ToIndex: Longint); override;
         procedure InsertRows(atRow, aCount : longint); dynamic;
         procedure DeleteRows(atRow, aCount : longint); dynamic;
         procedure FixupRowHeights(atRow : integer); dynamic;

         //virtual management input/output data
         procedure SetNodeData(Node : TFlyNode; ACol : integer; const Value : string); dynamic;
         function GetNodeData(Node : TFlyNode; ACol : integer) : string; dynamic;
         //procedure Paint; override;
         property Columnsmap : TList read FColumnsmap;
         function  GetNodeCells(Node : TFlyNode; ACol : integer) : string;
         procedure SetNodeCells(Node : TFlyNode; ACol : integer; const Value : string);
      public
         { Public declarations }
         //procedure RecalcRowHeights(BeginRow : Integer; Redraw : Boolean);
         //fixup row basing on FlyNodes information
         procedure FixupRows;
         function RecalcNodeHeight(aNode : TFlyNode) : integer;
         procedure FlushSelection;  // ????????? remove node.FSelected  but remain selection ????
         procedure FillSelectedList(aList : Tlist);//get list of selected items
         procedure InitGlyphs;
         procedure RefreshNodeList(aNode : TFlyNode);
         procedure DrawImage(aCanvas : TCanvas; aBitmap: TBitmap; DrawRect : TRect);
         function  GetHittest : TPoint;
         property ButtonSize : integer read FButtonSize write SetButtonSize default 11;
         //Usi
         property UniqueTags : Boolean Read FEnumerateNodes write SetEnumerateNodes default False;
         //drag-drop
         //Specifies which item in the tree appears as the target of a drag and drop operation
         property DropTarget: TFlyNode read GetDropTarget write SetDropTarget;
         //Generates an OnDragDrop event
         //procedure DragDrop(Source: TObject; X, Y: Integer); override;

         constructor Create(AOwner: TComponent); override;
         destructor Destroy; override;
         //Returns the last visible node in Tree.
         function GetLastVisibleNode : TFlyNode;
         //Returns the next visible node in Tree of a tree node.
         function GetNextVisible(Node : TFlyNode): TFlyNode;
         //Returns the previous visible node in Tree of a tree node.
         function GetPrevVisible(Node : TFlyNode): TFlyNode;
         //Expands the parent nodes of a node.
         procedure MakeVisible(Node : TFlyNode);
         //Indicates whether the tree node is currently visible in the tree image
         function IsNodeVisible(Node : TFlyNode) : Boolean;
         //Returns the bounding rectangle for a tree node.
         function DisplayRect(Node : TFlyNode; TextOnly : Boolean) : TRect;
         //Returns the width for a tree node text.
         function DisplayWidth(Node : TFlyNode) : integer;
         //Returns Node from specified Row
         function GetNodeAtRow(aRow : Longint) : TFlyNode;
         // for compatibility
         //Returns information about the location of a point relative to the client area of the tree control.
         function GetHitTestInfoAt(X, Y: Integer): THitTests;
         //Returns the node that is found at the specified position.
         function GetNodeAt(X, Y: Integer): TFlyNode;
         // for determine order of column before/after move column
         function GetColumnOrder(aCol : integer) : integer;

         //Collapses all the nodes within a tree view control.
         procedure FullCollapse;
         //Expands all nodes within the tree control.
         procedure FullExpand;
         {$IFDEF ACTIVEX}
         {$IFNDEF Registered}
          property RTFDrawing : boolean read FSkipProp write FSkipProp default False;
         {$ENDIF}
         {$ENDIF}
         property SmoothExpandCollapse : boolean read FAnimatedEC write FAnimatedEC default true;
         property NodeSelectionStyle : TNodeSelectionStyle read FNodeSelectionStyle Write SetNodeSelectionStyle default tnsCell;
         property OutlineStyle : TOutlineStyle read FOutlineStyle write SetOutlineStyle default olsStandardTree;
         //Specifies the number of rows on the left of the tree that cannot be scrolled.
         property FixedRows : integer read GetFixedRows write SetFixedRows;
         //Specifies the selected node in the tree
         property Selected: TFlyNode read GetSelection write SetSelection;
         //Specifies the topmost node that appears in the tree
         property TopItem: TFlyNode read GetTopItem write SetTopItem;
         //Determines whether a selected node appears selected when the focus shifts to another control
         property HideSelection : Boolean read FHideSelection write SetHideSelection;
         // Specifies the amount of indentation in pixels when a list of child nodes is expanded
         property Indent : integer read Findent write SetIndent default 20;
         //Lists the individual nodes that appear in the tree control.
         property Items: TFlyNodes read FRootNode write SetNodes;
         //Specifies whether to display the lines that link child nodes to their corresponding parent nodes
         property Showlines : Boolean read FShowLines write SetShowLines;
         // Specifies whether lines connecting top-level nodes are displayed
         property ShowRoot  : Boolean read FShowRoot write SetShowRoot;
         //Specifies whether to display plus (+) and minus (-) buttons to the left side of each parent item
         property ShowButtons : Boolean read FShowButtons write SetShowButtons;
         //Specifies whether to display Checkbox or Radiobutton buttons to the left side of each item
         property ShowLogic : Boolean read FShowLogic write SetShowLogic;
         //Specifies whether to display images to the left side of each item
         property ShowImages : Boolean read FShowImages write SetShowImages;
         //Specifies Column for displaying Tree structure
         property StructureCol : integer read GetStructureCol write SetStructureCol default 0;
         //Specifies whether list items are highlighted when the mouse passes over them
         property HotTrack: Boolean read FHotTrack write SetHotTrack default False;
         property HotTrackColor : TColor Read FHotTrackColor write SetHotTrackColor default clBlue;
         //Specifies whether the nodes in the tree automatically expand and collapse depending on the selection
         property AutoExpand: Boolean read FAutoExpand write SetAutoExpand;// default False;
         //Determines which image list is associated with the tree view
         property Images : {$IFDEF DFS_COMPILER_4_UP} TCustomImageList {$ELSE} TImagelist {$ENDIF} read GetImages write SetImages;
         //Determines if and how the nodes in a tree view are automatically sorted
         property SortType: TSortType read FSortType write SetSortType;// default stNone;
         //Specifies whether the node text wraps when it is too long for the width of the column.
         property WordWrap : boolean read FWordWrap write SetWordWrap;
         property AutoMove : boolean read FAutoMove write FAutoMove;
         //Specifies whether the items in the tree view have tooltips.
         property ToolTips: Boolean read FToolTips write SetToolTips;
         //Specifies color of Tooltip window
         property TooltipColor : TColor read FTooltipColor write FTooltipColor;
         //Specifies pause for displaying tooltip window
         property OutlineColor : TColor read FOutlineColor write SetOutlineColor default clGray;
         property ToolTipPause : integer read FToolTipPause write FToolTipPause;
         Property TransparentMode : Boolean read FTransparentMode write SetTransparentMode;
         property FitToHeight : boolean read FFitHeight write SetFitToHeight;
         property FitColumnToClientWidth : Boolean read FFitWidth write SetFitToWidth default false; 
         property StatesDrawed : Boolean read FStatesDrawed write SetStatesDrawed;
         property Color;
         property Font;
         property Options;
         property RightClickSelect: Boolean read FRightClickSelect write FRightClickSelect default False;
         //HTMLDrawing
         property HTMLDrawing : boolean read FHTMLDrawing write SetHTMLDrawing default False;
         //events
         //Occurs when the user starts to edit the Text property of a node.
         property OnEditing: TFTVEditingEvent read FOnEditing write FOnEditing;
         //Occurs after the user edits the Text property of a node.
         property OnEdited: TFTVEditedEvent read FOnEdited write FOnEdited;
         //Occurs when a node is about to be expanded.
         property OnExpanding: TFTVExpandingEvent read FOnExpanding write FOnExpanding;
         //Occurs after a node is expanded.
         property OnExpanded: TFTVExpandedEvent read FOnExpanded write FOnExpanded;
         //Occurs when a node is about to be collapsed.
         property OnCollapsing: TFTVCollapsingEvent read FOnCollapsing write FOnCollapsing;
         //Occurs after a node has been collapsed.
         property OnCollapsed: TFTVExpandedEvent read FOnCollapsed write FOnCollapsed;
         //Occurs whenever the selection is about to be changed from one node to another.
         property OnChanging: TFTVChangingEvent read FOnChanging write FOnChanging;
         //Occurs whenever the selection has changed from one node to another
         property OnChange: TFTVChangedEvent read FOnChange write FOnChange;
         //Occurs when two nodes must be compared during a sort of the nodes in the tree.
         property OnCompare: TFTVCompareEvent read FOnCompare write FOnCompare;
         //Occurs when a node in the tree is deleted.
         property OnDeletion: TFTVExpandedEvent read FOnDeletion write FOnDeletion;
         //Occurs when the tree looks up the ImageIndex of a node.
         property OnGetImageIndex: TFTVExpandedEvent read FOnGetImageIndex write FOnGetImageIndex;
         //Occurs when the tree looks up the SelectedIndex of a node.
         property OnGetSelectedIndex: TFTVExpandedEvent read FOnGetSelectedIndex write FOnGetSelectedIndex;
         //cut/copy/paste management
         property OnPasteSelection : TNotifyEvent read FOnPasteSelection write FOnPasteSelection;
         property OnCopySelection : TNotifyEvent read FOnCopySelection write FOnCopySelection;
         property OnCutSelection : TNotifyEvent read FOnCutSelection write FOnCutSelection;
         {$ifdef DFS_COMPILER_4_UP}
         // OLE drag drop
         property DragType: TISDragType read FDragType write SetDragType default dtStandard;
         //target events
         property OnOLEDragOver : TDropTargetEvent read FOnOLEDragOver write FOnOLEDragOver;
         property OnOLEDragDrop : TDropTargetEvent read FOnOLEDragDrop write FOnOLEDragDrop;
         property OnOLEGiveFeedback : TFeedbackEvent read FonOLEGiveFeedback Write FonOLEGiveFeedback;
         property OnOLECompleteDrag : TCompleteDragEvent read FOnCompleteDrag Write FOnCompleteDrag;
         property OnOLEStartDrag : TStartDragEvent read FonStartDrag Write FonStartDrag;
         property OnOLESetData : TSetDataEvent read FOnSetData Write FOnSetData;
         {$endif}
      published
         { Published declarations }

   end;


   TRapidTree = class(TCustomRapidTree)
      published
         { Published declarations }
         property ButtonSize; // new 21/12/01
         property SmoothExpandCollapse; //new 24/09/01
         {$ifdef DFS_COMPILER_4_UP}
         property ScrollBarsStyle; //new 24/09/01
         property ScrollBarsColor; //new 24/09/01
         {$endif}
         //new 11/9/01
         property FitColumnToClientWidth;
         //16/06/01
         property UniqueTags;
         //new 18/01/01
         property NodeSelectionStyle;
         property HotTrackColor;
         //new 22.11.2000
         property OutlineColor;
         property OutlineStyle;
         //new 15.03.2000
         property FitToHeight;
         property RightClickSelect;
         {$ifdef DFS_COMPILER_4_UP}
         property DoubleBuffered default true;
         {$endif}
         //new 24.02.2000
         property FixedRowAsButton;
         property FixedColAsButton;
         property LineColor;
         property FixedLineColor;
         property Align;
         property Ctl3D;
         {$ifdef DFS_COMPILER_4_UP}
         property Anchors;
         property Constraints;
         property BiDiMode;
         property DragKind;
         property Canvas;
         property ParentBiDiMode;
         property OnEndDock;
         property OnMouseWheelDown;
         property OnMouseWheelUp;
         property OnMouseWheel;
         property OnStartDock;
         property OnStartDrag;

         {$endif}
         Property TransparentMode;
         property BorderStyle;
         property Color;
         property ColCount;

         property DefaultColWidth;
         property DefaultRowHeight;
         property DragCursor;

         property DragMode;
         property Enabled;
         property FixedColor;
         property FixedCols;
         property RowCount;
         property FixedRows;
         property Font;
         property GridLineWidth;
         property Options;

         property ParentColor;
         property ParentCtl3D;
         property ParentFont;
         property ParentShowHint;
         property PopupMenu;
         property ScrollBars;
         property ShowHint;
         property TabOrder;
         property TabStop;
         property Visible;
         property OnClick;
         property OnColumnMoved;
         property OnDblClick;
         property OnDragDrop;
         property OnDragOver;
         property OnDrawCell;

         property OnEndDrag;
         property OnEnter;
         property OnExit;
         property OnGetEditMask;
         property OnGetEditText;
         property OnKeyDown;
         property OnKeyPress;
         property OnKeyUp;
         property OnMouseDown;
         property OnMouseMove;
         property OnMouseUp;

         property OnRowMoved;
         property OnSelectCell;
         property OnSetEditText;
         property OnTopLeftChanged;
         //added
         property OnEditing;
         //Occurs after the user edits the Text property of a node.
         property OnEdited;
         //Occurs when a node is about to be expanded.
         property OnExpanding;
         //Occurs after a node is expanded.
         property OnExpanded;
         //Occurs when a node is about to be collapsed.
         property OnCollapsing;
         //Occurs after a node has been collapsed.
         property OnCollapsed;
         //Occurs whenever the selection is about to be changed from one node to another.
         property OnChanging;
         //Occurs whenever the selection has changed from one node to another
         property OnChange;
         //Occurs when two nodes must be compared during a sort of the nodes in the tree.
         property OnCompare;
         //Occurs when a node in the tree is deleted.
         property OnDeletion;
         //Occurs when the tree looks up the ImageIndex of a node.
         property OnGetImageIndex;
         //Occurs when the tree looks up the SelectedIndex of a node.
         property OnGetSelectedIndex;
         //new 24.02.2000
         // Occurs when column width has changed
         property OnColumnWidthChanged;
         // Occurs before column width changing
         property OnColumnWidthChanging;
         // Occurs when row height has changed
         property OnRowHeightChanged;
         // Occurs before row height changing
         property OnRowHeightChanging;

         //Tree Properties-------------------------------
         property Indent;
         property HideSelection;
         property Items;
         property Showlines;
         property ShowRoot;
         property ShowButtons;
         property ShowImages;
         property ShowLogic;
         property StructureCol; // Column for TreeNodes
         property HotTrack;
         property Images;
         property SortType;
         property WordWrap;
         property AutoMove;
         //property StateImages;
         property ToolTips;
         property AutoExpand;
         property TooltipColor;
         property ToolTipPause;
         property StatesDrawed;
         //copy/cut/paste management
         property OnPasteSelection;
         property OnCopySelection;
         property OnCutSelection;
         property OnAppendRow;
         // support for RTF-drawing
         property HTMLDrawing;
         // Ole drag drop support events
         {$ifdef DFS_COMPILER_4_UP}
         property DragType;
         property OnOLEDragOver;
         property OnOLEDragDrop;
         property OnOLEGiveFeedback;
         property OnOLECompleteDrag;
         property OnOLEStartDrag;
         property OnOLESetData;
         {$endif}

   end;


function GetCheckSize : integer;
procedure InitDoubleChecks;

var aDCBmp, aGDCBmp : TBitmap;
var
  FCheckWidth: Integer;

implementation

uses Math, IsConst, Consts, ComStrs, ISHTMLDraw  // CEDR 20.09.02 - math for max()
{$IFNDEF Registered}
, FTAbout
{$ENDIF};


function GetCheckSize;
begin
 if FCheckWidth <= 0 then
 begin
  with TBitmap.Create do
    try
      Handle := LoadBitmap(0, PChar(32759));
      FCheckWidth := Width div 4;
    finally
      Free;
    end;
  end;
  Result := FCheckWidth
end;

{function GetCheckSize : integer;
begin
   Result := GetSystemMetrics(SM_CXMENUCHECK)-1;
end;
}
procedure InitDoubleChecks;
begin
   if aDCBmp <> nil then
      aDCBmp.Free;
   if aGDCBmp <> nil then
      aGDCBmp.Free;

   aDCBmp := TBitmap.Create;
   aDCBmp.Handle := LoadBitmap(Hinstance, 'DCIMG');
   aGDCBmp := TBitmap.Create;
   aGDCBmp.Handle := LoadBitmap(Hinstance, 'GDCIMG');

end;

procedure Error(Const ErrStr : String);
begin
   raise ERapidTreeError.Create(ErrStr);//exception
end;

procedure ErrorFmt(const Msg: string; Format: array of const);
begin
  raise ERapidTreeError.CreateFmt(Msg, Format);
end;

{$IFNDEF Registered}
function DecryptStr(const S: String): String;
var
   i : Integer;
const
   C1   = 19715;
   C2   = 17819;
   ISKey= 61072;

begin
   result:='';
   for i:=1 to Length(s) do
      result:=result+Chr( Ord(s[i]) xor i xor IsKey);
end;
{$endif}

const
   IntImages: array[TBitmapArrayRange] of PChar= ('EXPANDED', 'COLLAPSED', 'FOPEN', 'FCLOSED', 'EMPTY', 'CHECKED', 'UNCHECKED', 'GRAYED', 'OPTIONED', 'UNOPTIONED', 'GRAYEDUNCHECKED', 'GRAYEDOPTIONED','GRAYEDUNOPTIONED', 'DOUBLECHECKED', 'GRAYEDDOUBLECHECKED' );


function DefaultSort(aNode1, aNode2: TTreeCollection): Integer; stdcall;
begin
   with TFlyNode(aNode1) do
      if (Tree<> nil) and Assigned(Tree.OnCompare) then
         Tree.OnCompare(Tree, TFlyNode(aNode1), TFlyNode(aNode2), Result)
      else Result := lstrcmp(PChar(aNode1.Caption), PChar(aNode2.Caption));
end;


constructor TCustomRapidTree.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
//   FCachedRow.Node := nil;
   FButtonSize :=  FCheckWidth - 2;
   DoubleBuffered := true;
   //Usi
   FAnimatedEC :=true;
   FEnumerateNodes :=False;
   FAsFocused := False;
   FOutlineStyle := olsStandardTree;
   FHotTrackColor := clBlue;
   FHotTrackedRow := -1;
   FOutlineColor := clGray;
   FStatesDrawed :=True;
   Width := 121;
   Height := 97;
   ParentColor := False;
   FShowButtons:= true;
   FShowLines:= true;
   FShowRoot := true;
   FIndent := 20;
   FStructureCol := 0;
   FColSized :=-1;
   FRowSized :=-1;

   FRootNode := TFlyNodes.Create(Self);
   FrootNode.Add(nil,'TFlyNode');

   FImages := nil;
   FImageChangeLink := TChangeLink.Create;
   FImageChangeLink.OnChange := ImageListChange;
   FColumnsMap := TList.Create;
   InitGlyphs;
   FToolTip:=nil;
   FtoolTips:=false;
   FToolTipPause:=1000;
   FToolTipColor:=clInfoBk;
   FDragImage := {$IFDEF DFS_COMPILER_4_UP} TISDragImageList{$ELSE}TCustomImagelist{$ENDIF}.CreateSize(32, 32);
   InitColumnsMap;
end;

destructor TCustomRapidTree.Destroy;
begin
   FRootNode.Free;
   FIndicators.Free;
   while FColumnsMap.Count<>0 do
   begin
      Dispose(FColumnsMap.Items[0]);
      FColumnsMap.Delete(0);
   end;
   FColumnsMap.Free;
   FImageChangeLink.Free;

   FDragImage.Free;
   {$ifdef DFS_COMPILER_4_UP}
   if FDropSource <> nil then
      FDropsource.Free;
   if FDropTarget <> nil then
      FDropTarget.Free;
   {$endif}
   StopToolTipTimer;
   FtoolTip.Free;
   FtoolTip:=nil;
   inherited Destroy;
end;

procedure TCustomRapidTree.Loaded;
var aNode : TFlyNode;
begin
   FWithoutFixup :=true;

   inherited Loaded;
   FWithoutFixup :=false;

   //FRootNode.FaddedCount:=0;

   RefreshNodelist(nil);
   FixupRows;
   //init ColumnsMap list
   InitColumnsMap;

   if FRootNode.Count = 0 then
     FAnchorNode := nil
   else
     FAnchorNode := FRootNode.Item[0];

   //select first node
   aNode := GetnodeAtRow(Row);
   if aNode <> nil then
     aNode.Selected :=true;

   // CEDR 05.10.02  moved to TCustomFlyTreeView.Loaded because
   //   need to set FVisibleColumns list correctly for expand operation.
   //if csDesigning in ComponentState then
   //   FullExpand;

end;

procedure TCustomRapidTree.SetSaveCellExtents(Value : Boolean);
begin
   FSaveCellExtents := Value; //for future use
end;

procedure TCustomRapidTree.SetOutlineColor(Value : TColor);
begin
   If FOutlineColor <> Value then
   begin
     FOutlineColor := Value;
     Invalidate;
   end;
end;

procedure TCustomRapidTree.ColCountChanged;
begin
   InitColumnsMap;
end;

procedure TCustomRapidTree.InitColumnsMap;
var i  : integer;
   pI : PInt;
begin
   //freeing objects
   if (csLoading in Componentstate) then exit;
   while FColumnsMap.Count<>0 do
   begin
      Dispose(FColumnsMap.Items[0]);
      FColumnsMap.Delete(0);
   end;

   for i:=0 to ColCount-1 do
   begin
      New(pI);
      pI^ :=i;
      FColumnsMap.Add(pI);
   end;
end;

procedure TCustomRapidTree.InitGlyphs; //init default bitmaps
var
   Bmp : TBitmap;
   i   : integer;
begin
   Bmp := TBitmap.Create;
   try
      Bmp.Handle := LoadBitmap(HInstance, IntImages[0]);
      FIndicators := TImageList.CreateSize(Bmp.Width, Bmp.Height);
      for i:=low(IntImages) to High(IntImages) do
      begin
         Bmp.Handle := LoadBitmap(HInstance, IntImages[i]);
         FIndicators.AddMasked(Bmp, clWhite);
      end;
   finally
      Bmp.Free;
   end;
end;

procedure TCustomRapidTree.FixupRows;
//var aNode : TFlyNode;
begin

   if (csloading in ComponentState) and (csReading in ComponentState)
   or (csDestroying in ComponentState) {or not HandleAllocated} then
   begin
      exit;
   end;

   //if FGridstate <> gsSelecting then
   //   aNode := GetNodeAtrow(Row);

   if FrootNode.FNodeList.Count > 0 then
   begin
      RowCount:=FixedRows + FrootNode.FNodeList.Count
   end
   else
   begin
     RowCount:=FixedRows;
     TopRow := FixedRows;
   end;
   if (not FRootNode.FSorted) and (FSortType<>stNone) then
      FRootNode.Alphasort;
   //if FGridstate <> gsSelecting then SetSelection(aNode);
//   if FitToHeight then
//     RecalcRowHeights(FixedRows, False);

   InvalidateGrid;

end;

procedure TCustomRapidTree.FixupRowHeights(atRow : integer);
var i     : integer;
   aNode : TFlyNode;
   cPos  : Trect;
begin
   for i:=atrow to RowCount-1 do
   begin
      aNode := GetNodeAtRow(i);
      if aNode <> nil then
         if aNode.FHeight > 0 then
            RowHeights[i] := aNode.FHeight
         else
            RowHeights[i] := DefaultRowHeight;
   end;

   cPos := BoxRect(0, atRow, Colcount, RowCount);

   if HandleAllocated then
      Windows.InvalidateRect(Handle, @cPos, False);
end;


procedure TCustomRapidTree.DeleteRows(atRow, aCount : longint);
var sm, i, RStep, Step, Filloffset : integer;
    aR : TRect;
    aBmp : TBitmap;
begin
 sm := GetSystemMetrics(SM_SLOWMACHINE);
 if sm = ord(true) then FAnimatedEC:=false;
 if FAnimatedEC then
 begin
   aR := BoxRect(LeftCol, atRow+1, LeftCol+VisibleColCount, atRow+1);
   aR.Bottom := ClientHeight;
   aR.Right := Clientwidth;

   if IntersectRect(aR, aR, ClientRect) then
   begin
      Step := 0;
      for i:=atRow to atRow+aCount-1 do
      begin
        inc(Step, RowHeights[i]);
        if Step > (ar.Bottom-ar.Top) then
        begin
          Step := ar.Bottom-ar.Top;
          break;
        end;
      end;


      Canvas.Brush.Color := Color;
      Filloffset :=0;
      RStep := AnimationInc;
      aBmp := TBitmap.Create;
      try
       aBmp.Width := aR.Right-ar.Left;
       aBmp.Height := aR.Bottom-ar.Top;
       BitBlt(aBmp.Canvas.Handle, 0, 0, aBmp.width, aBmp.height, Canvas.Handle, aR.Left, aR.Top, SRCCOPY);
       while Step > 0 do
       begin
        BitBlt(Canvas.Handle, aR.Left, aR.Top, aR.Right, aR.Bottom, aBmp.Canvas.Handle, 0, FillOffset, SRCCOPY);

        Dec(Step, RStep);//new
        if Step > 0 then
        begin
         inc(Filloffset, RStep);//new
         FillRect(Canvas.Handle, Rect(aR.Left, aR.Bottom-Filloffset, ar.Right, aR.Bottom), Canvas.Brush.handle);
         inc(RStep, AnimationInc);//new
        end;
       end;
     finally
       aBmp.Free;
     end;
   end;
 end;
   if not (csLoading in ComponentState) then
   begin
      for i:=atRow+1 to RowCount-1 do
      begin
         RowHeights[i] := RowHeights[i+aCount];
      end;
   end;
   RowCount :=RowCount - aCount;
end;




procedure TCustomRapidTree.InsertRows(atRow, aCount : longint);
var sm, i,Step, RStep     : integer;
   aR : TRect;
   aBmp : TBitmap;
begin
 //Animation expand
 sm := GetSystemMetrics(SM_SLOWMACHINE);
 if sm = ord(true) then FAnimatedEC:=false;
 if FAnimatedEC then
 begin
   aR := ClientRect; //getsystemmetrics
   aR.Top := BoxRect(LeftCol, atRow, LeftCol+VisibleColCount, atRow+aCount).Top;
   inc(aR.Top, RowHeights[atRow]);
   //ar.Bottom := ClientHeight;
   //ar.Right := Clientwidth;
   if IntersectRect(aR, aR, ClientRect) then
   begin
      Step := 0;
      for i:=atRow to atRow+aCount-1 do
      begin
        inc(Step, RowHeights[i]);
        if Step > (ar.Bottom-ar.Top) then
        begin
          Step := ar.Bottom-ar.Top;
          break;
        end;

      end;
      //Step := AnimationInc*Step;//VisibleRowCount;
      Canvas.Brush.Color := Color;
      RStep := AnimationInc;
      aBmp := TBitmap.Create;
      try
       aBmp.Width := aR.Right-ar.Left;
       aBmp.Height := aR.Bottom-ar.Top;
       BitBlt(aBmp.Canvas.Handle, 0, 0, aBmp.width, aBmp.height, Canvas.Handle, aR.Left, aR.Top, SRCCOPY);

       while Step > 0 do
       begin
        //ScrollWindow(Handle, 0, AnimationInc, @aR, @aR);
        BitBlt(Canvas.Handle, aR.Left, aR.Top , aR.Right, aR.Bottom, aBmp.Canvas.Handle, 0, 0, SRCCOPY);

        FillRect(Canvas.Handle, Rect(aR.Left, ar.Top, ar.Right, aR.Top+Rstep), Canvas.Brush.handle);
        Inc(aR.Top, RStep);
//        Sleep(SleepPeriod);//new
        //Sleep(500);//new
        Dec(Step, RStep);
        inc(RStep,AnimationInc );//new
       end;
      finally
        aBmp.Free;
      end;
   end;
 end;

   RowCount :=RowCount + aCount;
   if not (FFitHeight or (csLoading in ComponentState)) then
   begin
      {for i:=(RowCount - aCount-1) downto AtRow+1 do
      begin
         RowHeights[i+aCount]:=RowHeights[i];
      end;
      //fixup rowheights
      for i:=atRow+1 to atRow+aCount do
      begin
         aNode :=GetNodeAtRow(i);
         if aNode<>nil then
            if aNode.FHeight > 0 then
               RowHeights[i] := aNode.FHeight
            else
               RowHeights[i] := DefaultRowHeight;
      }

      {dec(atrow, fixedrows);//  i - FixedRows
      for i:=atRow+1 to atRow+aCount do
      begin
        aNode :=  TFlyNode(FRootNode.FNodeList[i]);
        //if aNode<>nil then
          if aNode.FHeight > 0 then
             inherited SetRowHeights(i, aNode.FHeight)
          else
             inherited SetRowHeights(i, DefaultRowHeight);

      end;
      }
   end;

end;

procedure TCustomRapidTree.SetNodes(Value: TFlyNodes);
begin
   Items.Assign(Value)
end;

//----

function TCustomRapidTree.GetFixedRows : integer;
begin
   Result := inherited FixedRows;
end;

procedure TCustomRapidTree.SetFixedRows(Value : integer);
begin
   //preventing error message
   if FrootNode.Count=0 then
   begin
      RowCount:=Value+1;
   end
   else if Value >= FRootNode.Count then
     RowCount:=FRootNode.Count+Value;
   inherited FixedRows :=Value;
   FixupRows;
end;

procedure TCustomRapidTree.SetSortType(Value: TSortType);
begin
   if SortType <> Value then
   begin
      FSortType := Value;
      if ((SortType in [stData, stBoth]) and Assigned(OnCompare)) or
        (SortType in [stText, stBoth]) then
         FRootNode.AlphaSort;
   end;
end;

procedure TCustomRapidTree.ImageListChange(Sender: TObject);
begin
 if not (csLoading in Componentstate) then
   if HandleAllocated and Visible then
   begin
      if (Sender = Images) then
         if TCustomImageList(Sender).HandleAllocated then
            Invalidate;
   end;
end;

procedure TCustomRapidTree.Notification(AComponent: TComponent;
Operation: TOperation);
begin
   inherited Notification(AComponent, Operation);
   if Operation = opRemove then
   begin
      if AComponent = FImages then
        FImages := nil;
      //if AComponent = StateImages then StateImages := nil;
   end;
end;

function TCustomRapidTree.GetImages : {$IFDEF DFS_COMPILER_4_UP} TCustomImageList {$ELSE} TImagelist {$ENDIF};
begin
   Result := FImages;
end;

procedure TCustomRapidTree.SetImages(Value: {$IFDEF DFS_COMPILER_4_UP} TCustomImageList {$ELSE} TImagelist {$ENDIF});
begin
   if Images <> nil then
      Images.UnRegisterChanges(FImageChangeLink);
   FImages := Value;
   if Images <> nil then
   begin
      Images.RegisterChanges(FImageChangeLink);
      if not (csDestroying in self.ComponentState) then  // CEDR - 04.10.02 because of assertion in classes.pas
        Images.FreeNotification(Self);
      //SetImageList(Images.Handle, TVSIL_NORMAL)
      if Images.Height > DefaultRowHeight then
         DefaultRowHeight := Images.Height;
      Indent := Images.Width+4;
   end;
   Invalidate;
end;

function TCustomRapidTree.GetColumnOrder(aCol : integer) : integer;
begin
   Result := -1;
   if (aCol>=0) and (aCol < FColumnsMap.Count) then
      Result := PInt(FColumnsMap.items[aCol])^;
end;

Function TCustomRapidTree.GetHittest : TPoint;
begin
    Result:=inherited Hittest;
end;

procedure TCustomRapidTree.SetNodeCells(Node : TFlyNode; ACol : integer; const Value : string);
begin
   if ((aCol <> -1)) and (Node<>nil) then
   begin
      if Node.Fcells=nil then Node.Fcells:=TStringList.Create;
      while (aCol > Node.FCells.Count-1) do Node.FCells.Add('');
      Node.FCells[aCol] := Value;
      if FFitHeight then
      begin
        RecalcNodeHeight(Node);//FHeight := -1;// need to update
        InvalidateRectBelow(Node);
      end
      else
        InvalidateCell(GetColumnOrder(aCol), Node.Getrow);
   end;

end;

procedure TCustomRapidTree.SetNodeData(Node : TFlyNode; ACol : integer; const Value : string);
var i : integer;
begin
   i := GetColumnOrder(aCol);
   SetNodeCells(Node, i, Value);
   if Node <> nil then
      invalidateCell(aCol, Node.Getrow);
end;

procedure TCustomRapidTree.Edited(Node: TFlyNode; var S: string);
begin
  if (Node <> nil) and Assigned(FOnEdited) then
       FOnEdited(Self, Node, S);
end;

procedure TCustomRapidTree.SetEditText(ACol, ARow: Longint; const Value: string);
var aNode  : TFlyNode;
   S      : String;
begin
   aNode := GetNodeAtRow(aRow);
   S := Value;
   Edited(aNode, S);
   if (aCol = FStructureCol)  then
   begin
      //fire event
      if aNode <> nil then
         aNode.Caption := S;
   end
   else
   begin
      if aNode <> nil then
         SetNodeData(aNode, ACol, S);
   end;
end;

function TCustomRapidTree.GetEditText(ACol, ARow: Longint): string;
var aNode : TFlyNode;
begin
   Result:=inherited GetEditText(aCol,aRow);
   aNode := GetNodeAtRow(aRow);
   if Result = '' then
     if (aNode <> nil) and (not aNode.Deleting)then
        Result := GetNodeData(aNode, ACol);
end;

//for virtual management iput/output data

Function TCustomRapidTree.GetNodeCells(Node : TFlyNode; ACol : integer) : string;
begin
//new 31/5/2
{ Result := '';
 if (Node <> nil) and (aCol <>-1) then
 begin
   //dynamic init FCells
   if aCol = GetcolumnOrder(StructureCol) then
     Result:=Node.Text
   else
   begin
     if Node.FCells <> nil then
      if (aCol <= Node.FCells.Count-1) then
        Result := Node.FCells[aCol];
   end;
 end;
}
 Result := GetNodeData(Node, aCol);
end;

Function TCustomRapidTree.GetNodeData(Node : TFlyNode; ACol : integer) : string;
var rCol : integer;
begin
//   Result := GetNodeCells(Node, GetColumnOrder(aCol));//new 31/5/2
 Result := '';
 rCol:=0;
 if rCol < ColCount then
   rCol := GetColumnOrder(aCol)
 else
   rCol := aCol;
 if (Node <> nil) and (aCol <>-1) then
 begin
   //dynamic init FCells
   if rCol = GetcolumnOrder(StructureCol) then
     Result:=Node.Text
   else
   begin
     if Node.FCells <> nil then
      if (rCol <= Node.FCells.Count-1) and (rCol <> -1) then
        Result := Node.FCells[rCol]
      else if (aCol <= Node.FCells.Count-1) then
        Result := Node.FCells[aCol];
   end;
 end;
end;


procedure TCustomRapidTree.SetIndent(Value : integer);
begin
   if (Value <> FIndent) and (Value > FButtonSize) then
   begin
      Findent := Value;
//      if Odd(Findent) then
//        Dec(FIndent);
      Invalidate;
   end;
end;

procedure TCustomRapidTree.SetWordWrap(Value : Boolean);
begin
   if Value <> FWordwrap then
   begin
      FWordWrap :=Value;
      invalidate;
   end;
end;

function TCustomRapidTree.GetStructureCol : integer;
begin
   Result:=FstructureCol;
end;

procedure TCustomRapidTree.StructureColChanged(OldVal, NewVal : integer);
begin
   //for future use;
end;

procedure TCustomRapidTree.SetStructureCol(Value : integer);
var oldVal : integer;
begin
   if Value <> FStructureCol then
   begin
      OldVal := FStructureCol;
//      if (Value <> -1) then
//      begin
//       if (Colcount <= Value ) then
//         Colcount := Value+1;     // CEDR: how about adding columns???
         FStructureCol := Value;
         StructureColChanged(OldVal, Value);
//      end;
      Invalidate;
   end;
   //Showmessage( 'StructureCol='+inttostr(Value)+'ColCount='+Inttostr(ColCount));
end;

procedure TCustomRapidTree.SetShowLogic(Value : Boolean);
begin
   if (Value <> FShowLogic) then
   begin
      FShowLogic := Value;
      Invalidate;
   end;

end;

procedure TCustomRapidTree.SetShowButtons(Value : Boolean);
begin
   if (Value <> FShowButtons) then
   begin
      FShowButtons := Value;
      Invalidate;
   end;
end;

procedure TCustomRapidTree.SetShowLines(Value : Boolean);
begin
   if (Value <> FShowLines) then
   begin
      FShowLines := Value;
      Invalidate;
   end;
end;

procedure TCustomRapidTree.SetShowImages(Value : Boolean);
begin
   if (Value <> FShowImages) then
   begin
      FShowImages := Value;
      Invalidate;
   end;
end;

procedure TCustomRapidTree.SetShowRoot(Value : Boolean);
begin
   if (Value <> FShowRoot) then
   begin
      FShowRoot := Value;
      Invalidate;
   end;
end;

function TCustomRapidTree.GetSelection: TFlyNode;
begin
 if Selection.Top > -1 then
   Result:=GetNodeAtRow(Row)
 else Result := nil;
end;

procedure TCustomRapidTree.SetSelection(Value: TFlyNode);
var aRow : integer;
begin
  if Value <> nil then
  begin
    Value.MakeVisible;
    aRow := Value.GetRow;

    if (aRow <> -1) and ((aRow <> Row) or not Value.Selected) then begin   // CEDR 05.10.02 - Roy's proposal
      FocusCell(Col, aRow, True, [], swNone);
      Flushselection;
  //        SetRClickNode(nil);
      Value.FSelected := True;
    end;
  end
  else
  begin
   ClearSelection;
   Flushselection;
   if goRowSelect in Options then
     InvalidateRow(Row)
   else InvalidateCell(Col, Row);
  end;
end;

function TCustomRapidTree.GetTopItem: TFlyNode;
begin
   Result:=GetNodeAtRow(TopRow);
end;

procedure TCustomRapidTree.SetAutoExpand(Value: Boolean);
begin
   if FAutoExpand <> Value then
   begin
      FAutoExpand := Value;
   end;

end;

procedure TCustomRapidTree.SetHotTrackColor(Value : TColor);
begin
   if Value <> FHotTrackColor then
   begin
     FHotTrackColor := Value;
   end;
end;

procedure TCustomRapidTree.SetHotTrack(Value: Boolean);
begin
   if (Value <> FHotTrack) then
   begin
      FHotTrack := Value;
   end;
   if FStructureCol < FixedCols then
      FHotTrack :=false;
end;

procedure TCustomRapidTree.SetTopItem(Value: TFlyNode);
begin
   Value.MakeVisible;
   TopRow := Value.GetRow;
end;

procedure TCustomRapidTree.GetImage(aNode : TFlyNode; index :  integer; Image : TBitmap);
begin
   with FIndicators do
      GetBitmap(index, Image);
end;

procedure TCustomRapidTree.GetBitmap(aNode : TFlyNode; index :  integer; Image : TBitmap);
begin
 if Assigned(Images) then
   with Images do
   begin
      GetBitmap(index, Image);
   end;
end;

//service function
procedure TCustomRapidTree.DrawImage(aCanvas : TCanvas; aBitmap: TBitmap; DrawRect : TRect);
var Pt      : TPoint;
begin
   with DrawRect do
   begin
     Pt.X:=left + ((FIndent - aBitmap.Width{FIndicators.width}) div 2);
     Pt.Y:=Top + (((Bottom - Top) - aBitmap.Height{FIndicators.Height}) div 2);
   end;
   {$IFDEF DFS_COMPILER_2}
    aCanvas.Brushcopy(rect(Pt.X, Pt.Y, Pt.X+aBitmap.Width{FIndicators.width}, Pt.Y+aBitmap.Height{FIndicators.Height}),aBitmap,
    Rect(0,0, aBitmap.Width{FIndicators.width}, aBitmap.Height{FIndicators.Height}), abitmap.canvas.pixels[0, aBitmap.Height-1]);
   {$ELSE}

   aBitmap.Transparent:=true;
   aBitmap.TransparentColor:=aBitmap.Canvas.Pixels[aBitmap.Width-1,aBitmap.height-1];//Canvas.Pixels[Pt.X,Pt.y];//
   aBitmap.TransparentMode := tmAuto;
   {$ifdef DFS_DELPHI_4_UP}
    if UseRightToLeftAlignment then
      aCanvas.StretchDraw(rect(Pt.X+aBitmap.Width, Pt.Y,Pt.X , Pt.Y+aBitmap.Height),aBitmap)
    else
   {$endif}
     aCanvas.StretchDraw(rect(Pt.X, Pt.Y, Pt.X+aBitmap.Width, Pt.Y+aBitmap.Height),aBitmap);
   {$ENDIF}
//  end;
end;


procedure TCustomRapidTree.SetHTMLDrawing(Value : boolean);
begin
   if FHTMLDrawing <> Value then
   begin
     FHTMLDrawing := Value;
     Invalidate;
   end;
end;

procedure TCustomRapidTree.SetStatesDrawed(Value : boolean);
begin
   if Value<>FStatesDrawed then
   begin
      FStatesDrawed:=Value;
      InvalidateGrid;
   end;
end;

procedure TCustomRapidTree.SetFitToWidth(Value : Boolean);
begin
   if FFitWidth <> Value then
   begin
       FFitWidth := Value;
       UpdateScrollRange;
       if FFitWidth then
         InvalidateGrid;
   end;
end;

procedure TCustomRapidTree.SetFitToHeight(Value : boolean);
begin
   if FFitHeight <> Value then
   begin
       FFitHeight := Value;
       RefreshRowHeights;
       InvalidateGrid;
   end;
end;


function TCustomRapidTree.DrawImagelistPic(aCanvas : TCanvas; aNode : TFlyNode; index :  integer; DrawRect : TRect) : TRect;
var Pt      : TPoint;
   aBitmap : TBitmap;
   Oldcolor : TColor;
begin
   if (FIndicators<>nil) and (index < FIndicators.Count) then
      with FIndicators do
      begin
         //FIndicators.DrawingStyle := dsTransparent;
         //Calculate centering Point
         aBitmap := TBitmap.Create;
         try
            GetImage(aNode, index, aBitmap);
            {$ifdef DFS_COMPILER_3_UP}
            aBitmap.HandleType:=bmDDB;
            {$ENDIF}
            with DrawRect do
            begin
               Pt.X:=left + ((FIndent - aBitmap.Width) div 2);
               Pt.Y:=Top + (((Bottom - Top) - aBitmap.Height) div 2);
            end;
            Result:= rect(Pt.X, Pt.Y, Pt.X+aBitmap.Width, Pt.Y+aBitmap.Height);
            {$IFDEF DFS_COMPILER_2}
            aCanvas.Brushcopy(Result,aBitmap,
            Rect(0,0, aBitmap.Width, aBitmap.Height), abitmap.canvas.pixels[0, aBitmap.Height-1]);
            {$ELSE}
            if FTransparentmode then
            begin
             aBitmap.Transparent:=true;
             aBitmap.TransparentColor:=aBitmap.Canvas.Pixels[aBitmap.Width-1,aBitmap.height-1];//Canvas.Pixels[Pt.X,Pt.y];//
             aBitmap.TransparentMode := tmAuto;
            end;
             {$ifdef DFS_DELPHI_4_UP}
             if UseRightToLeftAlignment then
             begin
               Result:= rect(Pt.X, Pt.Y, Pt.X+aBitmap.Width, Pt.Y+aBitmap.Height);
               //aCanvas.Fillrect(Result); removed 1.08.2000
               //if not FTransparentMode then
               //aCanvas.Fillrect(Result);
               aCanvas.StretchDraw(Result, aBitmap)
             end
             else
             begin
             {$endif}
              //DrawRect := rect(Pt.X+aBitmap.Width, Pt.Y,Pt.X+aBitmap.Width, Pt.Y+aBitmap.Height);
              Result := rect(Pt.X, Pt.Y, Pt.X+aBitmap.Width, Pt.Y+aBitmap.Height);
              OldColor := aCanvas.Brush.Color;
              aCanvas.Brush.Color:=aCanvas.Pixels[math.max(Result.Left,0), Result.Top];  // CEDR 20.09.02 maybe better use own MAX function and dont include math unit?
              try
               aCanvas.FillRect(Result);
               aCanvas.StretchDraw(Result,aBitmap);
              finally
                aCanvas.Brush.Color := OldColor;
              end;
             {$ifdef DFS_DELPHI_4_UP}
             end;
             {$endif}
             {$ENDIF}
         finally
            aBitmap.free;
         end;
      end;
end;

procedure TCustomRapidTree.SetHideSelection(Value: Boolean);
begin
   if FHideSelection <> Value then
   begin
      FHideSelection := Value;
      InvalidateCell(Col, Row);
   end;
end;

procedure TCustomRapidTree.SetTrackedNode(aRow : Integer);
var aRectNode : TRect;
begin
   if (aRow <> FHotTrackedRow) then
   begin
      if FHotTrackedRow <> -1 then
      begin
         invalidateCell(FStructureCol, FHotTrackedRow);
      end;
      FHotTrackedRow := aRow;
      if FHotTrackedRow  <> -1 then
      begin
         //new 30.01.2001 - replace
         //InvalidateCell(FStructureCol, FHotTrackedRow);
         aRectNode:=CellRect(FStructureCol, FHotTrackedRow);
         //!!!! - here - invalidation without change background
         Windows.InvalidateRect(Handle, @aRectNode, False);
      end;
 end;
end;


procedure TCustomRapidTree.CMMouseLeave(var message: TMessage);
begin
   if FHottrack then
      SetTrackedNode(-1);
   if Tooltips then
   begin
      HideToolTip;
      FToolTipNode:=nil;
      FtooltipCol:=-1;
   end;
end;

function TCustomRapidTree.GetDropTarget: TFlyNode;
var arow : Longint;
begin
   Result:=nil;
   if HandleAllocated then
   begin
      aRow := GetDropTargetRow;
      if aRow <>-1 then
         Result := getNodeatRow(aRow);
      if Result = nil then Result := FLastDropTarget;
   end
   else Result := nil;

end;

procedure TCustomRapidTree.FlushSelection;
var
    FR,LR, i : integer;
    Rect : TGridRect;
begin
    // it's more faster

    FR :=-1; LR:=-1;
    if (csLoading in ComponentState) or (csReading in ComponentState) or (csDestroying in ComponentState)  or
    (FRootNode.FNodeList.Count=0) then exit;
    for i:=0 to FRootNode.FNodeList.Count-1 do
    begin
      if TObject(FRootNode.FNodeList[i]) is TFLyNode then
       if TFlyNode(FRootNode.FNodeList[i]).Selected then
       begin
         TFlyNode(FRootNode.FNodeList[i]).FSelected:=false;
         if FR=-1 then FR:=i;
         LR := i; //last row for invalidation
       end;
    end;
    if (FR<>LR) then
    begin
      with Rect do
      begin
       if goRowSelect in Options then
         Left := 0
       else
         Left := Selection.Left;
       Right := Selection.Right;
       Top := Fr+FixedRows;
       Bottom := Lr+FixedRows;
      end;
      InvalidateRect(Rect);
    end;
end;

procedure TCustomRapidTree.SetDropTarget(Value: TFlyNode);
begin
   if HandleAllocated then
      if Value <> nil then
      begin
       if not Value.DropTarget then
       begin
        if GetGridstate <> gsRowmoving then
           SetGridState(gsRowmoving);
        FlastDropTarget := GetNodeAtRow(GetDropTargetRow);
        If goRowSelect in Options then
          invalidateRow(GetDropTargetRow)
        else
          invalidateCell(FStructurecol, GetDropTargetRow);

          SetDroptargetrow(Value.Getrow);

        If goRowSelect in Options then
           InvalidateRow(GetDropTargetRow)
        else
           invalidateCell(FStructurecol, GetDropTargetRow);
       end;

      end
      else
      begin
         SetDropTargetRow(-1);
         if FlastDropTarget <> nil then
         If goRowSelect in Options then
           invalidateRow(FlastDropTarget.GetRow)
         else
           invalidateCell(FStructurecol, FlastDropTarget.GetRow);
      end;
end;

//cut/copy/paste management
//procedure TCustomRapidTree.WMCopy(var Message: TMessage);
//begin
//   if (not EditorMode) then CopySelection;
//end;
//procedure TCustomRapidTree.WMPaste(var Message: TMessage);
//begin
//  if (not EditorMode)  then PasteSelection;
//end;

//procedure TCustomRapidTree.WMCut(var Message: TMessage);
//begin
//  if (not EditorMode)  then CutSelection;
//end;

procedure TCustomRapidTree.CutSelection;
begin
  if Assigned(OnCutSelection) then
     OnCutSelection(Self);
end;

procedure TCustomRapidTree.CopySelection;
begin
  if Assigned(OnCopySelection) then
     OnCopySelection(Self);
end;

procedure TCustomRapidTree.PasteSelection;
begin
  if Assigned(OnPasteSelection) then
     OnPasteSelection(Self);

end;


procedure TCustomRapidTree.WMLButtonDown(var Message: TWMLButtonDown);
var
   Node     : TFlyNode;
   aCol, aRow : integer;
   ht : THitTests;
begin
   FDragged := False;
   FDragNode := nil;
   try
      //!!!this hit test should be BEFORE inherited handler!!!
      ht := GetHittestinfoat(Message.XPos, Message.YPos);
      if EditorMode then
         EditorMode :=false;
      inherited;
      //SetFocus;
      if {(DragMode = dmAutomatic)} {$IFDEF DFS_COMPILER_4_UP} {and} (DragKind = dkDrag){$ENDIF} then
      begin
         if FDragged {$ifdef DFS_COMPILER_4_UP}or (FDragType = dtOle) {$endif}then
         begin
            Node := GetNodeAt(Message.XPos, Message.YPos);
            if (Node <> nil) and (([htOnIndent,htOnIcon,htOnButton] * ht = [])  and (htonItem in ht)) then
            begin
               Node.Focused := True;
               if not EditorMode then
               With Message do
               begin
                 MousetoCell(XPos, YPos, aCol, aRow);
                 if (aCol >= FixedCols) and (aRow >= FixedRows) then
                 begin
                  FoleDragPoint.X := XPos;
                  FoleDragPoint.Y := YPos;
                 end; 
               end;
            end;
         end;
      end;
   finally
      FDragNode := nil;
   end;
end;

{$ifdef DFS_COMPILER_4_UP}
function TCustomRapidTree.GetDragText : String;
var
  i: Integer;
  ANode: TFlyNode;
  NodeStr: string;
begin
  Result := '';
  if Items.Count > 0 then
  begin
    ANode := Items.GetFirstSelectedNode;
    while ANode <> nil do
    begin
      NodeStr := '';
      for i := 0 to ANode.Level - 1 do
        NodeStr := NodeStr + ' '{TabChar};

      for i:=Selection.Left to Selection.Right do //add Cells info
      begin
        if i <> 0 then //getedit
          NodeStr := NodeStr + Tabchar;
        NodeStr := NodeStr + GetEditText(i, aNode.getRow);//aNode.Cells[i];
      end;
      NodeStr := NodeStr + EndOfLine;
      Result:= Result + NodeStr;
      ANode := Items.GetNextSelectedNode(ANode);
    end;
  end;
end;
{$endif}

procedure TCustomRapidTree.MoveEditor(aCol, aRow : integer; aRect : TRect; Redraw : boolean);
var aNode : TFlyNode;
begin
  if aCol = StructureCol then
  begin
    aNode := GetNodeatRow(aRow);
    if aNode<>nil then
      aRect := aNode.DisplayRect(true);
  end;
  inherited MoveEditor(aCol, aRow, aRect, Redraw);
end;

procedure TCustomRapidTree.DblClick;
begin
   inherited;
end;

procedure TCustomRapidTree.PrepareDragImages(Node : TFlyNode; X,Y : integer; Images : TCustomImagelist);
var abmp : TBitmap;
    aCoord : TGridCoord;
    //aWRect,
    aCellRect : TRect;
    DrawInfo: TExGridDI;
    i,j, FirstVisrow, LastVisrow, aTop, aLeft : integer;
begin
  if Node <> nil then
  begin
    aBmp := TBitmap.Create;
    FDragImage.Clear;
    CalcDI(DrawInfo);
    try
     //multiselected
     aCoord := MouseCoord(X,Y);
     if (goRangeSelect in Options) then
     begin
       //calculate Bmp size
       FirstVisrow :=-1;
       LastVisrow := FirstVisRow;
       for i:= Toprow to TopRow+VisibleRowcount do
       if Getnodeatrow(i) <> nil then
       begin
          if Getnodeatrow(i).Selected then
          begin
           if (FirstVisrow = -1) then
              FirstVisrow := i;
           LastVisRow := i;
          end;
       end
       else Break;

       aCellRect := BoxRect(Selection.Left, FirstVisrow, Selection.Right, LastVisrow);
       with aCellRect do
       begin
        aBmp.Height:= Bottom-Top;
        aBmp.Width := Right - Left;
       end;
       aTop := 0;
       for i := FirstVisRow to LastVisrow do
       begin
          aLeft :=0;
          if Getnodeatrow(i).Selected then
           for j:= Selection.Left to Selection.right do
           begin
            DrawCells(aBmp.Canvas, j, aCoord.Y, aLeft, aTop, aLeft+ColWidths[j], aTop+RowHeights[i], Color, [gdNoUseSelColor], DrawInfo, False);
            inc(aLeft, ColWidths[j]);
           end;
          inc(aTop, RowHeights[i]);
       end;
      end
     else
     begin
        aCellRect := CellRect(aCoord.X, aCoord.Y);
        with aCellRect do
        begin
         aBmp.Height := Bottom-Top;
         aBmp.Width := Right - Left;
        end;
        DrawCells(aBmp.Canvas, aCoord.X, aCoord.Y, 0,0, aBmp.Width, aBmp.Height, Color, [gdNoUseSelColor], DrawInfo, False);
     end;
      aBmp.Mask(aBmp.Canvas.Pixels[0,0]);
      aBmp.Canvas.Brush.Color:= clBlack;
      aBmp.Canvas.FrameRect(Rect(0,0,abmp.width, aBmp.Height));
      {$ifdef DFS_COMPILER_4_UP}
      Images.Height := aBmp.Height;
      Images.Width := aBmp.Width;
      {$endif}
      Images.AddMasked(ABmp, cldefault);
      FImageHotSpot.X := (X - aCellRect.Left);
      FImageHotSpot.Y := (Y- aCellRect.Top);
      {$ifdef DFS_COMPILER_4_UP}
      if FDropsource <> nil then
      begin
        FDropsource.ImageHotSpotX :=  FImageHotSpot.X;
        FDropsource.ImageHotSpotY := FImageHotSpot.Y;
      end;
      {$endif}
    finally
       aBmp.Free;
    end;
  end;
end;


{$ifdef DFS_COMPILER_4_UP}
procedure TCustomRapidTree.DoOleDrag(X,Y : integer);
var Node : TflyNode;
begin
  Node := GetnodeAt(X,Y);
  if Node <> nil then
  begin
   FDropSource.DataWrapper.StringData := GetDragText;
   PrepareDragImages(Node, X, Y, FDragImage);
   try
    with FDropSource do
    begin
     Images := FDragImage;
     Showimage := True;
     Execute(Handle);
     Free;
    end;
   finally
     FDropSource := nil;
     FLastDropTarget := nil;
     DropTarget:=nil;
     SetGridState(gsNormal);
    end;
  end;
end;
{$endif}

procedure TCustomRapidTree.CMDrag(var Message: TCMDrag);
begin
   inherited;
   with Message, DragRec^ do
      case DragMessage of
         dmDragMove:
         begin
            with ScreenToClient(Pos) do
               DoDragOver(Source, X, Y, Message.Result <> 0);
         end;
         dmDragEnter:
         begin
            SetGridState(gsRowMoving);
            SetTimer(Handle, 1, 60, nil);
         end;
         dmDragLeave:
         begin
            TDragObject(Source).HideDragImage;
            FLastDropTarget := DropTarget;
            StopDrag;
            TDragObject(Source).ShowDragImage;
            DropTarget:=nil;
         end;
         dmDragDrop:
         begin
            StopDrag;
            DropTarget:=nil;
            FLastDropTarget := nil;
         end;
      end;
end;


procedure TCustomRapidTree.DragOver(Source: TObject; X, Y: Integer; State: TDragState;
 var Accept: Boolean);
begin
  Accept := true;
  if Assigned(OnDragOver) then
  begin
    OnDragOver(Self, Source, X, Y, State, Accept);
  end;

end;

procedure TCustomRapidTree.DoDragOver(Source: TDragObject; X, Y: Integer; CanDrop: Boolean);
var
   Node : TFlyNode;
   aRow : Longint;
begin
   Node := GetNodeAt(X, Y);
   if (Node <> nil) and ((Node <> DropTarget) or (Node = FLastDropTarget)) then
   begin
      FLastDropTarget := nil;
      TDragObject(Source).HideDragImage;
      Node.DropTarget:= True;
      aRow           :=Node.Getrow;
      if aRow <> -1 then
      begin
         if GetGridstate<>gsRowmoving then SetGridState(gsRowmoving);
      end;
      TDragObject(Source).ShowDragImage;
   end;
end;

function TCustomRapidTree.GetDragImages: {$IFDEF DFS_COMPILER_4_UP}TDragImageList{$ELSE}TCustomimagelist{$ENDIF};
begin
 if FInternalDragImage <> nil then
 begin
   if FInternalDragImage.Count > 0 then
      Result := FInternalDragImage
   else
      Result := nil;
  end
  else Result := nil;
end;

procedure TCustomRapidTree.DoStartDrag(var DragObject: TDragObject);
//var
   //ImageHandle : HImageList;
//   DragNode    : TFlyNode;
//   P           : TPoint;
begin
   FDragBeginned :=True;
   inherited DoStartDrag(DragObject);//tcustomli
//   DragNode := FDragNode;
   FLastDropTarget := nil;
   FDragNode := nil;
{
   if DragNode = nil then
   begin
      GetCursorPos(P);
      with ScreenToClient(P) do DragNode := GetNodeAt(X, Y);
   end;
   if DragNode <> nil then
   begin
     if TFlyTreeview(sender).Selection.Top=TFlyTreeview(sender).Selection.Bottom then
        TFlyTreeview(sender).Cursor:=crMultiDrag;

   end;
}
   
end;

procedure TCustomRapidTree.DoEndDrag(Target: TObject; X, Y: Integer);
var MousePos : TPoint;
    Keys: Longint;
begin
    inherited DoEndDrag(Target, X, Y);//dragcursor

    GetCursorPos(MousePos);
    with PointToSmallPoint(ScreenToClient(MousePos)) do
    begin
      Keys :=0;

     if (GetKeyState(VK_SHIFT) < 0) then Keys:=Keys+MK_SHIFT;
     if (GetKeyState(VK_CONTROL) < 0) then Keys:=Keys+MK_CONTROL;

     Perform(WM_LBUTTONUP, Keys, MakeLong(word(X), word(Y)));  // CEDR 05.10.02 - range

    end;
    if Target is TCustomRapidTree then
       TCustomRapidTree(Target).SetGridState(gsNormal);


   FLastDropTarget := nil;
   FInternalDragImage.Free;
   FInternalDragImage :=nil;
   FDragBeginned :=False;
end;

//procedure TCustomRapidTree.WndProc(var Message: TMessage);
//begin
//if not (csDestroying in ComponentState) then
//  inherited WndProc(Message);
//end;

function TCustomRapidTree.BeginRowDrag(var Origin, Destination: LongInt;
const MousePt: TPoint): Boolean;
begin
   Result:=true; 
   if FRootnode.Updatecount=0 then
      Fdragged:=true;
end;

function TCustomRapidTree.EndRowDrag(var Origin, Destination: Longint;
const MousePt: TPoint): Boolean;
begin
   Result:=true;
   Fdragged:=false;
end;

procedure TCustomRapidTree.ColSized(aCol, OldWidth, Width : integer);
begin

end;

procedure TCustomRapidTree.RowSized(aRow, OldHeight, Height : integer);
begin
end;

procedure TCustomRapidTree.ColumnMoved(FromIndex, ToIndex: Longint);
//var cPos : TRect;
   //i    : integer;
begin
   FColumnsMap.Move(FromIndex,ToIndex);

   inherited;

   //fixup structurecol
   if (FromIndex > FStructureCol) and (ToIndex<=FStructureCol) then
      structureCol:=FstructureCol+1//on right
   else if (ToIndex >= FStructureCol) and (FromIndex < FStructureCol) then
         structureCol:=FstructureCol-1
      else if FromIndex = FstructureCol then
            structureCol:=Toindex;

   {if FromIndex > Toindex then
      cPos := BoxRect(Toindex, 0,Colcount, RowCount)
   else
      cPos := BoxRect(Fromindex,0, Colcount, RowCount);

   if HandleAllocated then ;
     Windows.InvalidateRect(Handle, @cPos, False);
   }  
end;


procedure TCustomRapidTree.FillSelectedList(aList : Tlist);
var i : integer;
begin
    for i:=0 to FRootNode.FnodeList.Count-1 do
      if TFLyNode(FRootNode.FnodeList[i]).Selected then
         aList.Add(FRootNode.FnodeList[i]);
end;

procedure TCustomRapidTree.RowMoved(FromIndex, ToIndex: Longint);
var
  cPos             : TRect;
  aListNodes : TList;
  aToNode : TFlyNode;
  i : integer;
  procedure MoveNode(ToNode,FromNode : TFlyNode);
  var FromIndex, ToIndex : Longint;
  begin
   if (FromNode <> nil) and (ToNode <>nil) then
   begin
      FromIndex := FromNode.GetRow;
      ToIndex := ToNode.GetRow;

      if (ToNode <> nil) and FAutoMove then
      begin
         FWithoutFixup := true;
         if ToIndex > FromIndex then //insert between
         begin
             if ToNode.GetNextVisible<> nil then
               FromNode.MoveTo(ToNode.GetNextVisible, naInsert)
             else
               FromNode.MoveTo(nil, naAdd);
         end
         else //add to the end
             FromNode.MoveTo(ToNode, naInsert);

         FWithoutFixup := false;
         if FromIndex > Toindex then
            cPos := BoxRect(0, Toindex, Colcount, RowCount)
         else
            cPos := BoxRect(0, Fromindex, Colcount, RowCount);

         if HandleAllocated then
            Windows.InvalidateRect(Handle, @cPos, False);
      end;
   end;


   end;
begin
   if csDestroying in ComponentState then exit;
   aToNode := GetNodeatRow(ToIndex);
   aListNodes :=TList.Create;
   try
      FillSelectedList(aListNodes);
      for i:=0 to aListNodes.Count-1 do//downto 0 do
      begin
           MoveNode(aToNode, TFlyNode(aListNodes[i]));
      end;
   finally
      aListNodes.Free;
   end;
   SetDropTargetrow(-1);
   inherited;
end;

function TCustomRapidTree.MouseHit(X,Y : integer) : boolean;
var aHT : THitTests;
begin
   aHT:= GetHitTestInfoat(X,Y);
   Result:= not ((htOnButton in aHT) or(htOnIcon in aHT) or (htOnIndent in aHt) or (htOnStateIcon in aHT));
end;


procedure TCustomRapidTree.MouseMove(Shift: TShiftState; X, Y: Integer);
var aCoord : TGridCoord;
    aMinDrag : integer;
//    Node : TFlyNode;
begin
   inherited;
   //DragDrop
   //HotTrack
   aCoord := MouseCoord(X,Y);
   if FHottrack {and (htOnLabel in GetHitTestInfoAt(X,Y))} then
      SetTrackedNode(aCoord.Y);

   if (Shift = [ssLeft])  then
   begin
     aMinDrag := Mouse.DragThreshold;//GetSystemMetrics(SM_CXDRAG) div 2;
     {$ifdef DFS_COMPILER_4_UP}
     if (FDragType = dtStandard) and (FDragged) and
     ( (Abs(FOleDragPoint.X - X) > aMinDrag) or (Abs(FOleDragPoint.Y - Y) > aMinDrag) ) then
     begin
     {$endif}
//      Node := GetNodeAt(FOleDragPoint.X, FOleDragPoint.Y);
      FDragBeginned :=True;
      //BeginDrag(True);//
      BeginDrag(false, Mouse.DragThreshold);
     {$ifdef DFS_COMPILER_4_UP}
     end
     else if (FDragType = dtOle) then
     begin

     if (FDropSource = nil) and (GetGridstate in [gsSelecting, gsRowMoving, gsNormal]) and
     ( (Abs(FOleDragPoint.X - X) > aMinDrag) or (Abs(FOleDragPoint.Y - Y) > aMinDrag) ) then
     begin
       SetGridState(gsNormal);
       FDropSource := TOleDropsource.Create(Self);
       // link to events of Dropsource
       FDropSource.OnFeedback := FonOLEGiveFeedback;
       FDropSource.OnCompleteDrag := FOnCompleteDrag;
       FDropSource.OnStartDrag    := FOnStartDrag;
       FDropSource.OnSetData := FOnSetData;
       DoOleDrag(FOleDragPoint.X, FOleDragPoint.Y);
       if FDropsource <> nil then
       begin
         FDropSource.Free;
         FDropSource := nil;
       end;
     end;
     {$endif}
     end;
   end;

end;

function TCustomRapidTree.NeedToShowEditor : boolean;
begin
  if (not FNeedToShowEditor or FDragged) and FDragBeginned then
    Result:=false
  else
    Result:=inherited NeedToShowEditor;

end;


procedure TCustomRapidTree.WMLButtonUp(var Message: TWMLButtonUp);
begin
 ControlState := ControlState+[CSClicked]; //override for raise Click!
 FDragged := False;
 if not FDragBeginned then
   inherited;
end;

procedure TCustomRapidTree.SelectOne(aRow : integer);
var aNode : TFlyNode;
//    Rect: TGridRect;
begin
  aNode := GetNodeAtRow(aRow);
  FlushSelection;
  if aNode<> nil then
  begin
    FanchorNode := aNode;
    aNode.FSelected :=true;
  end;
end;

procedure TCustomRapidTree.MouseDown(Button: TMouseButton; Shift: TShiftState;
X, Y: Integer);
var Cur    : HCursor;
   aCoord : TGridCoord;
   aNode : TFlyNode;
//   aSel : boolean;
   aTest : THitTests;
begin
   HideTooltip;

   Cur := GetCursor;//setcursor
//   aSel :=true;
   aCoord :=MouseCoord(X,Y);
   if Cur = VertCursor then//Screen.Cursors[crVSplit] then
      FRowSized := aCoord.Y
   else if Cur = HorzCursor then//Screen.Cursors[crHSplit] then
         FColSized := aCoord.X;

   //aNode := GetNodeAt(X,Y);

   if (goRangeSelect in Options) then
   begin
    if (aCoord.X > FixedCols) or (acoord.Y > FixedRows) then
     LastSel :=nil;

//    if aNode <> nil then
//      aSel := aNode.FSelected

   end;

//   if Button = mbright then
//      SetRClickNode(aNode);

  aTest := GethitTestInfoAt(X,Y);
  if (htonItem in aTest) and (Button = mbLeft) and (Shift * [ssShift, ssCtrl] = []) then
   begin
      aNode:= GetNodeAt(X,Y);
      if (htOnButton in aTest) and (aNode <> nil) then
      begin
        FExpanding := true;
        EditorMode:=False;
        aNode.ExpandItem(not aNode.FExpanded, false);
      end
   end;


   if {not FExpanding} (aTest = []) or (htOnLabel in aTest) or (htabove in aTest) then
   begin
     if FRightClickSelect and (Button = mbRight) then
        Button := mbLeft;
     FNotProcessMouse :=false;
   end
   else FNotProcessMouse := true;

 inherited MouseDown(Button, Shift, X, Y);//new 9/3/2
//new 4/3/2002
//   if (not FExpanding) and ((Shift * [ssShift, ssCtrl] = []) and ((Button=mbLeft) or (FrightClickSelect and (Button=mbRight) )) and not aSel) or not (goRangeSelect in Options) then
//     SelectOne(Row);

  FExpanding :=false;

end;

procedure TCustomRapidTree.WMRButtonUp(var Message: TWMRButtonUp);
begin
   inherited;
//   if not FrightClickSelect then //18.12/01
//      SetRClickNode(nil);
end;

procedure TCustomRapidTree.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var //CPos : TPoint;
   aTest               : THitTests;
   aNode               : TFlyNode;
   Cur                 : HCursor;
   oldHeight, OldWidth : integer;
begin

   Cur := GetCursor;//setcursor
   oldHeight:=-1;
   oldwidth:=-1;
   if FRowSized<>-1 then {Cur = Screen.Cursors[crVSplit]}
   begin
      oldHeight := RowHeights[FRowSized];
   end
   else if FColSized <> -1 then {Cur = Screen.Cursors[crHSplit]}
   begin
      OldWidth := ColWidths[FColSized];
   end;
   aTest := GetHittestInfoAt(X, Y);
   FNeedToShowEditor := ((htOnLabel in aTest) or ((MouseCoord(X,Y).X<>-1) and (MouseCoord(X,Y).X <> FStructureCol)))
   and (Shift * [ssShift, ssCtrl] = []);


   inherited;

   if (htOnItem in aTest) and (selection.Top <> -1) and (not FNotProcessMouse) then //Selected <> nil){Selected   MouseDown} then;//and ([htOnIndent,htOnIcon,htOnButton] * aTest = []) then //new 4/5/2
   begin

     if (Shift * [ssShift, ssCtrl] = []) and (Button=mbLeft) then//or (FRightClickSelect and (Button=mbRight) )) and  ((LastSel = FAnchorNode) or (LastSel=nil)) and (htonItem in aTest)then
         SelectOne(Row);
   end;
   //if not FRightClickselect then//for rightclickSelect - in WMRBUTONUP
   //SetRClickNode(nil);

   if (ssCtrl in Shift) then
   begin
      if goRowSelect in Options then
         InvalidateRow(Row)
      else
         InvalidateCell(Col, Row);
   end;
   FNeedToShowEditor := true;
   //determine sizing
   if Cur = VertCursor then//Screen.Cursors[crVSplit] then
   begin
      anode := GetnodeAtRow(FRowSized);
      if aNode <> nil then
         aNode.FHeight := RowHeights[FRowSized];

      RowSized(FrowSized, OldHeight, RowHeights[FRowSized]);
      FRowSized := -1;
   end
   else if Cur = HorzCursor then//Screen.Cursors[crHSplit] then
      begin
         ColSized(FColSized, OldWidth, ColWidths[FColSized]);
         FColSized := -1;
      end;

   FNotProcessMouse :=false;
end;


{procedure TCustomRapidTree.KeyPress(var Key: Char);
var aNode : TFlyNode;

begin
  if ((Col = FStructureCol) or (goRowSelect in Options)) then
  if not EditorMode then
  begin
     aNode := GetNodeAtRow(Row);
     IncSearch(aNode, Key);
     Key:=#0;
  end;
  inherited;
end;}

function TCustomRapidTree.IncSearch(aNode : TFlyNode; aKey : Char) : TFlyNode;
var achar, Atext : String;
    StartNode : TFlyNode;
begin
   if aNode<> nil then
     Result:=aNode//.GetRow
   else
   begin
      Result := nil;
      exit;
   end;
   //achar :=nil;
   StartNode := aNode;
   aNode := aNode.GetNextVisible;
   aText:='';
   if aNode = nil then aNode := Items.GetFirstNode;
   while (aNode<>nil) and (aNode <> StartNode) do //findstr
   begin      //STRPCOPY
      Setlength(aChar,1);
      //if assigned(OnGetEditText) then
      //  OnGeteditText(Self, FStructurecol, aNode.GetRow, aText)
      //else
      //  aText := aNode.Text;
      if (FStructureCol>=0)and(FStructureCol<ColCount) then  // CEDR 08.10.02
        aText := aNode.Cells[FStructurecol];
      aChar :=  StrlCopy(Pchar(aChar), Pchar(aText),1);//Pchar(aNode.Text[1]);
      if isCharLower(aKey) then   //uppercase
         aChar := CharLower(Pchar(aChar))
      else
         achar := CharUpper(Pchar(aChar));

      if aChar = aKey then //upperstr
      begin
         Result:= aNode;//.GetRow;
         exit;
      end
      else
         if aNode.Expanded then
            aNode := aNode.item[0]
         else
         begin
            aNode := aNode.GetNextVisible;//Sibling;
            if aNode = nil then
              aNode := Items.GetFirstNode;
         end;
   end;
end;

{procedure TCustomRapidTree.Updatewidths;
begin
 if HandleAllocated then
  if (ColCount=1) and (ClientWidth<>0) then
      Colwidths[0]:=ClientWidth;
end;
}

//procedure TCustomRapidTree.WMSize(var Message: TWMSize);
//begin
//   if FFitHeight then
//   begin
//     RecalcRowHeights(TopRow, False);
//   end;
//   inherited;
//   UpdateScrollRange;
//end;

procedure TCustomRapidTree.WMChar(var Msg: TWMChar);
var aNode : TFlyNode;
begin
   if (Col = FStructureCol) or (goRowSelect in Options) {and ((Msg.KeyData and (1 shl 29))>0)} then
   begin
     if not (Char(Msg.CharCode) in ['+','-', #13]) then  
     begin
      if not (goEditing in Options)  then
      begin
         aNode       := GetNodeatRow(Row);
         Selected         := incSearch(aNode, Char(Msg.CharCode));
         Msg.CharCode:=0;
      end
      else
        inherited;
     end;
   end
   else inherited;
end;


procedure TCustomRapidTree.KeyDown(var Key: Word; Shift: TShiftState);
var
   Node     : TFlyNode;
begin
   Node := GetNodeAtRow(Row);

   if (Node <> nil) and ((Col = FStructureCol) or (goRowSelect in Options)) then
      case Key of //insertrow
         VK_LEFT:
            if {(goRowSelect in Options) or} (ColCount=1) then
            begin
               if (Node.Expanded) then
                  Node.Collapse(false)
               else if Node.Parent<>nil then
                  begin
                     Row:=Node.Parent.Getrow;
                  end;
               //Key := 0;
            end;
         VK_RIGHT:
            if {(goRowSelect in Options) or} (ColCount=1) then
            begin
               if (Node.Expanded) and (Node.Count > 0) then
               begin
                  Row :=Node[0].GetRow;
               end
               else if Node.HasChildren then
                     Node.Expand(false);
               //Key := 0;
            end;

         VK_RETURN:
            if ((Col=FstructureCol) or (goRowselect in Options)) and not EditorMode then
            begin
               Node.Expanded := not Node.Expanded;
            end;
         VK_ADD:
         begin
            Node.Expand(False);
            Exit;
         end;
         VK_SUBTRACT:
         begin
            Node.Collapse(False);
            Exit;
         end;
      end;
   inherited KeyDown(Key, Shift);
end;


function TCustomRapidTree.GetNodeAt(X,Y : integer) : TFlyNode;
var aCoord : TGridCoord;
begin
   aCoord := MouseCoord(X,Y);
   Result:= GetNodeAtRow(aCoord.Y);
end;

procedure TCustomRapidTree.SetTransparentMode(Value:boolean);
begin
   if Value<>FTransParentMode then
   begin
      FTransparentMode:=Value;
      Invalidate;
   end;
end;

function TCustomRapidTree.DisplayRect(Node : TFlyNode; TextOnly : Boolean) : TRect;
var aRow : Longint;
    aRestore : boolean;
begin
   if Node.IsVisible then
   begin
      aRow  := Node.Getrow;
      Result:= CellRect(FStructureCol, aRow);
      if TextOnly then
      {ifdef DFS_DELPHI_4_UP}
      begin
       if not UseRightToLeftAlignment then
       {endif}
       begin
         if FShowRoot or (Node.Level>0) then
            inc(Result.Left, (Node.Level) * FIndent);
         //else
         //   inc(Result.Left, (Node.Level) * (FIndent));

         if (FShowLines or (FShowButtons {and Node.HasChildren})) and
          ((Node.Level >0 ) or FShowroot) then
            inc(Result.Left, Findent);
         if FshowLogic and (Node.StateIndex > STATE_EMPTY) then
            inc(Result.Left, Findent);
         if FshowImages  then
         begin
           if (Node.Selected and ((Node.SelectedIndex >= 0) {and (Node.SelectedIndex < images.Count-1)}))
              or ((Node.ImageIndex >= 0) {and (Node.ImageIndex < images.Count-1)}) then
            inc(Result.Left, Findent);
         end;

         aRestore := false;
         if (FStructureCol>=0)and(FStructureCol<ColCount) then   // CEDR 08.10.02
           DrawStructureCellContents(Canvas, Result,[], FStructureCol, aRow, Node, Node.Text, tvaCenter, aRestore, true);
         //Result.Right := Result.Left + DisplayWidth(Node);
      {ifdef DFS_DELPHI_4_UP}
      end
      else
      begin
         if FShowRoot or (Node.Level>0) then
            Dec(Result.right, (Node.Level) * FIndent);
         //else
         //   Dec(Result.right, (Node.Level) * (FIndent));

         if (FShowLines or (FShowButtons and Node.HasChildren)) and
          ((Node.Level >0 ) or FShowroot) then
            Dec(Result.right, Findent);
         if FshowLogic then
            Dec(Result.right, Findent);
         if FshowImages then
            Dec(Result.right, Findent);
      end;
      {endif}
      end
      else
         Result.Right := ClientWidth;
   end
   else
      Result := Rect(0,0,0,0);
end;

function TCustomRapidTree.GetHitTestInfoAt(X, Y: Integer): THitTests;
var aNode        : TFlyNode;
   aCoord       : TGridCoord;
   aTest, aRect : Trect;
   XImageDelta, YImageDelta  : integer;
begin
   aCoord := MouseCoord(X,Y);
   YImageDelta := 0;

   inc(X, ColOffset);

   Result:=[];
   if (Y < 0 ) or ((aCoord.Y < FixedRows) and (aCoord.Y >= 0)) then
   begin
      include(Result, htAbove);
      exit;
   end
   else
      if (Y > ClientHeight) then
      begin
         include(Result, htbelow);
         exit;
      end
      else
      begin
         aRect := CellRect(0,RowCount-1);
         if (Y > aRect.Bottom) and (aRect.Bottom>0) then
         begin
            include(Result, htNowhere);
            exit;
         end; //
      end;
   aNode := GetNodeAtRow(aCoord.Y);
   if aNode <> Nil then//,
   begin
      include(Result, htOnItem);

      if (aCoord.X <> -1) and (aCoord.X <> FStructureCol) then  // CEDR 08.10.02
      begin
        Result := [];
        exit;
      end;
      aRect := aNode.DisplayRect(True);//text part
      if PtInrect(aRect, Point(X,Y)) then
         include(Result, htOnLabel)
      else
      begin
         aRect:= aNode.DisplayRect(false);
         aTest:= CellRect(aCoord.X, aCoord.Y);
         {ifdef DFS_DELPHI_4_UP}
         if not UseRightToLeftAlignment then
         begin
         {endif}
          if (X < aRect.left) then
          begin
            Include (Result, htToLeft);
            exit;
          end;
          //showbuttons,showImages, Showlogic
          if FShowRoot or (aNode.Level>0) then // begiining ofnode
            inc(atest.Left, (aNode.Level) * FIndent);
          //else
          //  inc(atest.Left, (aNode.Level) * FIndent);

          if (X < atest.left) then
          begin
            Include (Result, htOnIndent);
            exit;
          end;

         if FShowRoot or (aNode.Level>0) then // begiining ofnode
         begin
          if FStatesDrawed then //21/12/01
          begin
            YImageDelta := ((aTest.Bottom-atest.Top)-FButtonSize) div 2;
            XImageDelta := (FIndent-FButtonSize) div 2;
            if ((X >= atest.left + XImageDelta) and (X <= aTest.Left + XImageDelta + FButtonSize))  and FShowButtons
            and ((Y >= aTest.Top + YImageDelta) and (Y <= aTest.Top + YImageDelta + FButtonSize)) then
            begin
             Include (Result, htOnButton);
             exit;
            end;
          end
          else
          begin
           YImageDelta := ((aTest.Bottom-atest.Top)-FIndicators.Height) div 2;
           XImageDelta := (FIndent-FIndicators.Height) div 2;
           if ((X >= aTest.Left + XImageDelta) and (X <= aTest.Left + XImageDelta + FIndicators.Height))  and FShowButtons
           and (Y >= aTest.Top + YImageDelta) and
           (Y <= aTest.Top + YImageDelta + FIndicators.Height) then
           begin
             Include (Result, htOnButton);
             exit;
           end;
          end;
         end;

         if (FShowLines or (FShowButtons {and aNode.HasChildren})) and
          ((aNode.Level >0 ) or FShowroot) then
            inc(atest.Left, Findent);

         if FshowLogic and (aNode.StateIndex > STATE_EMPTY) then //STATE_EMPTY
         begin
            inc(atest.Left, Findent);

           if (X < atest.left) and (Y >= aTest.Top + YImageDelta) and
             (Y <= aTest.Top + YImageDelta + FIndicators.Height)then
           begin
            Include (Result, htOnStateIcon);
            exit;
           end;
         end;

         if FshowImages and (aNode.Selected and ((aNode.SelectedIndex >= 0) {and (aNode.SelectedIndex < images.Count-1)}))
          or ((aNode.ImageIndex >= 0) {and (aNode.ImageIndex < images.Count-1)}) then
         begin
            inc(atest.Left, Findent);

           if (X < atest.left) and (Y >= aTest.Top + YImageDelta) and
            (Y <= aTest.Top + YImageDelta + FIndicators.Height) then
           begin
            Include (Result, htOnIcon);
            exit;
           end;

         end;
         if (X > atest.Right) and (X < ClientWidth) then
         begin
            Include (Result, htOnRight);
            exit;
         end
         else if (X >= ClientWidth) then
               Include (Result, htToRight);
      {ifdef DFS_DELPHI_4_UP}
      end
      else
      begin
          if (X > aRect.right) then
          begin
            Include (Result, htToLeft);
            exit;
          end;
          //showbuttons,showImages, Showlogic
          if FShowRoot or (aNode.Level>0) then // begiining ofnode
            Dec(atest.right, (aNode.Level) * FIndent);
          //else
          //  Dec(atest.Right, (aNode.Level) * FIndent);

          if (X > atest.Right) then
          begin
            Include (Result, htOnIndent);
            exit;
          end;

          if (FShowLines or FShowButtons) and
          ((aNode.Level >0 ) or FShowroot) then
            Dec(atest.Right, Findent);

          YImageDelta := ((aTest.Bottom-atest.Top)-FIndicators.Height) div 2;
          if (X > atest.right)  and FShowButtons
          and (Y >= aTest.Top + YImageDelta) and
          (Y <= aTest.Top + YImageDelta + FIndicators.Height) then
          begin
            Include (Result, htOnButton);
            exit;
          end;

         if FshowLogic then
            Dec(atest.Right, Findent);

         if (X > atest.Right) and FShowLogic and (Y >= aTest.Top + YImageDelta) and
           (Y <= aTest.Top + YImageDelta + FIndicators.Height)then
         begin
            Include (Result, htOnStateIcon);
            exit;
         end;

         if FshowImages then
            Dec(atest.Right, Findent);

         if (X > atest.Right) and (Y >= aTest.Top + YImageDelta) and
          (Y <= aTest.Top + YImageDelta + FIndicators.Height) then
         begin
            Include (Result, htOnIcon);
            exit;
         end;

         if (X < atest.left) and (X >0 {ClientWidth}) then
         begin
            Include (Result, htOnRight);
            exit;
         end
         else if (X <= 0{ClientWidth}) then
               Include (Result, htToRight);

      end;
      {endif}
      end;
   end;
end;

procedure TCustomRapidTree.DrawBackground(aCanvas : TCanvas; aRect : TRect; aCol, aRow : Longint; AState: TExGridDrawState);
begin
   with aCanvas do FillRect(aRect);
end;

procedure TCustomRapidTree.DrawFixedFrame(aCanvas : TCanvas; aRect : TRect; aCol, aRow : integer; Down : Boolean);
var
     FrameFlags1, FrameFlags2: DWORD;
begin
  if (FixedColAsButton and (aCol < FixedCols)) or
  (FixedRowAsButton and (aRow < FixedRows)) then
   with aCanvas do
   begin

      if Ctl3d then
      begin
        
        FrameFlags1 := 0;
        FrameFlags2 := 0;
        if goFixedVertLine in Options then
        begin
          FrameFlags1 := BF_RIGHT;
          FrameFlags2 := BF_LEFT;
        end;
        if goFixedHorzLine in Options then
        begin
         FrameFlags1 := FrameFlags1 or BF_BOTTOM;
         FrameFlags2 := FrameFlags2 or BF_TOP;
        end;
        if ((FrameFlags1 or FrameFlags2) <> 0) then
        begin

         if (FrameFlags1 and BF_RIGHT) = 0 then
          Inc(aRect.Right, GridLineWidth)
         else if (FrameFlags1 and BF_BOTTOM) = 0 then
          Inc(aRect.Bottom, GridLineWidth);

         if Down then
         begin
          DrawEdge(aCanvas.Handle, aRect, BDR_SUNKENINNER, BF_RECT);
          //DrawEdge(aCanvas.Handle, aRect, BDR_SUNKENINNER, FrameFlags1);
          //DrawEdge(aCanvas.Handle, aRect, BDR_SUNKENOUTER, FrameFlags2);
         end
         else
         begin
          DrawEdge(aCanvas.Handle, aRect, BDR_RAISEDINNER,BF_RECT);
          //DrawEdge(aCanvas.Handle, aRect, BDR_RAISEDOUTER, FrameFlags2);
          //DrawEdge(aCanvas.Handle, aRect, BDR_RAISEDINNER, FrameFlags1);
         end;
        end;
      end
      else
         FrameRect(aRect);
   end;
end;

procedure TCustomRapidTree.DrawFixed(aCanvas : TCanvas; aRect : TRect; aCol, aRow : Longint;
AState: TExGridDrawState; Var Continue : boolean);
var Flags : integer;
   aData          : string;
begin
   aData      :='';
   with aCanvas do
   begin
     with aCanvas do
     begin
       Brush.Color:= FixedColor;
       FillRect(aRect);
     end;
      DrawFixedFrame(aCanvas, aRect, aCol, aRow, false);
      if (aCol<>FStructureCol) or (aRow < Fixedrows) then
      begin
         aData := inherited GetEditText(aCol,aRow);
         if aData<>'' then
         begin
            inflaterect(aRect,-1, 0);
            if FHTMLDrawing then
            begin
              DrawHTML(aRect, aCanvas, aData, FWordWrap, false, DT_LEFT, DT_VCENTER)
            end
            else
            begin
              if FWordWrap then
               Flags:=DT_LEFT+DT_WORDBREAK+DT_NOPREFIX+DT_EXPANDTABS
              else
               Flags:=DT_END_ELLIPSIS+DT_SINGLELINE+DT_VCENTER+DT_NOPREFIX+DT_EXPANDTABS;
              {$ifdef DFS_COMPILER_4_UP}
              Flags := DrawTextBiDiModeFlags(Flags);
              {$endif}
              DrawText(aCanvas.Handle,PChar(aData), Length(aData),aRect,Flags);
            end;
         end;
      end;
   end;
end;

procedure TCustomRapidTree.SetNodeSelectionStyle(Value : TNodeSelectionStyle);
begin
   if Value <> FNodeSelectionStyle then
   begin
      FNodeSelectionStyle := Value;
      Invalidate;
   end;
end;

procedure TCustomRapidTree.SetOutlineStyle(Value : TOutlineStyle);
begin
   if Value <> FOutlineStyle then
   begin
      FOutlineStyle := Value;
      Invalidate;
   end;
end;

procedure TCustomRapidTree.CreateWindowHandle(const Params: TCreateParams);
begin
  inherited CreateWindowHandle(Params);
  {$ifdef DFS_COMPILER_4_UP}
  UpdateDropTarget;
  {$endif}
end;

function TCustomRapidTree.GetAlignment(Col : integer) : TAlignment;
begin
  Result := taLeftJustify;
end;

{$ifdef DFS_COMPILER_4_UP}
procedure TCustomRapidTree.UpdateDropTarget;
begin
 if FDragtype = dtOLE then
 begin
  if (not Assigned(FDropTarget)) then
  begin
    FDropTarget := TOLEDropTarget.Create(Self);
    FDropTarget.OnDragOver := OLEDragOver;
    FDropTarget.OnDrop := OLEDragDrop;
  end;
  if Handleallocated and ( not ( csDesigning in ComponentState )) then
     FDropTarget.Register(Self);
 end
 else if {Assigned(FDropTarget)} FDropTarget is TOLEDropTarget then   // CEDR 05.10.02 - because of AV when change from dtOLE in design-mode
 begin
    FDroptarget.Unregister;
    //FDroptarget.Free;
    FDroptarget := nil;
 end;
end;

procedure TCustomRapidTree.SetDragType(Value: TISDragType);
begin
  if (FDragType <> Value) then
  begin
    FDragType := Value;
    UpdateDropTarget
  end;

end;

procedure TCustomRapidTree.OLEDragOver(Sender: TObject; Data : IS_IDataObject;
    ShiftState: TShiftState; Point: TPoint; var Effect: Longint);
var Node : TFlyNode;
begin
   with Point do
     Node := GetNodeAt(X, Y);
   if (Node <> nil) and ((Node <> DropTarget) or (Node = FLastDropTarget)) then
   begin
      FLastDropTarget := nil;
      if FDropSource <> nil then FDropSource.Images.HideDragImage;
      Node.DropTarget:= True;
      Update;
      if FDropSource <> nil then FDropSource.Images.ShowDragImage;
   end;

  if (assigned(FOnOleDragOver)) then
    FOnOleDragOver(Self, Data, ShiftState, Point, Effect);
end;

procedure TCustomRapidTree.OLEDragDrop(Sender: TObject; Data : IS_IDataObject;
    ShiftState: TShiftState; Point: TPoint; var Effect: Longint);
begin
  try
   if (assigned(FOnOLEDragDrop)) then
    FOnOleDragDrop(Self, Data, ShiftState, Point, Effect);
  finally
    FLastDropTarget := nil;
    DropTarget:=nil;
    SetGridState(gsNormal);
  end;
end;


function TCustomRapidTree.DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
   Result := inherited DoMouseWheelDown(Shift, MousePos);
   if Result then
      HideToolTip;
end;

function TCustomRapidTree.DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
   Result := inherited DoMouseWheelUp(Shift, MousePos);
   if Result then
      HideToolTip;
end;

{$endif}

procedure TCustomRapidTree.DrawStructureCellContents(aCanvas : TCanvas; var aRect : TRect; AState: TExGridDrawState; aCol, aRow : Longint; aNode : TFlyNode; aData : string; Valign : TISVertAlign; var aRestore : Boolean; CalcRect : boolean);
var aFRect, RestoreRect : TRect;
    Flags : integer;
const
    VAlignFlags : array [TISVertAlign] of Integer =  ( DT_TOP, DT_BOTTOM, DT_VCENTER);
begin
  if FHTMLDrawing then
  begin
     aFRect := aRect;
     if FNodeSelectionStyle = tnsTextOnly then
     begin
       Dec(afRect.Right, 8);
       DrawHTML(aFRect, aCanvas, aData, FWordWrap, True, DT_LEFT, VAlignFlags[VAlign]);
       with aRect do
       begin
         Left := afRect.Left;
         if Right > (afRect.Right+8) then
           Right := afRect.Right+8;
       end;
     end;
//added 18/01/01
     if not ((goRowselect in Options) or  (gdFixed in aState) or CalcRect) then
       DrawBackground(aCanvas, ARect,aCol , aRow,aState);
     RestoreRect := aRect;
     if Not wordWrap then
     begin
       if (afRect.Bottom - afrect.Top) < (RestoreRect.Bottom - RestoreRect.Top) then
       begin
         inc (RestoreRect.Top,  (((RestoreRect.Bottom - RestoreRect.Top) - (afRect.Bottom - afrect.Top)) div 2));
         dec (RestoreRect.Bottom,  (((RestoreRect.Bottom - RestoreRect.Top) - (afRect.Bottom - afrect.Top)) div 2));
       end;
     end;
     //inc(RestoreRect.Left, 4);
     //inflateRect(RestoreRect, -4,0);
     if CalcRect then
     begin
       aRect := RestoreRect;
       exit;
     end;
     Inc(RestoreRect.Left,4);
     DrawHTML(RestoreRect, aCanvas, aData, FWordWrap, false, DT_LEFT, VAlignFlags[VAlign]);
     //inflateRect(RestoreRect, 4,0);
     Dec(RestoreRect.Left,4);
  end
  else
  begin
    if FWordWrap then
      Flags:=DT_LEFT or DT_WORDBREAK or DT_NOPREFIX +DT_EXPANDTABS
    else
      Flags:=DT_END_ELLIPSIS or DT_SINGLELINE {or DT_VCENTER} + DT_NOPREFIX + DT_EXPANDTABS;

   if not CalcRect then
    if FHotTrack and (FHotTrackedRow = aRow) and (FStructureCol >= FixedCols) then
    with aCanvas.Font do
    begin
      aRestore := (not (fsunderline in Style) and (Color <> FHotTrackColor));
      if aRestore then
      with aCanvas.Font do
      begin
        Style := Style+[fsunderline];
        if not aNode.Selected then
          Color := FHotTrackColor;
      end;
    end;

    if FNodeSelectionStyle = tnsTextOnly then
    begin
      aFRect := aRect;
      DrawRTLText(aCanvas, aData, aFRect, Flags or DT_CALCRECT, DT_VCENTER);
      with aRect do
      begin
        Left := afRect.Left;
        if Right > (afRect.Right+8) then
           Right := afRect.Right+8;
      end;
    end;

    if CalcRect then exit;

    if not ((goRowselect in Options) or  (gdFixed in aState)) then
      DrawBackground(aCanvas, ARect,aCol,aRow,aState);
    inc(aRect.Left, 4);
    Dec(aRect.Right, GridLinewidth);
    DrawRTLText(aCanvas, aData,aRect, Flags, VAlignFlags[VAlign]);
    Inc(aRect.Right, GridLinewidth);
    Dec(aRect.Left,4);
 end;
end;

procedure TCustomRapidTree.DrawStructureNode(aCanvas : TCanvas; aNode : TFlyNode; aRect : TRect; aCol, aRow : Longint;
AState: TExGridDrawState; Var Continue : boolean);
var {Flags, TextLength,} OldMode : integer;
   aData                      : string;
   aChanged, aRestore         : boolean;
   aFontColor, aColor         : TColor;
//   RestoreRect, aFRect : TRect;
begin

   aRestore := false;
   if aNode = nil then exit;

      with aCanvas do
      begin
         aColor    :=Brush.Color;
         aFontColor:= aCanvas.Font.Color;
         //aChanged  :=false;
         GetColor(aNode, aCol, aRow, aState, aColor, aFontColor, aChanged);
         if aChanged then
         begin
            Brush.Color := aColor;
            aCanvas.Font.Color:= aFontcolor;
         end;
      end;


     DrawStructureButtonsLines(aCanvas, aNode, aRow, aCol, aRect, aState, [doDrawlines,doDrawbuttons, doDrawStates, doDrawImages]);

   if gdFixed in aState then
      InflateRect(ARect, -1, -1);
   // Remove 18/01/01
   // if not ((goRowselect in Options) or  (gdFixed in aState) or (FNodeSelectionStyle=tnsTextOnly)) then
   //   DrawBackground(aCanvas, ARect,aCol,aRow,aState);
   //
   aData :='';
   aData := GetEditText(aCol,Arow);
   try
      OldMode := SetBkMode(aCanvas.Handle, TRANSPARENT);
      try
       DrawStructureCellContents(aCanvas, aRect, aState, aCol, aRow, aNode, aData, tvaCenter, aRestore, false);
      finally
         SetBkMode(aCanvas.handle, OldMode);
      end;

      if (GetFocus = Self.Handle) and (goDrawFocusSelected in Options)
       and (Continue<>false) and (gdfocused in AState) and not (goRowSelect in Options) then
         with aCanvas do
         begin
            DrawFocusRect(aRect);
         end;

      if FHotTrack and (FHotTrackedRow = aRow) and (FStructureCol >= FixedCols) then
      begin
         if aRestore then
         with aCanvas.Font do
         begin
            Style := Style- [fsunderline];
            Color := aFontColor;
         end;
      end;

   finally
      //
   end;
end;

//Usi
procedure TCustomRapidTree.EnumerateNodes;
var aNode : TFlyNode;
begin
  aNode := FRootNode.GetFirstNode;
  FRootNode.FEnumerating := True;
  FRootNode.FMaxTag := -1;
  try
   while aNode <> nil do
   begin
      aNode.SetUniqueTag(-1);
      aNode := aNode.GetNext;
   end;
  finally
     FRootNode.FEnumerating := False;
  end;
end;

procedure TCustomRapidTree.SetEnumerateNodes(Value : Boolean);
begin
   if Value <> FEnumerateNodes then
   begin
       FEnumerateNodes := Value;
       FRootNode.FMaxTag := -1;
       If FEnumerateNodes then
          EnumerateNodes;
   end;
end;

function TCustomRapidTree.GetColWidths(Index: Longint): Integer; //new 11/9/1
var i, Line : integer;
begin
  if FFitWidth then
  begin
   if ColCount > 1 then
   begin
    Result:=0;
    if (goVertLine in Options) or (goFixedVertLine in Options) then
      Line := GridLineWidth
    else
      Line := 0;

    for i:=0 to index do
      inc(Result,inherited GetColWidths(i)+Line);
    if Result > ClientWidth then
    begin
      i := inherited GetColWidths(Index) - (Result - ClientWidth);
      if i < 0 then
       Result := 0
      else Result:=i;
    end
    else
     if (index < ColCount-1) then
      Result := inherited GetColWidths(Index)
     else
       Result := inherited GetColWidths(Index) + (ClientWidth - Result);
    //if (Result >0) and (Clientwidth > 0) then
    //  Result := Trunc(inherited GetColWidths(Index) / (Result/ClientWidth))
   end
   else
     Result := ClientWidth;
  end
  else
   Result := inherited GetColWidths(Index);
end;

procedure TCustomRapidTree.CalcSizingState(X, Y: Integer; var State: TGridState; var Index: Longint; var SizingPos, SizingOfs: Integer; var FixedInfo: TExGridDI);
begin
  inherited;
  if (State = gsColSizing) and (Index = ColCount-1) and FFitWidth then
    State := gsNormal;
end;

procedure TCustomRapidTree.InvalidateRectBelow(aNode : TFlyNode);
var aRect : TRect;
    aRow : integer;
begin
  aRow := aNode.GetRow;
  if aRow <> -1 then
  begin
    aRect := CellRect(0,aRow);
    aRect.Right := ClientWidth;
    aRect.Bottom := ClientHeight;
    Windows.InvalidateRect(Handle, @aRect, true);//true);
  end;
end;

function TCustomRapidTree.RecalcNodeHeight(aNode : TFlyNode) : integer;
var Max,i : integer;
begin
 Result := DefaultRowHeight;
 if csLoading in ComponentState then
 begin
   exit;
 end;
 if (aNode <> nil) then
 begin
   if FFitHeight then
   begin
     if (aNode.FHeight = -1) then
     begin
       Result := 1;
       for i:=0 to ColCount-1 do
       begin
         aNode.FHeight :=-1;
         Max := CalcNodeHeight(aNode, i);
         if Result < Max then Result := Max;
       end;
       aNode.FHeight := Result;
     end
     else
      Result := aNode.FHeight;
   end
   else
   begin
     if aNode.FHeight <> -1 then
      Result := aNode.FHeight
   end;
 end;
end;

function TCustomRapidTree.CalcNodeHeight(aNode : TFlyNode; aCol : integer) : integer;
var
  anRect : TRect;
  Flags : integer;
  aCaption : String;
begin
 Result := DefaultRowHeight;
 if aNode = nil then exit;
 if FFitHeight then
 begin
   if (aNode.FHeight<>-1) and (not aNode.FHidden) then
   begin
    Result := aNode.FHeight;
   end
   else
   begin
    if FWordWrap then
      Flags:=DT_LEFT+DT_WORDBREAK+DT_NOPREFIX or DT_EXPANDTABS
    else
      Flags:=DT_END_ELLIPSIS+DT_SINGLELINE + DT_VCENTER+DT_NOPREFIX+DT_EXPANDTABS;

    {$ifdef DFS_COMPILER_4_UP}
    Flags := DrawTextBiDiModeFlags(Flags);
    {$endif}
    if FWordWrap then
      anRect:=Rect(0,0, ColWidths[aCol], 1)
    else
      anRect:=Rect(0, 0, 0, 1);
    aCaption := GetNodeData(aNode, aCol);  //aNode.GetCell(aCol);//GetEditText(FStructurecol, Index);

    if aCol = FStructureCol then
    begin
    //calculate indentation
     if (FShowRoot) or (aNode.Level>0) then
       Dec(anRect.Right, (aNode.Level * FIndent));
     if (FShowButtons or FShowLines) and (FShowRoot or (aNode.Level>0))then
       Dec(anRect.Right, FIndent);
     if FShowLogic and (aNode.stateIndex<>STATE_EMPTY) then
       Dec(anRect.Right, FIndent);
     if (FShowimages) then
       Dec(anRect.Right, FIndent);
    end;

   Dec(anRect.Right,4);

   if aCaption <> '' then
   begin
     if FHTMLDrawing then
       DrawHTML(anRect, Canvas, aCaption, FWordWrap, True, DT_LEFT, DT_VCENTER)
     else
     begin
       if FWordWrap then
        //DrawText(Canvas.Handle,PChar(aCaption), Length(aCaption),anrect,Flags or DT_CALCRECT)
        DrawRTLText(Canvas,aCaption, anRect, Flags+ DT_CALCRECT, 0)
       else
        anRect.Bottom := Canvas.TextHeight(aCaption);
     end;

     inc(anRect.Bottom,2);
     if FShowImages and (Images<>nil) then
     begin
       if Images.Height > anRect.Bottom then
          anRect.Bottom := Images.Height;
     end;

     aNode.FHeight := anRect.Bottom;
     Result := anRect.Bottom;
   end
   else Result := 1;//DefaultRowHeight;//inherited GetRowHeights(Index); //new 16/2/2
  end;
 end;
end;

procedure TCustomRapidTree.SetRowHeights(Index: Longint; Value: Integer);//new 3/4/2
var
  aNode : TFlyNode;
begin
  aNode := GetNodeatRow(Index);
  if (aNode = nil) then
  begin
    inherited SetRowHeights(index, value);
    exit;
  end
  else
  begin
    if FFitHeight then
      aNode.FHeight := -1
    else if aNode.FHeight <> value then
    begin
      RowHeightChanging(Index, Value);
      aNode.FHeight := value;
      InvalidateGrid;
      RowHeightsChanged;
      RowHeightChanged(Index, Value);
    end;
  end;
end;

function TCustomRapidTree.GetRowHeights(Index: Longint): Integer;//new 11/9/1
var
  aNode : TFlyNode;
begin
  aNode := GetNodeatRow(Index);
  if (aNode = nil) then //if it row header new 16/2/2
  begin
    Result := inherited GetRowHeights(index);
    exit;
  end
  else Result := ReCalcNodeHeight(aNode);
end;

procedure TCustomRapidTree.RefreshRowHeights;
var aNode : TFlyNode;
begin
  aNode := Items.GetFirstNode;
  while aNode <> nil do
  begin
    aNode.FHeight:=-1;
    aNode := aNode.GetNext;
  end;
end;

procedure TCustomRapidTree.InternalSetRow(Value: Longint); //4/26/2
begin
  inherited;
end;

function TCustomRapidTree.BeginColumnDrag(var Origin, Destination: Longint; const MousePt: TPoint): Boolean;
begin
  Result := inherited BeginColumnDrag(Origin, Destination, MousePt);
end;

procedure TCustomRapidTree.ColumnWidthChanged(Index, Value : integer);
begin
 if (FFitHeight) and (Wordwrap) then
    RefreshRowHeights;
 inherited;   
end;

{procedure TCustomRapidTree.Paint;
Var
    anRect : TRect;
    aCaption : String;

begin
   // FFittoheight support - prepare rowheights
//   if FFitHeight then
//     RecalcRowHeights(TopRow, False);
   inherited;
end;
}
procedure TCustomRapidTree.DrawDataNode(aCanvas : TCanvas; aNode : TFlyNode; aRect : TRect; aCol, aRow : Longint;
AState: TExGridDrawState; Var Continue : boolean);
var Flags              : integer;
   aData              : string;
   aFontColor, aColor : TColor;
   achanged           : boolean;
const
{$ifdef DFS_COMPILER_4_UP}
   RTL: array [Boolean] of Integer = (0, DT_RTLREADING);
{$ENDIF}

  AlignFlags : array [TAlignment] of Integer =  ( DT_LEFT, DT_RIGHT, DT_CENTER );
begin
   if aNode<>nil then
      with aCanvas do
      begin
         aColor    :=Brush.Color;
         aFontColor:= aCanvas.Font.Color;
         aChanged  :=false;
         GetColor(aNode, aCol, aRow, aState, aColor, aFontColor, aChanged);
         if aChanged then
         begin
            Brush.Color      := aColor;
            aCanvas.Font.Color:= aFontcolor;
         end;
      end;

   aData :='';
   aData := GetEditText(aCol,Arow);

   //if (not FHideSelection) or (GetFocus = Self.Handle) then
      with aCanvas do
      begin
         DrawBackground(aCanvas, ARect,aCol,aRow,aState);
      end;

   inflaterect(aRect,-1, -1);

   if FHTMLDrawing then
      DrawHTML(aRect, aCanvas, aData, FWordWrap, false, DT_LEFT, DT_VCENTER)
   else
   begin
     if FWordWrap then
       Flags:=AlignFlags[GetAlignment(aCol)]+DT_WORDBREAK+DT_NOPREFIX+DT_EXPANDTABS
     else
     begin
       Flags:=AlignFlags[GetAlignment(aCol)]+
          DT_END_ELLIPSIS+DT_SINGLELINE+DT_VCENTER+DT_NOPREFIX+DT_EXPANDTABS;
     end;
     //DrawText(aCanvas.Handle,PChar(aData), Length(aData),aRect,Flags{$ifdef DFS_COMPILER_4_UP} or RTL[UseRightToLeftAlignment]{$endif});
     DrawRTLText(aCanvas, aData, aRect, Flags, DT_VCENTER);
   end;

   if ((aCol= Col) and (aRow = Row)) and not(goRowSelect in Options)then
      with aCanvas do
      begin
         if (goDrawFocusSelected in Options)  then
         begin
            inflaterect(aRect,1,1);
            DrawFocusRect(aRect);
         end;
      end;

end;

procedure TCustomRapidTree.GetColor(aNode : TFlyNode; aCol, aRow : Longint; AState: TExGridDrawState; var aColor, aFontColor : TColor; var aChanged : boolean);
begin
   //for future use
   if not (gdNoUseSelColor in aState) then
   if  ((aNode.Selected or aNode.DropTarget or (gdClicked in aState)) and ((aCol>=Selection.Left) and (aCol<=Selection.Right)) {and (PointInGridRect(aCol, aRow, Selection))}) then
   begin
      if (Focused{GetFocus = Self.Handle}) or FAsFocused then //new 15/06/2001
      begin
        aColor    := clHighlight;
        aFontColor:= clHighlightText;
        aChanged := True;
      end
      else if not FHideSelection then
      begin
        aColor    := clInactiveCaption;
        aFontColor:= clHighlightText;
        aChanged  :=true;
      end;
   end;
end;

procedure TCustomRapidTree.Selecting(aCol, aRow : Longint; Node : TFlyNode; Shift: TShiftState; MoveAnchor : Boolean);
var //aNNode : TFlyNode;
   aRow1, DRow, i : integer;
//   Shift : TShiftstate;
procedure DoSelection(aRow : integer; State : boolean);
var aNode : TFlyNode;
begin
 aNode := GetNodeAtRow(aRow);
 if (aNode <> nil) then
 begin
   aNode.Selected := State;
   //InvalidateRow(aRow)
 end;
end;
begin
//Selecting management
  if Node = nil then exit;
  //Shift := GetOptimalKeys;
  if (ssShift in Shift) and (goRangeSelect in Options) then
  begin
     //flush selection
     if FAnchorNode <> nil then
     begin
        aRow1:=FanchorNode.GetRow;
        if LastSel <> nil then
        begin
           Flushselection;
           Drow := LastSel.Getrow;
           if DRow>aRow then
             for i:= aRow to DRow do Doselection(i,false)
           else
             for i:= DRow to aRow do Doselection(i, false);
           end
           else Flushselection;
           LastSel := GetNodeatRow(aRow);
           //FlushSelection;
           if aRow1>aRow then
             for i:=aRow to aRow1 do Doselection(i,True)
           else
             for i:=aRow1 to aRow do Doselection(i, True);
        end;
  end
  else if (ssCtrl in Shift) and (goRangeSelect in Options) and not MoveAnchor then
  begin
      LastSel := GetnodeAtRow(aRow);//getkeyboardstate
      if (LastSel <> nil) then //will be invalidated on
      begin
        LastSel.FSelected:= not LastSel.FSelected;
        invalidateRow(LastSel.GetRow);
      end;
      FAnchorNode := LastSel;
  end;
{  else
  begin
    LastSel := GetnodeAtRow(aRow);//getkeyboardstate
    if LastSel<>nil then
    begin
//       if not MouseCapture then FlushSelection;
       LastSel.FSelected:= true;
       FAnchorNode := LastSel;
    end;
  end;
}
end;

function TCustomRapidTree.ChangeState(Node: TFlyNode; StateIndex : integer) : Boolean;
begin
   Result :=true;
   Node.FStateIndex := StateIndex;
   InvalidateCell(FStructureCol, Node.GetRow);
end;

procedure TCustomRapidTree.SizeChanged(OldColCount, OldRowCount: Longint);
begin
  inherited;
  if (FFitHeight) and (Wordwrap) then
    RefreshRowHeights;

end;

function TCustomRapidTree.SelectCell(var ACol, ARow: Longint; MoveAnchor : Boolean;  Shift: TShiftState; SelWay : TSelectionWay): Boolean;
var OldRow          : longint;
   aNewNode, aNode : TFlyNode;
   i : integer;
begin

   OldRow := Row;
   Result:=false;
   aNode := GetNodeatRow(OldRow);
   anewNode := GetNodeAtRow(aRow);
   if (aNewNode <> nil) and (aCol>=FixedCols) then
   begin
      if CanChange(anewNode) then
       if inherited SelectCell(ACol, ARow, MoveAnchor, Shift, SelWay) then
       begin
            Result := True;
       end;
   end
   else if (FrootNode.FNodeList.count=0) and (aNewNode=nil) then
      Result:=true;
  //end;

   if Result then
   begin
     if MoveAnchor then //new 4/3/2002
     begin
       FAnchorNode := GetNodeAtRow(aRow);
     end;
     if (SelWay = swByMouse) or (ssShift in Shift) then
       Selecting(aCol, aRow, GetNodeatRow(aRow), Shift, MoveAnchor);
     Change(anewNode);

{     if (anewNode <> nil) and (aNode <> aNewNode)then
      if (FShowImages) and (aNewNode.FImageIndex <> aNewNode.FSelectedIndex) then
        invalidateCell(FStructureCol,anewNode.GetRow);
}
   end;

   if FAutoExpand and (FRootNode.Count > 0) and Result and not FExpanding then
   begin
//    aNode := GetNodeAtRow(OldRow);
      FRootNode.BeginUpdate;
      try
      if (aNewNode<>nil) then
      begin
        aNewNode.expanded:= not aNewNode.expanded;
        if (anewNode<>aNode) then
        for i:=0 to FRootNode.Count-1 do
        begin
           if FRootNode[i].Expanded and not aNewNode.HasAsParent(FRootNode[i]) and
           (aNewNode <> FRootNode[i]) then
              FRootNode[i].Collapse(True);
        end;
        aRow:=anewNode.GetRow;
       end;

      finally
        FRootNode.EndUpdate;
      end;
      //FGridstate := gsNormal;
   end;//if FautoExpand
end;

type
  TDDaRec = record
    aDC : HDC;
    Vflag : boolean;
    aColor : longint;
  end;

procedure TCustomRapidTree.InternalLineTo(aCanvas : TCanvas; X,Y  : integer; Vline : Boolean);
var
   aDDaRec : TDDaRec;
   OldMode                   : TPenMode;
procedure MyLineDDAProc(aX,aY : Integer; adata : LPARAM);stdcall;
begin
     if ((TDDaRec(Pointer(adata)^).VFlag) and odd(aY)) or
     (not (TDDaRec(Pointer(adata)^).VFlag) and odd(aX)) then
     begin
        //more faster method for set pixel
        SetPixelV(TDDaRec(Pointer(adata)^).aDC, aX, aY, TDDaRec(Pointer(adata)^).aColor);
     end;

end;
begin
   oldMode := aCanvas.pen.mode;
   with aCanvas do
   try
      //aCanvas.pen.mode:=pmMergePenNot;
      aDDaRec.aDC:=aCanvas.Handle;
      aDDaRec.aColor := ColortoRGB(FOutlineColor);
      aDDaRec.VFlag:=Vline;
      LineDDA(PenPos.X, PenPos.Y, X, Y, @MyLineDDAProc, LPARAM(@aDDaRec));
   finally
     aCanvas.pen.mode:= Oldmode;
   end;
   
end;

procedure TCustomRapidTree.SetButtonSize(const Value : integer);
begin
   if (FButtonSize <> Value) and (Value <= FIndent) then
   begin
     if not Odd(Value) then
       FButtonSize := Value-1
     else
       FButtonSize := Value;
     Invalidate;
   end;
end;

procedure TCustomRapidTree.DrawButton(aCanvas : TCanvas; aNode : TFlyNode; aindex :  integer; aRect : TRect);
var aNRect : TRect;
    newL, NewT{, aWidth, IntIndent} : integer;
    aFlags : integer;
procedure DrawBox(DRect : TRect);
begin
 with aCanvas do
 begin
  Pen.Color := FOutlineColor;
  with aNrect do
     Rectangle(left,Top, Right, Bottom);
{  InflateRect(aNRect,1,1);
  Brush.Color := Color;
  FrameRect(aNrect);
}  
 end;
end;

var aColor : TColor;
    achange : boolean;
    CtrPos : TPoint;
begin

  if TRapidBitmap(aIndex) in [obCollapsed, obExpanded] then
     anRect.Left := GetCX(aNode.Level) - (FButtonSize div 2)
  else
  begin
    aNRect.Left:= aRect.left + ((FIndent - FButtonSize) div 2);//((IntIndent - aWidth) div 2);
    if not Odd(aNRect.Left) then Inc(aNRect.Left)
  end;
  anRect.Top:=aRect.Top + (((aRect.Bottom - aRect.Top) - FButtonSize) div 2);
  anRect.Right:=aNRect.Left + FButtonSize;
  anRect.Bottom:=aNRect.Top + FButtonSize;

  if not Odd(anRect.Top) then
     OffsetRect(anRect, 0, 1);

  if Ctl3d then
   aFlags:=0
  else
   aFlags :=DFCS_FLAT;

  with aCanvas do
  begin
   aColor:=Brush.Color;
   if Brush.Color<> clWindow then
   begin
     Brush.Color:=clWindow;
     aChange:=true;
   end
   else
    aChange:=false;
   end;
  if (not (aIndex in [Ord(obCollapsed),Ord(obExpanded)])) then
  begin
   if (aFlags=0) then
     inflateRect(aNrect,1,1);
//   if FShowroot then //critical
//     offsetrect(aNrect, FIndent, 0);
  end;
  with aCanvas do
    Case aIndex of
       {Ord(obEmpty):
       begin
          if aFlags=0 then inflateRect(aNrect,1,1);
          DrawFrameControl(aCanvas.Handle, aNRect,DFC_BUTTON, DFCS_BUTTONPUSH+DFCS_MONO+aFlags);
       end;}
       Ord(obUnchecked):
       begin
          //if aFlags=0 then inflateRect(aNrect,1,1);
          DrawFrameControl(aCanvas.Handle, aNRect,DFC_BUTTON, DFCS_BUTTONCHECK+aFlags);
       end;
       Ord(ObChecked):
       begin
          //if aFlags=0 then inflateRect(aNrect,1,1);
          DrawFrameControl(aCanvas.Handle, aNRect,DFC_BUTTON, DFCS_BUTTONCHECK+DFCS_CHECKED+aFlags);
       end;
       Ord(ObGrayedChecked):
       begin
          //if aFlags=0 then inflateRect(aNrect,1,1);
          DrawFrameControl(aCanvas.Handle, aNRect,DFC_BUTTON, DFCS_BUTTONCHECK+DFCS_CHECKED+DFCS_INACTIVE+aFlags);
       end;
       Ord(ObGrayedUnChecked):
       begin
          //if aFlags=0 then inflateRect(aNrect,1,1);
          DrawFrameControl(aCanvas.Handle, aNRect,DFC_BUTTON, DFCS_BUTTONCHECK+DFCS_INACTIVE+aFlags);
       end;
       Ord(ObOptioned):
       begin
          //if aFlags=0 then inflateRect(aNrect,1,1);
          DrawFrameControl(aCanvas.Handle, aNRect,DFC_BUTTON, DFCS_BUTTONRADIO+DFCS_CHECKED+aFlags);
       end;
       Ord(ObGrayedOptioned):
       begin
          //if aFlags=0 then inflateRect(aNrect,1,1);
          DrawFrameControl(aCanvas.Handle, aNRect,DFC_BUTTON, DFCS_BUTTONRADIO+DFCS_CHECKED+DFCS_INACTIVE+aFlags);
       end;

       Ord(ObUnOptioned):
       begin
          //if aFlags=0 then inflateRect(aNrect,1,1);
          DrawFrameControl(aCanvas.Handle, aNRect,DFC_BUTTON, DFCS_BUTTONRADIO+aFlags);
       end;

       Ord(ObGrayedUnOptioned):
       begin
          //if aFlags=0 then inflateRect(aNrect,1,1);
          DrawFrameControl(aCanvas.Handle, aNRect,DFC_BUTTON, DFCS_BUTTONRADIO+DFCS_INACTIVE+aFlags);
       end;

       Ord(ObGrayedDoubleChecked):
       begin
          //if aFlags=0 then inflateRect(aNrect,1,1);
          DrawFrameControl(aCanvas.Handle, aNRect,DFC_BUTTON, DFCS_BUTTONCHECK+DFCS_INACTIVE+aFlags);
          if aFlags=0 then
            inflateRect(aNrect,-2,-2)
          else
            inflateRect(anRect,-1,-1);
          if aGDCBmp = nil then
             InitDoubleChecks;
          newL := anRect.Left+ (((anRect.Right - anRect.Left) - aGDCBmp.Width) div 2);
          newT := anRect.Top+ (((anRect.Bottom - anRect.Top)- aGDCBmp.Height) div 2);
          aCanvas.Draw(newL, newT, aGDCBmp);

       end;

       Ord(ObDoubleChecked):
       begin
          //if aFlags=0 then inflateRect(aNrect,1,1);
          DrawFrameControl(aCanvas.Handle, aNRect,DFC_BUTTON, DFCS_BUTTONCHECK+aFlags);
          if aFlags=0 then
            inflateRect(aNrect,-2,-2)
          else
            inflateRect(anRect,-1,-1);
          if aDCBmp = nil then
             InitDoubleChecks;
          newL := anRect.Left+ (((anRect.Right - anRect.Left) - aDCBmp.Width) div 2);
          newT := anRect.Top+ (((anRect.Bottom - anRect.Top)- aDCBmp.Height) div 2);
          aCanvas.Draw(newL, newT, aDCBmp);
       end;

       Ord(obCollapsed)://getdevicecaps
       begin
          DrawBox(aNrect);
          Pen.Color := clBlack;
          with aNRect do
          CtrPos:=Point(Left+(Right-Left) div 2, Top+(Bottom-Top) div 2);
          {$ifdef DFS_COMPILER_4_UP}
          if UseRightToLeftAlignment then
             inc(CtrPos.X);
          {$endif}
          MoveTo(CtrPos.X,CtrPos.Y);
          LineTo(CtrPos.X-3,CtrPos.Y);
          MoveTo(CtrPos.X,CtrPos.Y);
          LineTo(CtrPos.X+3,CtrPos.Y);
          MoveTo(CtrPos.X,CtrPos.Y);
          LineTo(CtrPos.X,CtrPos.Y-3);
          MoveTo(CtrPos.X,CtrPos.Y);
          LineTo(CtrPos.X,CtrPos.Y+3);
       end;
       Ord(obExpanded):
       begin
          DrawBox(aNrect);
          Pen.Color := clBlack;
          with aNRect do
          CtrPos:=Point(Left+(Right-Left) div 2, Top+(Bottom-Top) div 2);
         {$ifdef DFS_COMPILER_4_UP}
          if UseRightToLeftAlignment then
             inc(CtrPos.X);
          {$endif}
          MoveTo(CtrPos.X,CtrPos.Y);
          LineTo(CtrPos.X-3,CtrPos.Y);
          MoveTo(CtrPos.X,CtrPos.Y);
          LineTo(CtrPos.X+3,CtrPos.Y);
       end;

    end;

  with aCanvas do
  if aChange then
    Brush.Color := aColor;

end;

function TCustomRapidTree.GetCX(NLevel : integer) : integer;
begin
  Result := CellRect(StructureCol, 0).Left - ColOffset;
  inc(Result, (NLevel * FIndent) + (FIndent div 2));
  if not Odd(Result) then Inc(Result);
end;

procedure TCustomRapidTree.DrawStructureButtonsLines(aCanvas : TCanvas; aNode : TFlyNode; aRow : Longint; aCol : integer; var aRect : TRect; aState : TExGridDrawState; aDrawOptions : TDrawOptions);
var aStIndex, ImageXDelta, ImageYDelta : integer;

procedure DrawLineAndButton(ARect: TRect; Node: TFlyNode);
var newrect : Trect;
    {OFI,} W, AIndex, cx, cy      : Integer;
    TopPart, BottomPart : Boolean;
    aNode: TFlyNode;
    OldPenWidth : integer;
    OldPenColor : TColor;
begin
   {!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
   //   - -    (  !!!!!!!!!!)
   {!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
   newrect:=Rect(aRect.left, aRect.top, arect.left+(aRect.bottom-aRect.top),aRect.Bottom);
   OldPenColor := aCanvas.Pen.Color;
   OldPenWidth := aCanvas.Pen.Width;
   if (FOutlineStyle = olsExcel) then
   begin
      aCanvas.Pen.Width :=2;
      aCanvas.Pen.color := FOutlineColor;
   end;
   try
      //AIndex :=-1;
      with aCanvas do
      begin
         if (FShowLines) and (doDrawlines in aDrawOptions) then
         begin
           //calculate position of lines
            if Odd(NewRect.Top) then Dec(NewRect.Top);
            if not Odd(NewRect.Bottom) then inc(NewRect.Bottom);

            cx := GetCX(Node.Level);//newrect.Left+ FIndent div 2; //21/12/01
            cy := newrect.Top + (newrect.Bottom - newrect.Top) div 2;

            if not Odd(cy) then inc(cy);
            if not Odd(cx) then dec(cx);

           TopPart := Node.GetPrevVisible<>nil;
           BottomPart := Node.GetNextVisibleSibling<>nil;
           //Result := Findent;
           if FoutlineStyle = olsStandardTree then
           begin
            if TopPart and Bottompart then
            begin
              PenPos := Point(cx, NewRect.Top-1);
              InternalLineTo(aCanvas, cx, NewRect.Bottom+1, true);
            end
            else if TopPart then //draw half vertical line, top portion.
            begin
              PenPos := Point(cx, NewRect.Top-1);
              InternalLineTo(aCanvas, cx, cy, True);
            end
            else if BottomPart then //draw half vertical line, bottom portion.
            begin
              PenPos := Point(cx, cy);
              InternalLineTo(aCanvas, cx, NewRect.Bottom+1, True);
            end;
            PenPos := Point(cx{+2}, cy);//horizontal connect
            InternalLineTo(aCanvas, cx+(FIndent div 2), cy, False);
           end
           else if (FOutlineStyle in [olsExplorer, olsExcel]) then
           begin
             if (Node.Level>0) then
             begin
              if TopPart then
              begin
               PenPos := Point(cx-FIndent, NewRect.Top-1);
               if FOutlineStyle = olsExplorer then
                 InternalLineTo(aCanvas, cx-FIndent, Cy, True)
               else
                 ACanvas.LineTo(cx-FIndent, Cy);
              end;
              if BottomPart then
              begin
               PenPos := Point(cx-FIndent, cy);
               if FOutlineStyle = olsExplorer then
                 InternalLineTo(aCanvas, cx-FIndent, NewRect.Bottom+1, True)
               else
                 ACanvas.LineTo(cx-FIndent, NewRect.Bottom+1);
              end;

              if BottomPart and (FoutlineStyle = olsExcel) then
              begin
               W := FIndent shr 3;
               if W = 0 then W := 1;
               PatBlt(Canvas.handle, cx-(FIndent div 2)-W, Cy, W, W, BLACKNESS);
              end;

              if not BottomPart then//horizontal line
              begin
               PenPos := Point(cx-FIndent, cy);
               if (FOutlineStyle = olsExplorer) then
                  InternalLineTo(aCanvas, cx-(FIndent div 2), Cy, false)
               else
                  ACanvas.LineTo(cx-(FIndent div 2), Cy);
              end;
             end;
           end;


           //connect to Parents
           aNode := Node.Parent;
           while (aNode <> nil) and not ((aNode.Level=0) and (FOutlineStyle <> olsStandardTree)) do
           begin
               cx := GetCX(aNode.Level);//Dec(cx, FIndent);
               if FOutlineStyle <> olsStandardTree then
                  Dec(cx, FIndent);
               if aNode.GetNextVisibleSibling <> nil then
               begin
                  PenPos := Point(cx, NewRect.Top-1);
                  if (FOutlineStyle <> olsExcel) then
                    InternalLineTo(aCanvas, cx, NewRect.Bottom+1, True)
                  else
                    ACanvas.LineTo(cx, NewRect.Bottom+1);
               end;
               aNode := aNode.Parent;
           end;
       end;

         if FShowButtons and (doDrawButtons in aDrawOptions) then
         begin
            if Node.HasChildren and (not Node.FAllHidden) then
            begin
               if Node.Expanded then
                  AIndex := ord(obExpanded)
               else
                  AIndex := ord(obCollapsed);
            end
            else aIndex:=-1;

            if (FOutlineStyle = olsExcel) then
            begin
               aCanvas.Pen.Color := OldPenColor;
               aCanvas.Pen.Width := OldPenWidth;
            end;
            // drawbutton Image
            if AIndex <>-1 then
            begin
             if FStatesDrawed then
             begin
               DrawButton(aCanvas, Node, aindex, aRect)
             end
             else
             begin
               DrawImagelistPic(aCanvas, Node, aindex, aRect);
             end;
             //Result:=Findent; //setup aRect;
            end;
         end;//showbuttons


      end;//with
   except
      Error('Error Draw Item');
   end;
end;

var aBitmap : TBitmap;
    arFontColor, arColor, aFontColor, aColor         : TColor;
    AbmpEmpty, aChanged : boolean;
//    aIndex : integer;
begin
   aStIndex:=-1;
   AbmpEmpty := True;
   if aCol = FStructureCol then //drawing structure cell
   begin
      if aNode <> nil then
      begin
       if (goRowSelect in Options) then //or ((Style<> ttsNormal) and ({FFirstLevel and (}aNode.Level=0{)}) then
       with aCanvas do
       begin
         aColor :=Brush.Color;
         aRColor := aColor;
         aFontColor:= aCanvas.Font.Color;
         arFontColor := aFontColor;
         aChanged  :=false;
         GetColor(aNode, aCol, aRow, aState, aColor, aFontColor, aChanged);

         DrawBackground(aCanvas, ARect,aCol,aRow,aState);

         if aChanged then //restore
         begin
            Brush.Color      := arColor;
            aCanvas.Font.Color:= arFontcolor;
         end;

       end;

       if (FShowRoot) or (aNode.Level>0) then //level dependent
          inc(aRect.Left, (aNode.Level * FIndent));
          //aRect.Left := aRect.Left + (aNode.Level * FIndent);

         if (FShowButtons or FShowLines) and (FShowRoot or (aNode.Level>0))then
         begin
            DrawLineAndButton(aRect, aNode);
            inc(aRect.Left, FIndent);
         end;

         if FShowLogic then
         begin//obEmpty, obChecked, obUnchecked, obGrayed, obOptioned, obUnoptioned
            if (doDrawStates in aDrawOptions) then
            begin

               if aNode.stateIndex <>-1 then
               begin
                  case aNode.stateIndex of
                     STATE_EMPTY : aStIndex := ord(obEmpty);
                     STATE_UNCHECKED : aStIndex := ord(obUnchecked);
                     STATE_CHECKED   : aStIndex := ord(obChecked);
                     STATE_GRAYEDCHECKED  : aStIndex := ord(obGrayedChecked);
                     STATE_GRAYEDUNCHECKED  : aStIndex := ord(obGrayedUnChecked);
                     STATE_OPTIONED     : aStIndex := ord(obOptioned);
                     STATE_UNOPTIONED    : aStIndex := ord(obUnoptioned);
                     STATE_GRAYEDOPTIONED:   aStIndex := ord(obGrayedOptioned);
                     STATE_GRAYEDUNOPTIONED: aStIndex := ord(obGrayedUnoptioned);
                     STATE_DOUBLECHECKED: aStIndex := ord(obDoubleChecked);
                     STATE_GRAYEDDOUBLECHECKED: aStIndex := ord(obGrayedDoubleChecked);


                  end;

                  if FStatesDrawed then
                  begin
                   if aNode.stateIndex<>STATE_EMPTY then
                   begin
                    {$ifdef DFS_COMPILER_4_UP}
                    if UseRightToLeftAlignment then
                      offsetRect(arect, GetCheckSize,0);
                    {$endif}
                    Drawbutton(aCanvas, aNode, aStIndex, aRect);
                    {$ifdef DFS_COMPILER_4_UP}
                    if UseRightToLeftAlignment then
                      offsetRect(arect, -GetCheckSize,0);
                    {$endif}
                    inc(aRect.Left, FIndent);
                   end;
                  end
                  else
                  begin
                     DrawImagelistPic(aCanvas, aNode, aStIndex, aRect);
                     inc(aRect.Left, FIndent);
                  end;
               end;
            end;

         end;
         //----------------------------------
         if (FShowimages) then
         begin
            if (doDrawImages in aDrawOptions) then
            begin
                  aBitmap:=TBitmap.Create;
                  try
                     if (gdSelected in aState) or (aRow = Row) then
                     begin
                        if Assigned(FongetselectedIndex) then
                          ongetselectedIndex(Self, aNode);
                          if ((aNode.SelectedIndex >= 0) {and (aNode.SelectedIndex < images.Count-1)}) then
                            GetBitmap(aNode, aNode.SelectedIndex,aBitmap)
                     end
                     else
                     begin
                        if Assigned(FongetImageIndex) then
                          FongetImageIndex(Self, aNode);
                         if ((aNode.ImageIndex >= 0) {and (aNode.ImageIndex < images.Count-1)}) then
                           GetBitmap(aNode, aNode.Imageindex,aBitmap);
                     end;
                     ImageYDelta := ((aRect.Bottom-aRect.Top)-aBitmap.height) div 2;
                     ImageXDelta := (FIndent - aBitmap.Width) div 2;

                     AbmpEmpty := aBitmap.empty;
                     if not AbmpEmpty then
                     begin
                     {$IFDEF DFS_COMPILER_2}
                       aCanvas.Brushcopy(rect(aRect.Left+ImageXDelta, aRect.Top+ImageYDelta, ImageXDelta+aBitmap.Width{FIndicators.width}, ImageYDelta+aBitmap.Height{FIndicators.Height}),aBitmap,
                       Rect(0,0, aBitmap.Width{FIndicators.width}, aBitmap.Height{FIndicators.Height}), abitmap.canvas.pixels[0, aBitmap.Height-1]);
                     {$ELSE}
                     if FTransparentmode then
                     begin
                       aBitmap.Transparent:=true;
                       aBitmap.TransparentColor:=aBitmap.Canvas.Pixels[aBitmap.Width-1,aBitmap.height-1];//Canvas.Pixels[Pt.X,Pt.y];//
                       aBitmap.TransparentMode := tmAuto;
                     end;
                     //aCanvas.Draw(aRect.Left+ImageXDelta, aRect.Top+ImageYDelta, aBitmap);
                     {$ifdef DFS_COMPILER_4_UP}
                     if UseRightToLeftAlignment then
                       aCanvas.StretchDraw(Rect(aRect.Left+ImageXDelta+aBitmap.width, aRect.Top+ImageYDelta, aRect.Left+ImageXDelta, aRect.Top+ImageYDelta+aBitmap.Height), aBitmap)
                     else
                        aCanvas.StretchDraw(Rect(aRect.Left+ImageXDelta, aRect.Top+ImageYDelta, aRect.Left+ImageXDelta+aBitmap.Width, aRect.Top+ImageYDelta+aBitmap.Height), aBitmap);
                     {$ELSE}
                        aCanvas.StretchDraw(Rect(aRect.Left+ImageXDelta, aRect.Top+ImageYDelta, aRect.Left+ImageXDelta+aBitmap.Width, aRect.Top+ImageYDelta+aBitmap.Height), aBitmap);
                     {$ENDIF}
                     {$ENDIF}
                    end;
                  finally
                     aBitmap.Free;
                  end;
            end;
            if not AbmpEmpty then
              inc(aRect.Left, FIndent);
         end;
      end;
   end;

end;


// Here we only prepare AState flags for inherited call to DrawCell
procedure TCustomRapidTree.DrawCell(aCanvas : TCanvas; ACol, ARow: Longint; ARect: TRect;
AState: TExGridDrawState; Var Continue : boolean);
var
   aNode : TFlyNode;
begin
   try
      aNode := GetNodeatRow(aRow);
      with aCanvas do
      begin
        Brush.Color := Self.Color;
        Font.Color := Self.Font.Color;
      end;

      if (aNode<>nil) then
      begin
        if (aNode.Selected) and ((aCol>=Selection.Left) and (aCol<=Selection.Right)) then//PointInGridRect(aCol, aRow, Selection) then//) or (goRowSelect in Options)) then
          include(aState, gdSelected)
        else if not (aNode.Selected) then
        begin
          exclude(aState, gdSelected);
          if goRowSelect in Options then
            exclude(aState, gdFocused);
        end;
      end;
      //special flag
      if gdNoUseSelColor in aState then
      begin
         exclude(aState, gdSelected);
         exclude(aState, gdFocused);
      end;
      include(aState, gdPrepaint);
      DrawBackground(aCanvas, ARect,aCol,aRow,aState);
      exclude(aState, gdPrepaint);

      if gdFixed in aState then //drawing fixed cols
      begin
         DrawFixed(aCanvas, aRect, aCol, aRow, aState,Continue);
         //InflateRect(ARect, -1, -1);//--???
      end;

    if aNode<>nil then
    begin
      //if aNode = FRClickNode then
      //    include(aState, gdClicked);
      if (aCol = FStructurecol)  then
         DrawStructureNode(aCanvas, aNode, aRect, aCol, aRow, aState,Continue)
      else if {not (gdFixed in aState) and} (aCol<Colcount) then
         DrawDataNode(aCanvas, aNode, aRect, aCol, aRow, aState, Continue);
    end;

   finally
      inherited;
   end;
end;

procedure TCustomRapidTree.FullCollapse;
var
   Node : TFlyNode;
begin
 Items.BeginUpdate;
 try
   Node := FRootNode.GetFirstNode;
   while Node <> nil do
   begin
      Node.Collapse(True);
      Node := Node.GetNextSibling;
   end;
 finally
    items.Endupdate;
    Invalidate;
 end;
end;

procedure TCustomRapidTree.FullExpand;
var
   Node : TFlyNode;
begin
 Items.BeginUpdate;
 try
   Node := Items.GetFirstNode;
   while Node <> nil do
   begin
      Node.Expand(True);
      Node := Node.GetNextSibling;
   end;
 finally
    items.Endupdate;
    Invalidate;
 end;

end;

function TCustomRapidTree.CanCollapse(Node: TFlyNode): Boolean;
begin
   Result := True;
   if Assigned(FOnCollapsing) then FOnCollapsing(Self, Node, Result);
end;

function TCustomRapidTree.CanExpand(Node: TFlyNode): Boolean;
begin
   Result := True;
   if Assigned(FOnExpanding) then FOnExpanding(Self, Node, Result);
end;

procedure TCustomRapidTree.Expand(Node: TFlyNode);
begin
   if Assigned(FOnExpanded) then FOnExpanded(Self, Node);
end;

procedure TCustomRapidTree.Collapse(Node: TFlyNode);
begin
   if Assigned(FOnCollapsed) then FOnCollapsed(Self, Node);
end;

procedure TCustomRapidTree.Delete(Node: TFlyNode);
//var aRow : integer;
begin
   if csDestroying in Componentstate then
      exit;
   if Assigned(FOnDeletion) then FOnDeletion(Self, Node);
end;

function TCustomRapidTree.CanEditShow: Boolean;//selectcell
var aNode : TFlyNode;
begin
   Result := inherited CanEditShow;
   if HandleAllocated and not (csDestroying in ComponentState) then
   begin
   aNode := GetNodeAtRow(Row);
   if Result then
    if (aNode<>nil) and Assigned(FOnEditing) then
      FOnEditing(Self, aNode, Result);
   end;   
end;


function TCustomRapidTree.CanChange(Node: TFlyNode): Boolean;
begin
   Result := True;
   if Assigned(FOnChanging) then FOnChanging(Self, Node, Result);
end;

procedure TCustomRapidTree.Change(Node: TFlyNode);
begin
   if Assigned(FOnChange) then FOnChange(Self, Node);
end;

procedure TCustomRapidTree.ExpandItem(Node : TFlyNode; Expand : Boolean);
begin
   //
end;

function TCustomRapidTree.InSelection(aCol, aRow : integer) : Boolean;
var aNode : TFlyNode;
begin
   Result := False;
   if inherited InSelection(aCol, aRow) then
   begin
     aNode := GetNodeatRow(aRow);
     if aNode <> nil then
       Result := aNode.Selected;
   end;
end;

procedure TCustomRapidTree.FocusCell(ACol, ARow: Longint; MoveAnchor : Boolean;  Shift: TShiftState;  SelWay : TSelectionWay);
var aNode : TFlyNode;
begin
    if ShowImages then
    begin
       aNode := GetNodeatRow(Row);
       if aNode <> nil then
        if (Col <> StructureCol) and (aNode.SelectedIndex <> -1) then
        begin
         if goRowSelect in Options then
          invalidateRow(Row)
         else
          invalidateCell(StructureCol, Row);
        end;

       aNode := GetNodeatRow(aRow);
       if aNode <> nil then
        if (aCol <> StructureCol) and (aNode.SelectedIndex <> -1) then
        begin
         if goRowSelect in Options then
          invalidateRow(aRow)
         else
          invalidateCell(StructureCol, aRow);
        end;
    end;

    if (Row <> aRow) then //or (Selected = nil)
    begin
      if (not (goRangeSelect in Options)) or (MoveanChor) then
         SelectOne(aRow);
    end;

   inherited;

end;

procedure TCustomRapidTree.SelectItem(Node : TFlyNode);
var aRow : longint;
    aRect : TGridRect;
begin
   if (Node<>nil) then
   begin
      Node.MakeVisible;
      aRow := Node.Getrow;
      if (aRow<>-1) {and (aRow<>Row)} then
      begin
        with aRect do
        begin
          Top := aRow;
          Bottom := aRow;
          Left := Selection.Left;
          Right := Selection.Right;
        end;
        InvalidateRect(aRect);
        //if (goRowSelect in Options)  then
        //  InvalidateRow(aRow)
        //else
        //  invalidateCell(FStructureCol, aRow);
      end;
   end;
end;

function TCustomRapidTree.CreateNode(AOwner: TTreeCollection) : TFlyNode;
begin
   Result := TFlyNode.Create(aOwner);
end;

function TCustomRapidTree.GetLastVisibleNode : TFlyNode;
//var aNode : TFlyNode;
begin
{   Result := nil;
   if FRootNode.Count > 0 then
      aNode := FRootNode.item[FRootNode.Count-1]
   else aNode :=nil;

   while aNode <> nil do
   begin
      Result := aNode;
      if aNode.Expanded then
         aNode := aNode.GetLastChild
      else aNode:=nil;
   end;
}
 if FRootnode.FNodeList.Count > 0 then
   Result := FRootnode.FNodeList[FRootnode.FNodeList.Count-1]
 else
   Result:=nil;
end;

function TCustomRapidTree.GetNextVisible(Node : TFlyNode): TFlyNode;
var aIndex : integer;
begin
   aIndex:=FRootnode.FNodeList.IndexOf(Node);
   if (aIndex<>-1) and (aIndex+1<FRootnode.FNodeList.Count) then
     Result:=TFlyNode(FRootnode.FNodeList[aindex+1])
   else
   begin
     Result := Node.GetNext;
     While Result <> nil do
     begin
        if Result.IsVisible then
        begin
           break;
        end
        else
          Result := Result.GetNext;
     end;
   end;
end;

function TCustomRapidTree.GetPrevVisible(Node : TFlyNode): TFlyNode;
    var aindex : integer;
begin
   aindex:=Frootnode.FnodeList.indexOf(Node);
   if (aindex<>-1) and not (aindex-1 < 0) then
     Result:=TFlyNode(Frootnode.FnodeList[aindex-1])
   else
   begin
     Result := Node.GetPrev;
     While Result <> nil do
     begin
        if Result.IsVisible then
        begin
           break;
        end
        else
          Result := Result.GetPrev;
     end;
   end;
end;

//    procedure CollapseNodeList(aNode: TFlyNode; atIndex : Longint; Recurse : Boolean);//removing from Nodelist collapsed values
//    procedure ExpandNodeList(aNode: TFlyNode; var atIndex : Longint; Recurse : Boolean);

Procedure TCustomRapidTree.SetFirstLevelDrawMode(aValue : boolean);
begin
  FFirstLevel:=aValue;// for drawing entire cell in first level
end;

procedure TCustomRapidTree.RefreshNodeList(aNode : TFlyNode);
var i, atIndex : Longint;

procedure AddSubItem(anode : TFlyNode);
var i : integer;
begin
  if aNode.Expanded then
   for i:=0 to aNode.Count-1 do
      with FrootNode.FNodeList do
      if not aNode[i].Hidden then //new feature
      begin
       if aNode.Expanded then
           Add(aNode[i]);
         aNode[i].Fowner := FrootNode;
         AddSubItem(aNode[i]);
      end
end;
begin
   //aSelNode :=nil;
   //aSelNode := Selected;
   if aNode = nil then
   begin
      FrootNode.FNodeList.Clear;
      for i:=0 to FrootNode.Count-1 do
         with FrootNode.FNodeList do
         begin
          if not FRootNode.ISMeta(i) then
          begin
           if not FRootNode.Item[i].Hidden then //new feature
           begin
              Add(FRootNode.Item[i]);
              FrootNode.Item[i].Fowner := FrootNode;
              AddSubItem(FrootNode.Item[i]);
           end;
          end
          else
          begin
             Add(FRootNode.GetPointer(i));
             //here without subitems
          end;
         end;
   end
   else if not aNode.Hidden then//New feature
   begin
      aNode.CollapseNodeList(aNode, true);//removing from Nodelist collapsed values
      atIndex :=-1;
      aNode.ExpandNodeList(aNode, atIndex, true);//internal expanding
   end;

   //if aSelNode<>nil then
   //   Row := aSelNode.Getrow;
end;

procedure TCustomRapidTree.MakeVisible(Node : TFlyNode);
begin
   Node.MakeVisible;
end;

function TCustomRapidTree.IsNodeVisible(Node : TFlyNode) : Boolean;
begin
   Result := Node.IsVisible;
end;

function TCustomRapidTree.ExtractNodeFromMetaNode(aIndex: Integer; MetaNode : TMetaNode) : TFlyNode;
begin
   if MetaNode.Parent = nil then
      Result := TFlyNode(FRootNode._Add(MetaNode.Index))
   else
       Result := TFLyNode(TFLyNode(MetaNode.Parent)._Add(MetaNode.Index));
   FRootNode.FNodeList[aIndex] := Result; //replace
   //MetaNode.Free;
end;

function TCustomRapidTree.GetNodeAtRow(aRow : Longint) : TFlyNode; // getNode at Row
var aindex : Longint;
begin
   Result:=nil;
   aindex := aRow - FixedRows;
   if (FRootNode<>nil) and (FRootNode.FNodeList <> nil) then
     if (aindex <= FrootNode.FNodeList.Count-1) and (aindex>=0) then
     begin
        if TObject(FRootNode.FNodeList[aindex]) is TFLyNode then //sizeof
          Result:=TFlyNode(FRootNode.FNodeList[aindex])
        else
        begin
            Result := ExtractNodeFromMetaNode(aIndex, TMetaNode(FRootNode.FNodeList[aindex]));
        end;
     end;
end;

function TCustomRapidTree.DisplayWidth(Node : TFlyNode) : integer;
begin
   with Canvas do
   begin
      Font  := Self.Font;
      Result:= TextWidth(Node.Caption) + 1;
   end;
end;

function TCustomRapidTree.SaveNodes : Boolean;
begin
   Result := true;
end;

procedure TCustomRapidTree.DefineProperties(Filer: TFiler);
begin
   inherited DefineProperties(Filer);
   FWithoutFixup:=true;
   if SaveNodes then
    Filer.DefineBinaryProperty('Data', ReadData, WriteData, True);
   FWithoutFixup:=false;
end;

procedure TCustomRapidTree.ReadData(Stream: TStream);
begin
   TreeColl.ReadCollectionFromStream(FRootNode, Stream);
end;

procedure TCustomRapidTree.WriteData(Stream: TStream);
begin
   TreeColl.WriteCollectionToStream(FRootNode, Stream);
end; //

//tooltip management
procedure TCustomRapidTree.WMMouseMove(var Message: TMessage);
begin
   with message do
   begin
      if ToolTips then
      begin
         if not ActivateToolTips(loword(lParam),Hiword(LongWord(lParam))) then   // CEDR 20.09.02 - range
          inherited;
      end
      else inherited;
   end;

end;

procedure TCustomRapidTree.HideToolTip;
begin
   if (FToolTip <> nil) then
   begin
      if FToolTip.HandleAllocated and
       IsWindowVisible(FToolTip.Handle) then
         ShowWindow(FToolTip.Handle, SW_HIDE);
   end;
   StopToolTipTimer;
end;

procedure TCustomRapidTree.SetToolTips(Value: Boolean);
begin
   if FToolTips <> Value then
   begin
      FToolTips := Value;
   end;
   if (FToolTips) and (Ftooltip=nil) then
   begin
      FToolTip := TISHTMLHintWindow.Create(Self);
   end
   else if (Ftooltip<>nil) and (not FToolTips)then
      begin
         FToolTip.releasehandle;
         FToolTip.Free;
         FToolTip := nil;
      end;

end;
type TControlCrack = class (TControl);

function TCustomRapidTree.ActivateToolTips(X,Y : integer) : Boolean;
var HintRect, hotrect     : Trect;
   hotNode{, aoldTracked} : TFlyNode;
   aTest                  : THitTests;
   aCoord                 : TGridCoord;
   aText                  : string;

begin
   hotNode:=Getnodeat(X,Y);
   //
   Result:= false;
   aTest := GetHittestInfoAt(X, Y);
   aCoord:=MouseCoord(X,Y);

   //if  {and (hotnode <> nil)}  then
   //begin
    if ((hotnode <> FToolTipNode) OR (FtooltipCol<>aCoord.X)) AND (HotNode<>nil) {and (htonitem in aTest)}  then
    begin
      if (aCoord.X <> -1) and (aCoord.X = FstructureCol)  then //CEDR 08.10.02
      begin
        hotRect:= hotNode.Displayrect(true);
//        aText := hotNode.Text;
        aText := GetNodeData(hotNode, aCoord.X);  // CEDR 20.09.02
      end
      else
      begin
        hotRect:= CellRect(aCoord.X,aCoord.Y);
        aText := GetNodeData(hotNode, aCoord.X);
      end;
    end
    {else if FToolTipNode<>nil then//if Showhint then
    begin
      Result:=true;
      exit;
    end}
    else if Ftooltipnode=nil then// aText:='';
    begin
       HideToolTip;
       exit;
    end;


    //if HandleAllocated then
    //begin
    //  textRect := HotRect;
    //  textRect.right := textRect.left+Canvas.TextWidth(atext);
    //end;

    //application.CancelHint;

    FToolTip.Canvas.Font:=Font;
    FToolTip.Wordwrap := FWordwrap;
    FTooltip.HTMLDrawing := FHTMLDrawing;
    {$ifdef DFS_COMPILER_3_UP}
    HintRect := FtoolTip.CalcHintRect(GetSystemMetrics(SM_CXSCREEN), aText, nil);
    {$ELSE}
     HintRect := Rect(0, 0, GetSystemMetrics(SM_CXSCREEN), 0);
     DrawText(Canvas.Handle, PChar(AText), -1, HintRect, DT_CALCRECT or DT_LEFT or
     DT_WORDBREAK or DT_NOPREFIX or DT_EXPANDTABS);
     Inc(HintRect.Right, 6);
     Inc(HintRect.Bottom, 2);
    {$ENDIF}
    FToolTipNode        := hotNode;
    if ((Hotrect.Right-HotRect.Left) < (HintRect.Right-HintRect.Left))
    and (aText<>'')then
    begin
      HideToolTip;
      //FToolTipNode        := hotNode;
      FtooltipCol         := aCoord.X;
      FToolTip.Color      := FtoolTipColor;
      StartToolTipTimer(FTooltipPause);
      offsetRect(HintRect,HotRect.left,HotRect.top);
      GetWindowRect(Handle,HotRect);
      offsetRect(HintRect,HotRect.Left,HotRect.Top);
      FtoolTip.ActivateHint(HintRect,atext);//calchintrect
      Result:=true;
    end;
end;


procedure TCustomRapidTree.StartToolTipTimer(Value: Integer);
begin
   StopTooltipTimer;
   Ftimer:=TTimer.Create(self);
   Ftimer.interval:=FTooltipPause;
   Ftimer.OnTimer:=TimerProc;
end;

procedure TCustomRapidTree.TimerProc(Sender : Tobject);
begin
   HideToolTip;
end;

procedure TCustomRapidTree.StopToolTipTimer;
begin
   if Ftimer<> nil then
   begin
      Ftimer.Free;
      Ftimer:=nil;
   end;
end;

//TFlyNode

constructor TFlyNode.Create(AOwner: TTreeCollection);
begin
   inherited Create(AOwner);
   FCells:=nil;
   FAllHidden := False;
   {$ifdef DFS_COMPILER_3_UP}
   FNodeAdapter := nil;
   {$ENDIF}
   if AOwner is TFlyNodes then
   begin
      FOwner := TFlyNodes(Aowner);
      FOwner.FSorted :=False;
   end
   else if (AOwner is TFlyNode) then
   begin
      FOwner := TFlyNode(AOwner).FOwner;
      TFlyNode(AOwner).FSorted :=False;
   end;
   {$IFDEF ACTIVEX}
   FBookmark := nil;
   {$ENDIF}
   FHeight := -1;
   //FHidden :=false;
   //FExpanded:=false;
   if FOwner<>nil then
   with FOwner do
   begin
      FStateIndex   := FDefStateIndex;
      FimageIndex   := FDefImageIndex;
      FSelectedIndex:= FDefSelectedIndex;
      //usi
      if Tree<>nil then
       if Tree.UniqueTags then
          SetUniqueTag(-1);
   end
   else
   begin
     FStateIndex   := -1;
     FimageIndex   := -1;
     FSelectedIndex:= -1;
   end;

   //FCells :=nil;
   if FOwner <> nil then
   if FOwner.UpdateCount=0 then
   if Tree<>nil then
   begin
      if AOwner is TFlyNodes then
        Tree.RefreshNodeList(nil)
      else if (AOwner is TFlyNode) then
        Tree.RefreshNodeList(TFlyNode(aOwner));

      Tree.FixupRows;
   end;
end;

destructor TFlyNode.Destroy;
var
   Node : TFlyNode;
begin
   {$ifdef DFS_COMPILER_3_UP}
   NodeAdapter := nil;
   {$ENDIF}
   FDeleting := True;
   if FOwner.Tree <> nil then
     if FOwner.Tree.FLastDropTarget = Self then
      FOwner.Tree.FLastDropTarget := nil;

   Node := Parent;
   if (Node <> nil) and (not Node.Deleting) then
   begin
      if Node.Count = 1 then //self collapse parent Node
      begin
         Node.FHasChildren:= False;
         Node.FExpanded    := False;
      end;
   end;

   if FCells <> nil then
      FCells.Free;

   if Parent <> nil then
      Parent.Removed(Self)
   else if (FOwner <> nil) then
   with TFlyNodes(FOwner) do
   begin
      Removed(Self);//FnodeList.Remove(Self);
   end;

   Data := nil;

   if (Tree <> nil)  then
   begin
     if FOwner.FMaxTag = GetUniquetag then
        Dec(Fowner.FmaxTag);
   end;

   {$IFDEF ACTIVEX}
   if FBookmark <> nil then
   begin
    Dispose(FBookmark);
    FBookmark := nil;
   end;
   {$ENDIF}

   inherited Destroy;
end;


procedure TFlyNode.Show(Recursive : boolean);
var i : integer;
begin
  if FHidden then
  begin
      SetHidden(false);
  end;
  if Recursive then
    for i:=0 to Count-1 do
      TFlyNode(Items[i]).Show(Recursive);

end;

procedure TFlyNode.Hide;
begin
   if not FHidden then
      SetHidden(true);
end;

Procedure TFlyNode.SetHidden(Value : boolean);
var i : integer;
begin
   if Value <> FHidden then
   begin
       if Owner<>nil then Owner.BeginUpdate;
       Fhidden := Value;
       if FHidden then Fselected:=false;//unselect
       //here -> Set AllHidden
       if (Parent <> nil) then
        if FHidden then
        begin
           Parent.FAllHidden := True;
           for i:=0 to Parent.Count-1 do
           if not Parent[i].FHidden then
           begin
            Parent.FAllHidden := False;
            Break;
           end;
        end
        else Parent.FAllHidden := False;

       if Owner<>nil then Owner.EndUpdate;
   end;
end;

Procedure TFlyNode.Removed(aNode: TFlyNode);
begin
   if (FOwner <> nil) then
       FOwner.Removed(aNode);
end;


function TFlyNode.GetTree: TCustomRapidTree;
begin
   Result := FOwner.Tree;//Root
end;

function TFlyNode.HasAsParent(Value: TFlyNode): Boolean;
begin
   if Value <> Nil then
   begin
      if Parent = nil then Result := False
      else if Parent = Value then Result := True
         else Result := Parent.HasAsParent(Value);
   end
   else Result := True;
end;

Function TFlyNode.GetCell(aCol : integer) : string;
begin
 if Tree<> nil then
   Result := Tree.GetNodeCells(Self, Acol)
 else if FCells <> nil then
   if (aCol <= FCells.Count-1) then
     Result := FCells[aCol];
end;

procedure TFlyNode.SetCell(aCol : integer; Value : string);
begin
 if Tree <> nil then
   Tree.SetNodeCells(Self, Acol, Value)
 else
 begin
   if FCells=nil then FCells:=TStringList.Create;
   while (aCol > FCells.Count-1) do FCells.Add('');
   FCells[aCol] := Value;
 end;
end;

function TFlyNode.GetCellsText : String;
begin
   if FCells <> nil then
     Result := FCells.Text
   else
      Result := '';
end;

procedure TFlyNode.SetCaption(value : string);
begin
   inherited SetCaption(Value);
   if Tree <> nil then
   if not ((csLoading in Tree.ComponentState) or (FOwner.UpdateCount > 0))then
   begin
    if Tree.FFitHeight and (Value <> '') then
    begin
     Tree.RecalcNodeHeight(Self);//FHeight := -1;// need to update
     Tree.InvalidateRectBelow(Self);
    end
    else
     Tree.InvalidateCell(Tree.StructureCol, Getrow);
   end;   
end;

procedure TFlyNode.SetCellsText(const Value : String);
begin
  if FCells=nil then //create on demand
    FCells := TStringList.Create;
  FCells.Text := Value;
  if Tree <> nil then
   if (Tree.FFitHeight) and (FOwner.UpdateCount = 0)then
     Tree.RecalcNodeHeight(Self);//FHeight := -1;// need to update
end;

function TFlyNode.CellsStored : Boolean;
begin
   Result := (FCells <> nil);
end;

//usi
procedure TFlyNode.SetUniqueTag(Value : Integer);
begin
  with Fowner do
   if (Tree <> nil) and Tree.UniqueTags then
   begin
       if Value = -1 then //automatically enumerate
          FUniquetag := FMaxTag+1
       else
          FUniqueTag := Value;

       if FUniquetag > FMaxTag then
          FmaxTag := FUniquetag;
   end
   else FUniqueTag := Value;
end;

function TFlyNode.GetUniqueTag : integer;
begin
  if (Tree <> nil) and Tree.UniqueTags then
     Result := FUniqueTag
  else
     Result :=-1;
end;

function TFlyNode.GetHeight : integer;
begin
  Result := FHeight;
  if Result = -1 then
   if (Tree <> nil) then
      Result:= Tree.DefaultRowHeight;
end;

procedure TFlyNode.SetHeight(Value : integer);
var aRow, oldValue : integer;
begin
   if IsVisible and (Fheight <> Value) then
      with Tree do
      begin
         aRow            := Getrow;
         FHeight         := Value;
         oldValue        := RowHeights[aRow];
         RowHeights[aRow]:= Value;
         RowSized(aRow, oldValue, Value);
      end
   else
      if (FHeight <> Value) then
         FHeight := Value;

end;


procedure TFlyNode.SetText(const S: string);
begin

   Caption := S;
   if Tree<>nil then
      if (Tree.SortType in [stText, stBoth]) and Assigned(Tree.OnCompare)
       and (not Deleting) then
      begin
         if Parent <> nil then
            Parent.AlphaSort
         else
            FOwner.AlphaSort;
      end;
end;

Function TFlyNode.GetText : String;
begin
   Result := Caption;
end;

function  TFlyNode.Getdata : Pointer;
begin
   Result:=inherited Data;
end;

{$IFDEF ACTIVEX}
procedure TFlyNode.SetBookmark(Value: Pointer);
begin
  FBookmark := Value;
end;
{$ENDIF}

procedure TFlyNode.SetData(Value: Pointer);
begin
   inherited Data := Value;
   if Tree<>nil then
   begin
      if (Tree.SortType in [stData, stBoth]) and Assigned(Tree.OnCompare)
       and (not Deleting)  then
      begin
         if Parent <> nil then Parent.AlphaSort
         else FOwner.AlphaSort;
      end;
   end;
end;

procedure TFlyNode.SetImageIndex(Value: Integer);
begin
   FImageIndex := Value;
   if Tree<>nil then
   with Tree do
   begin
      if HandleAllocated then
         InvalidateCell(FStructureCol, Getrow);
   end;
end;

procedure TFlyNode.SetSelectedIndex(Value: Integer);
begin
   FSelectedIndex := Value;
   if Tree<>nil then
   with Tree do
   begin
      if HandleAllocated then
         InvalidateCell(FStructureCol, Getrow);
   end;

end;

procedure TFlyNode.SetOverlayIndex(Value: Integer);
begin
   FOverlayIndex := IndexToOverlayMask(FOverlayIndex + 1);
   if Tree<>nil then
   with Tree do
   begin
      if HandleAllocated then
         InvalidateCell(FStructureCol, Getrow);
   end;

end;


procedure TFlyNode.SetStateIndex(Value: Integer);
begin
   if (Tree<>nil) and (FStateIndex<>Value) then
   begin
    with Tree do
    begin
      if ChangeState(Self, Value) then
      begin
         if HandleAllocated then
            InvalidateCell(FStructureCol, Getrow);
      end;
    end;
   end
   else FStateIndex := Value;

end;

function TFlyNode.DoCanExpand(Expand: Boolean): Boolean;
begin
   Result := False;
   if HasChildren and (Tree<>nil) then
   begin
      if Expand then
         Result := Tree.CanExpand(Self) // new func
      else
         Result := Tree.CanCollapse(Self); //new func
   end;
end;

procedure TFlyNode.DoExpand(Expand: Boolean);
begin
   if (HasChildren) and (Count>0) then
   begin
      if Expand then
         Tree.Expand(Self)
      else
         Tree.Collapse(Self);
   end;
end;

procedure TFlyNode.ExpandNodeList(aNode: TFlyNode; var atIndex : Longint; Recurse : Boolean);
var i       : integer;
   addFlag : boolean;
begin
   with FOwner do
   begin
      if atIndex = -1 then //init atindex
      begin
         atindex := FNodelist.indexOf(aNode);
         if atIndex=-1 then exit;
         Inc(atIndex);
      end;

      addFlag := atIndex = FNodelist.Count;//indicate method of adding
      if (atIndex <> -1) and aNode.Expanded  then
      begin

         for i:=0 to aNode.Count-1 do
         if not aNode[i].Hidden then
         begin
            if AddFlag then//adding
               FnodeList.Add(aNode[i])
            else //inserting
               FNodeList.Insert(atIndex, aNode[i]);

            inc(atIndex);
            if Recurse or aNode[i].expanded then
               ExpandNodeList(aNode[i], atIndex, Recurse);
         end;
      end;
   end;
end;

procedure TFlyNode.CollapseNodeList(aNode: TFlyNode; Recurse : Boolean);//removing from Nodelist collapsed values
var i : integer;
    ToSelect : Boolean;
    //untilNode : TFlyNode;
begin
   ToSelect := false;
   with FOwner do
   begin
      if aNode.FExpanded then
      begin
        for i:=0 to aNode.Count-1 do
        begin
           if (aNode[i].Count > 0) and (aNode[i].Expanded) then
               CollapseNodeList(aNode[i], Recurse);
            Fnodelist.Remove(aNode[i]);
            if aNode[i].Fselected then
              ToSelect := true;
            aNode[i].Fselected :=False;
        end;
      end;
   end;
   If ToSelect then
     anode.FSelected := true;//     
end;

procedure TFlyNode.ExpandItem(Expand: Boolean; Recurse: Boolean);
var
   //Flag                  : boolean;
   {i,} aRow               : integer;
   Delta                 : integer;
   aPar, FSuccess              : boolean;
   atIndex               : Longint;
   SelNode               : TFlyNode;
procedure InvalidateRows(aExpand : boolean);
var //FullRect : TRect;
    i : integer;
begin
   aRow := GetRow;
   if (Tree.handleAllocated) and (aRow <> -1) then
      with Tree do
      begin
        for i:=aRow to aRow+VisibleRowCount do
          InvalidateFullRow(i);
        { FullRect := BoxRect(0, aRow, Colcount, RowCount);
         FullRect.Right := ClientRect.Right;
         Application.ProcessMessages;
         Windows.invalidateRect(Handle, @Fullrect, true);
         }
      end;
end;

procedure CountRows;
//var OldTopRow : integer;
begin
  if Tree = nil then exit;
  //fixup rows
  if IsNodeVisible then
  begin
    //insert/DeleteRows
    //OldTopRow := Tree.TopRow;
    with Tree do
      Delta:= FrootNode.FNodeList.Count - (RowCount-FixedRows);
    aRow := GetRow;
    with Tree do
    if Delta >0 then
       InsertRows(aRow, Delta)
    else if Delta < 0 then
       DeleteRows(aRow, -Delta);


{    if SelNode<>nil then
       if SelNode.IsNodeVisible then
       begin
         SelNode.Focused :=true;
         Tree.TopRow := OldTopRow;
       end;
}
    if Delta<>0 then
         invalidateRows(Expand);
   end;
end;

procedure SubExpand(Expand : boolean);
var
  Node : TFlyNode;
begin
   if (Count>0) then
   begin
     Node := Item[0];
     while Node <> nil do
     begin
        Node.ExpandItem(Expand, Recurse); //ExpandItem(
        Node := Node.GetNextSibling;
     end;
   end;
end;

procedure EnsuretoVisibleLastItem;
//var aNode : TFlyNode;
begin
  if (Count > 0) and (Tree <> nil) then
  with Tree do
  begin
     if Count+1 > (VisibleRowCount-FixedRows) then
        TopRow := GetRow
     else if ((GetRow-TopRow)+Count) >= (VisibleRowCount) then
     begin
        TopRow := TopRow+((GetRow+Count+1) - (TopRow+VisibleRowCount));
     end;
  end;
end;

procedure EnsureTopRow;
var
  NewTopLeft, MaxTopLeft: TGridCoord;
  DrawInfo: TExGridDI;
  procedure Restrict(var Coord: TGridCoord; MinX, MinY, MaxX, MaxY: Longint);
  begin
    with Coord do
    begin
      if X > MaxX then X := MaxX
      else if X < MinX then X := MinX;
      if Y > MaxY then Y := MaxY
      else if Y < MinY then Y := MinY;
    end;
  end;
begin
 //if Tree.Selected = Self then
 with Tree do
  begin
    Items.BeginUpdate;
   try
    MaxTopLeft.X := Col;//ColCount - 1;
    MaxTopLeft.Y := GetRow;//RowCount - 1;
    CalcDI(DrawInfo);
    MaxTopLeft := CalcMaxTopLeft(MaxTopLeft, DrawInfo);
    Restrict(NewTopLeft, FixedCols, FixedRows, MaxTopLeft.X, MaxTopLeft.Y);
    if {(NewTopLeft.X <> LeftCol) or }(NewTopLeft.Y <> TopRow) then
      MoveTopLeft(Col, NewTopLeft.Y);
   finally
    Items.EndUpdate;
   end;
  end;

end;
begin
   FSuccess := (FExpanded <> Expand) and IsNodeVisible;//flag for increase/decrease rowcount
   //try
   if FSuccess and (Tree<>nil) then
     Tree.HideEditor;

   if Tree<> nil then Tree.FManualNotify := True;
   atIndex :=-1;
//   Tree.Items.BeginUpdate;
   try
      SelNode := nil;
      if (Tree <> nil) then
       if (Tree.FRootNode.Updatecount =0) and (Tree.Selected <> nil) then
         SelNode := Tree.GetNodeatRow(Tree.Row);
//     Owner.BeginUpdate;
//     try
      if Expand then
      begin
       Fexpanding := true;
       try
        if GetRow = -1 then
          MakeVisible;
        if not FExpanded then
         if DoCanExpand(True) then
         begin
            //Sort mode
            if (not FSorted) and (Tree.FSortType<>stNone) then
               AlphaSort;
            Fexpanded := True;
            ExpandNodeList(Self, atIndex, Recurse);
            if (SelNode <> nil) then
              Tree.InternalSetRow(SelNode.Getrow);
            CountRows;
            DoExpand(Expand);
            //ensure to visible <all> expanded
            EnsuretoVisibleLastItem;
         end;
       finally
        FExpanding := false;
       end;
      end
      else
      begin
         if SelNode <> nil then
            aPar := SelNode.HasAsParent(Self)
         else aPar :=false;
         if DoCanExpand(False) then
         begin
           //if Owner.UpdateCount=0 then
            CollapseNodeList(Self, Recurse);
             // it's commented and transferred to CollapseNodeList
            //for i:=0 to Count-1 do
            //   TFlyNode(items[i]).Fselected :=false;
            FExpanded := false;
            if (Tree <> nil) and aPar then
              Tree.InternalSetRow(Getrow)
            else if SelNode <> nil then
              Tree.InternalSetRow(SelNode.Getrow);
            CountRows;

            DoExpand(False);
            if Owner.UpdateCount=0 then
            begin
             if (Tree.RowCount-Tree.TopRow) <= Tree.VisibleRowcount then
               EnsureTopRow;
            end;
         end;
      end;
      if Recurse then SubExpand(Expand);
//     finally // beignUpdate
//       Owner.EndUpdate;
//     end;

   finally
      if Tree<>nil then
        Tree.FManualNotify := False;
//     Tree.Items.EndUpdate;
   end;
end;


procedure TFlyNode.Expand(Recurse: Boolean);
begin
   ExpandItem(True, Recurse);
end;

procedure TFlyNode.Collapse(Recurse: Boolean);
begin
   ExpandItem(False, Recurse);
end;

function TFlyNode.GetExpanded: Boolean;
begin
   Result := FExpanded;
end;

procedure TFlyNode.SetExpanded(Value: Boolean);
begin
   if Value then
      Expand(False)
   else
      Collapse(False);
end;

function TFlyNode.GetSelected: Boolean;
begin
   Result := FSelected;
end;

procedure TFlyNode.SetSelected(Value: Boolean);
begin
 if Value <>FSelected then
 begin
   FSelected :=Value;
   if Tree<> nil then
   begin
      Tree.SelectItem(Self);
   end;
 end;
end;

function TFlyNode.GetCut: Boolean;
begin
   Result := GetState(nsCut);
end;

procedure TFlyNode.SetCut(Value: Boolean);
begin
   SetState(nsCut);
end;

function TFlyNode.GetDropTarget: Boolean;
begin
  if Tree<>nil then
    Result := Tree.GetDropTargetrow = Getrow
  else
    Result :=false;
   //GetState(nsDropHilited);
end;

procedure TFlyNode.SetDropTarget(Value: Boolean);
//var aRow : longint;
begin
   SetState(nsDropHilited);
   if Tree<>nil then
      with Tree do
      begin
         Tree.SetDropTarget(Self);
      end;

end;

function TFlyNode.GetChildren: Boolean;
begin
   Result := (Count > 0) or FHasChildren;
end;

procedure TFlyNode.SetFocused(Value: Boolean);
begin
  if Tree<>nil then
  begin
   if Value then
   begin
      MakeVisible;
      Tree.Row := GetRow;
      with Tree do
      if not (goRangeSelect in Options) then
         SelectOne(Row);
   end
   else if Focused then
      Tree.Row :=-1;
  end
  else SetState(nsFocused);
end;

function TFlyNode.GetFocused: Boolean;
begin
 if Tree<>nil then
   Result := Tree.Row = GetRow
 else
   Result := GetState(nsFocused);
end;

procedure TFlyNode.SetState(NodeState: TNodeState);
begin
   FNodeState := NodeState;
   //Owner.Owner.InvalidateNode(Self);
end;

function TFlyNode.GetState(NodeState: TNodeState): Boolean;
begin
   Result := (NodeState = FNodeState);
end;

procedure TFlyNode.SetChildren(Value: Boolean);
begin
   if (Count = 0) and (FHasChildren <> Value) then
   begin
      FHasChildren := Value;
      FAllHidden := False;
      if Tree<>nil then
         Tree.InvalidateCell(Tree.FStructurecol, GetRow);
   end
   else if Value = True then
      FhasChildren := true;
end;

function TFlyNode.GetParent: TFlyNode;
begin
   if TreeCollection is TflyNode then
      Result := TFlyNode(TreeCollection)
   else
      Result := nil;
end;


function TFlyNode.GetNextVisibleSibling: TFlyNode;
var i : integer;
    aNode : TFlyNode;
begin
{   Result := nil;
   if Parent <> nil then
   begin
    for i:= Index to Parent.Count-1 do
      if Parent[i].IsNodeVisible then
      begin
         Result := Parent[i];
         break;
      end;
   end
   else
   begin
      for i:=Index to Fowner.Count-1 do
      if Fowner[i].IsNodeVisible then
      begin
         Result := FOwner[i];
         break;
      end;
   end;
}
   Result:=nil;
   for i:=Index+1 to TreeCollection.Count-1 do
   begin
     aNode := TFlyNode(TreeCollection[i]);
     if aNode.IsNodeVisible then
     begin
       Result := TFlyNode(TreeCollection[i]);
       break;
     end;
   end;

end;

function TFlyNode.GetNextSibling: TFlyNode;
begin
   if index < TreeCollection.Count-1 then
   begin
      Result := TFlyNode(TreeCollection[Index+1]);
   end
   else
   begin
      Result:=nil;
   end;

end;

function TFlyNode.GetPrevSibling: TFlyNode;
begin
   if Index >0 then
      Result := TFlyNode(TreeCollection[Index-1])
   else Result :=nil;
end;

function TFlyNode.GetNextVisible: TFlyNode;
begin
  Result := Tree.GetNextVisible(Self) //new func
end;

function TFlyNode.GetPrevVisible: TFlyNode;
begin
   Result := Tree.GetPrevVisible(Self); //new func
end;

function TFlyNode.GetNextChild(Value: TFlyNode): TFlyNode;
begin
   if Value <> nil then
      Result := Value.GetNextSibling
   else
      Result := nil;
end;

function TFlyNode.GetPrevChild(Value: TFlyNode): TFlyNode;
begin
   if Value <> nil then
      Result := Value.GetPrevSibling
   else
      Result := nil;
end;

function TFlyNode.GetFirstChild: TFlyNode;
begin
   Result:=nil;
   if Count>0 then
      Result := item[0];
end;

function TFlyNode.GetLastChild: TFlyNode;
begin
   Result:=nil;
   if Count>0 then
      Result := item[Count-1];
end;

function TFlyNode.GetNext: TFlyNode;
var
   aNode, PNode : TFlyNode;
begin
   if Count>0 then
     aNode:=TFlyNode(items[0])
   else
      aNode := GetNextsibling;

   if aNode = nil then
   begin
      PNode := Self;
      while (PNode <> nil) and (Anode = nil) do
      begin
         aNode:= PNode.GetNextSibling;
         PNode:= PNode.Parent;
      end;
      Result:=aNode;
   end
   else
      Result := aNode;
end;

function TFlyNode.GetPrev: TFlyNode;
var
   Node : TFlyNode;
begin
   Result := GetPrevSibling;
   if Result <> nil then
   begin
      Node := Result;
      repeat
         Result:= Node;
         Node  := Result.GetLastChild;
      until Node = nil;
   end
   else
      Result := Parent;
end;

function TFlyNode.GetExpandedCount : Longint;
var i : integer;
begin
   Result:=0;
   if FExpanded then
   begin
      inc(Result, Count);
      for i:=0 to Count-1 do // all childs
         if item[i].Count>0 then
            inc(Result, item[i].GetExpandedCount);

      //old algoritm
      //for i:=0 to Count-1 do // all childs
      //   inc(Result, item[i].GetExpandedCount+1);
   end;
end;

//get row of Node
function TFlyNode.GetRow : integer;
var //Anode : TFlyNode;
   aindex : Longint;
begin
   if FOwner<> nil then
   begin
      aindex := Fowner.FnodeList.indexOf(Self);
      if aIndex <> -1 then
         Result := Tree.FixedRows + aIndex
      else Result:=-1; 
   end
   else
      Result:=-1;

   {if IsVisible then
   begin
        Result:=Tree.FixedRows;
        aNode := GetPrevSibling;
        while aNode <> nil do
        begin//Expandeditems plus Sibling
           inc(Result,aNode.GetExpandedCount+1);
           aNode := aNode.GetPrevSibling;
        end;
        if Parent<>nil then
          Inc(Result, Parent.GetRow);
   end;}

end;

function TFlyNode.GetAbsoluteIndex: Integer;
var
   Node : TFlyNode;
begin
   Result := -1;
   Node := Self;
   while Node <> nil do
   begin
     Inc(Result);
     Node := Node.GetPrev;
   end;
end;


function TFlyNode.GetItem(Index: Integer): TFlyNode;
begin
   Result := nil;
   if index < Count then
      Result := TFlyNode(inherited items[index])
   else
      {$ifdef DFS_COMPILER_3_UP}
      Error('GetItem:'+SListIndexError);
      {$ELSE}
       Error('GetItem:'+LoadStr(SListIndexError));
      {$ENDIF}

end;

procedure TFlyNode.SetItem(Index: Integer; Value: TFlyNode);
begin
   item[Index].Assign(Value);
end;

function TFlyNode.IndexOf(Value: TFlyNode): Integer;
var
   Node : TFlyNode;
begin
   Result := -1;
   Node := GetFirstChild;
   while (Node <> nil) do
   begin
      Inc(Result);
      if Node = Value then Break;
      Node := GetNextChild(Node);
   end;
   if Node = nil then Result := -1;
end;



function TFlyNode.GetLevel: Integer;
var
   Node : TFlyNode;
begin
   Result := 0;
   Node := Parent;
   while Node <> nil do
   begin
      Inc(Result);
      Node := Node.Parent;
   end;
end;

function TFlyNode.IsNodeVisible: Boolean;
begin
   if FOwner<> nil then
      Result := Fowner.FnodeList.indexOf(Self) <> -1
   else
      Result:=false;

end;

procedure TFlyNode.MakeVisible;
begin
   if (Parent <> nil) and (not Parent.FExpanding) then
      Parent.Expand(false);
end;

procedure TFlyNode.EndEdit(Cancel: Boolean);
begin
   if (Tree<>nil) then
      if (Tree.FStructureCol<>-1) and (Tree.FStructureCol>=Tree.Fixedcols)  // CEDR 08.10.02 was (Tree.FStructureCol>Tree.Fixedcols)  ????
      and (Tree.FStructureCol < Tree.ColCount) and
      (Tree.Row = GetRow) and (Tree.EditorMode) then
      begin
         //
         if not Cancel then
            Caption := Tree.GetEditText(Tree.Col, Tree.Row);
         Tree.EditorMode:=false;
      end;
end;

function TFlyNode.EditText: Boolean;//editlabel
begin
   Result:=false;
   if (Tree<>nil) then
      if (Tree.FStructureCol<>-1) and (Tree.FStructureCol>=Tree.Fixedcols)
      and (Tree.FStructureCol < Tree.ColCount) then
      begin
         //select Node
         Tree.Col:= Tree.FStructureCol;  //editcell
         Tree.Row:= GetRow;
         Tree.SetFocus;
         Tree.EditorMode:= true;
         Result         := Tree.EditorMode;
      end;
end;

function TFlyNode.DisplayRect(TextOnly: Boolean): TRect;
begin
  if Tree <> nil then
   Result := Tree.DisplayRect(Self, TextOnly);
end;


function TFlyNode.InternalGetClass(aClassname : String) : TTreeCollectionClass;
begin
   Result :=TFlyNode;
end;

procedure TFlyNode.SetOwner(aOwner : TFlyNodes);
var i : integer;
begin//correct owner
   for i:=0 to Count-1 do
     Item[i].Owner:=aOwner;
   FOwner:=aOwner;
end;

{function TFlyNode.Unpack(AtIndex : Integer): TTreeCollectionClass;
begin
   Result := inherited Unpack(AtIndex);
   TFlyNode(Result).FOwner := FOwner;
   FSorted :=False;
end;
}
function TFlyNode._Add(AtIndex : integer): TTreeCollectionClass;
begin
   Result := inherited _Add(AtIndex);
   //Result := TTreeCollectionClass(TFlyNode.Create(TTreeCollection(Self)));
   TFlyNode(Result).FOwner := FOwner;
   FSorted :=False;
end;

function TFlyNode.AlphaSort: Boolean;
begin
   Result:=false;
   if ({Expanded and} (Count > 0)) and (not FSorted) then
   begin
      if Tree.FSortType in [stText,stNone] then
      begin
         CustomSort(nil, true)
      end
      else
         CustomSort(DefaultSort, true);
      Result :=true;
      FSorted:=true;
   end;

end;

procedure TFlyNode.Delete;
begin
   if not Deleting then //dispose
   begin
      FDeleting :=True;
      //if Tree <> nil then Tree.Delete(Self);
      Free;
   end;
end;

procedure TFlyNode.DeleteChildren;
var aSel : Boolean;
   aRow : integer;
   cPos : TRect;

begin
   if Tree <> nil then
   begin
      aSel := Selected;
      Tree.FWithoutFixup:= true;
   end
   else aSel:=false;
   Clear;
   if Tree <> nil then Tree.FWithoutFixup := false;
   if Tree <> nil then
      with Tree do
      begin
         FixupRows;
         if aSel then Self.Selected := True;
         aRow:= GetRow;
         cPos:= BoxRect(0, aRow, Colcount, RowCount);
         if HandleAllocated then
            Windows.InvalidateRect(Handle, @cPos, False);
      end;
   HasChildren := False;
end;

procedure TFlyNode.Assign(Source: TPersistent);
var Node : TFlyNode;
    i : integer;
begin
   if Source is TFlyNode then
   begin
      Node         := TFlyNode(Source);
      Caption      := Node.Caption;
      Data         := Node.Data;
      ImageIndex   := Node.ImageIndex;
      SelectedIndex:= Node.SelectedIndex;
      StateIndex   := Node.StateIndex;
      OverlayIndex := Node.OverlayIndex;
      Focused      := Node.Focused;
      DropTarget   := Node.DropTarget;
      Cut          := Node.Cut;
      HasChildren  := Node.HasChildren;
      FUniqueTag   := Node.UniqueTag;
      if (Node.FCells <> nil) then
      begin
        if FCells = nil then
          FCells := TStringList.Create;
        FCells.Assign(Node.FCells);
      end;

      if FOwner <> nil then
      begin
       Fowner.BeginUpdate;
       try
        for i:=0 to Node.Count-1 do
          With FOwner.AddChild(Self,'') do
           Assign(Node[i]);

       finally
         FOwner.EndUpdate;
       end;
      end;
   end
   else
      inherited Assign(Source);
end;


{function TFlyNode.IsEqual(Node: TFlyNode): Boolean;
begin
   if Node<>nil then
      Result := (Caption = Node.Caption) and (Data = Node.Data) and
      (SelectedIndex = Node.SelectedIndex) and (StateIndex = Node.StateIndex)
      and (ImageIndex = Node.ImageIndex)
   else
      Result:=false;
end;
}
procedure TFlyNode.Update(Item: TTreeCollection);
begin
   inherited;
   if FOwner.Tree <>nil then
   begin
      if (Fowner.UpdateCount=0) then
      begin
         Fowner.Tree.RefreshNodeList(TFlyNode(item));
         Fowner.Tree.FixupRows;
         FOwner.Repaint(TFlyNode(item));
      end;
   end;
end;


procedure TFlyNode.SetIndex(Value: Integer);
var //aNode               : TFlyNode;
   aindex, CurIndex : integer;

procedure MoveChilds(aNode: TFlyNode);
var i, aNodeIndex, aCurIndex : integer;
begin
   if aNode.Expanded then
      for i:=0 to aNode.Count-1 do
      begin
         aNodeIndex := FOwner.FNodeList.indexOf(aNode);
         aCurIndex := FOwner.FNodeList.indexOf(aNode[i]);
         FOwner.FNodeList.Move(aCurIndex, aNodeIndex+i);
         MoveChilds(aNode[i]);
      end;
end;

begin
   if Parent <> nil then
   begin
      aIndex := FOwner.FNodeList.indexOf(Parent.Item[Value]);
   end
   else
      aIndex := FOwner.FNodeList.indexOf(Fowner.Item[Value]);

   CurIndex := FOwner.FNodeList.indexOf(Self);
   if (CurIndex<>-1) then//if visible
   begin
    if (aIndex <> -1) and (CurIndex<>aIndex) then //visible
    begin
      FOwner.FNodeList.Move(CurIndex, aindex);
      MoveChilds(Self);
    end;
   end;

   inherited;

end;

procedure TFlyNode.MoveTo(Destination: TFlyNode; Mode: TNodeAttachMode);
var OldRow, aRow : integer;
   aOldTree     : TCustomRapidTree;
   ParentsDiff, aTreediff    : Boolean;
   aFocused : Boolean;
begin
   aoldTree:=nil;
   aTreediff:=false;
   Oldrow:=-1;
   if Destination<> nil then
   begin
     if Destination.Parent = Self then exit;
   end;
   aFocused := Focused;
   if Tree <> nil then Tree.FWithoutFixup :=true;
   try
       OldRow := GetRow;
        if Destination <>nil then
           aTreediff:= Tree <> Destination.Tree
         else aTreeDiff:=false;

         aOldTree :=Tree;
         if Destination <> nil then
            ParentsDiff:= (Destination.TreeCollection<>treeCollection)
         else
            ParentsDiff:= TreeCollection<>Fowner;

         {if Destination<> nil then
           if Destination.Tree <> nil then
              Destination.Tree.Flushselection;
         }
         Case Mode of
            naInsert, naAdd, naAddFirst:
            begin
              if Destination <>nil then
              begin
               if Destination.Parent <> nil then
               begin
                  //ParentsDiff:= (Destination.Parent)<>Parent;
                  inherited TreeCollection := TTreeCollection(Destination.Parent);
                  //SetOwner(Destination.FOwner);
                  if (Destination.Tree <> nil)  then
                     Destination.Tree.RefreshNodeList(nil);
               end
               else
               begin
                  if Destination.FOwner <> nil then
                  begin
                     inherited TreeCollection := TTreeCollection(Destination.FOwner);
                  end;
                  if (Destination.Tree <> nil)  then
                     Destination.FOwner.Tree.RefreshNodeList(nil);
               end;
              end
              else
              begin
                inherited TreeCollection := TTreeCollection(FOwner);
                if (Tree <> nil)  then
                     Tree.RefreshNodeList(nil);
              end;

               if (aoldTree <> nil) and aTreeDiff then
               begin
                  Setowner(Destination.Fowner);
                  aOldTree.RefreshNodeList(nil);
               end;

               if Mode = naAddFirst then
               begin
                  FmovedIn:=true;
                  index   := 0;
                  FmovedIn:=false;
               end
               else if Mode = naInsert then
               begin
                     FmovedIn:=true;
                     if Destination <>nil then
                     begin
                      if not ParentsDiff then
                      begin
                       if Destination.index<index then
                          index   := Destination.index
                       else if Destination.index > 0 then
                          index   := Destination.index-1
                      else
                          index:=0;
                      end
                      else
                       index   := Destination.index

                     end
                     else
                       index:=0;

                     FmovedIn:=false;
               end
               else if Mode = naAdd then
               begin
                  FmovedIn:=true;
                  if Destination <>nil then
                  begin
                   if Destination.Parent <> nil then
                     index   := Destination.Parent.Count-1
                   else if Destination.FOwner <> nil then
                     index   := Destination.FOwner.Count-1;
                  end
                  else
                     index:=inherited TreeCollection.Count-1;
                  FmovedIn:=false;
               end;
            end;
            naAddChild, naAddChildFirst:
            begin
              if Destination <>nil then
              begin
               inherited TreeCollection := TTreeCollection(Destination);
               if (Destination.Tree <> nil)  then
                  Destination.Tree.RefreshNodeList(Destination);
               if (aoldTree <> nil) and aTreeDiff then
               begin
                  Fowner := Destination.Fowner;
                  aOldTree.RefreshNodeList(nil);
               end
              end
              else
              begin
                 inherited TreeCollection := TTreeCollection(FOwner);
                 if (Tree <> nil)  then
                     Tree.RefreshNodeList(nil);
              end;
              FmovedIn:=true;
              if Mode = naAddChildFirst then
                  index   := 0
              else if Mode = naAddChild then
                  index   := inherited TreeCollection.Count-1;
              FmovedIn:=false;

            end;
         end;
         //move pointer in NodeList
        //end;
   finally
      if Tree <> nil then
      begin
         Tree.RefreshNodelist(nil);
         Tree.Fixuprows;
         if (aoldTree <> nil) and aTreeDiff then
         begin
            aoldTree.Fixuprows;
         end;
         //fixup row heights
         aRow := Getrow;
         if Tree <>nil then
            if aRow < oldRow then
               Tree.FixupRowHeights(aRow)
            else
               Tree.FixupRowHeights(oldRow);

           Focused := aFocused;
      end;

   end;
end;

function TFlyNode.SaveToText(SplitToStrings: Boolean) : string; //Save TTreeCollection to Text format
begin
  Result := SaveTreeCollectionToText(Self, SplitToStrings);
end;

procedure TFlyNode.LoadFromText(Text : string); //Load TTreeCollection from Text
begin
   LoadTreeCollectionFromText(Self, Text); //Load TTreeCollection from Text
end;

procedure TFlyNode.LoadFromStream(Stream : TStream);
begin
   LoadTreeCollectionFromStream(Self, Stream);
end;

procedure TFlyNode.SaveToStream(Stream : TStream);
begin
  SaveTreeCollectionToStream(Self, Stream );
end;

procedure TFlyNode.SaveToFile(const Filename : string);
begin
  SaveTreeCollectionToFile(Self, Filename);
end;

procedure TFlyNode.LoadFromFile(const Filename : string);
begin
  LoadTreeCollectionFromFile(Self, Filename);
end;
{$ifdef DFS_COMPILER_3_UP}
procedure TFlyNode.SetNodeAdapter(const Value: INodeAdapter);
begin
  if FNodeAdapter <> nil then FNodeAdapter.ReleaseNode;
  FNodeAdapter := Value;
  if FNodeAdapter <> nil then FNodeAdapter.ReferenceNode(Self);
end;
{$ENDIF}
//-----------------------------------------------------
// TFlyNodes
//-----------------------------------------------------
constructor TFlyNodes.Create(AOwner: TCustomRapidTree);
begin
   inherited Create(nil);
   InitializeCriticalSection(FLock);
   FNodeList:=TList.Create;
   SetOwner(aOwner);
   FDefStateIndex := 0;
   FDefImageIndex := 0;
   FDefSelectedIndex :=0;
   FItemseparator := '.';
   FMaxTag := -1;
   FOwner := AOwner;
end;

destructor TFlyNodes.Destroy;
begin
 LockList;   // Make sure nobody else is inside the list.
 try
   FNodeList.Free;
   FNodeList:=nil;
   inherited Destroy;
 finally
   UnlockList;
   DeleteCriticalSection(FLock);
 end;

end;

procedure TFlyNodes.UnlockList;
begin
  LeaveCriticalSection(FLock);
end;

procedure  TFlyNodes.LockList;
begin
  EnterCriticalSection(FLock);
end;

{procedure TFlyNodes.Added(aNode: TFlyNode);
begin
   FNodeList.Add(aNode);
end;
}
Procedure TFlyNodes.Removed(aNode: TFlyNode);
begin
   if Fowner <> nil then
   begin
      if FnodeList<>nil then
      begin
         try
            if (aNode.GetRow = FOwner.Row) and (UpdateCount=0) then
               FOwner.Row := 0;
            FnodeList.Remove(aNode);
         except
         end;
         Fowner.Delete(aNode);
      end;
   end;
end;

function TFlyNodes.SaveToText(SplitToStrings: Boolean) : string;
begin
  Result:= SaveTreeCollectionToText(Self, SplitToStrings);
end;

procedure TFlyNodes.LoadFromText(Text : string);
begin
   LoadTreeCollectionFromText(Self, Text);
end;

procedure TFlyNodes.LoadFromStream(Stream : TStream);
begin
   LoadTreeCollectionFromStream(Self, Stream);
end;

procedure TFlyNodes.SaveToStream(Stream : TStream);
begin
  SaveTreeCollectionToStream(Self, Stream );
end;

procedure TFlyNodes.SaveToFile(const Filename : string);
begin
  SaveTreeCollectionToFile(Self, Filename);
end;

procedure TFlyNodes.LoadFromFile(const Filename : string);
begin
  LoadTreeCollectionFromFile(Self, Filename);
end;


function TFlyNodes.AlphaSort: Boolean;
var aNode : TFlyNode;
begin
    Result:=false;
    aNode:=nil;
    if Updatecount> 0 then exit;
      if Tree<>nil then
        aNode := Tree.GetNodeAtRow(Tree.Row);

      BeginUpdate;
      try
         if (FOwner <> nil) and (FOwner.FSortType in [stText,stNone]) then
            CustomSort(nil, true)
         else
            CustomSort(DefaultSort, true);
         Result := true;
         FSorted :=true;
      finally
         EndUpdate;
         if aNode<>nil then
         begin
          Tree.SetSelection(aNode);
         end;
      end;
   //end;

end;


procedure TFlyNodes.Delete(Node: TFlyNode);
//var aindex : integer;
begin
   Node.Delete;
end;

function TFlyNodes.GetTree : TCustomRapidTree;
begin
  Result := FOwner;
end;

procedure TFlyNodes.SetItemSeparator(Value : String);
begin
  FItemSeparator := Value;
end;


procedure TFlyNodes.Clear;
begin
try
 if FOwner<>nil then
 with Fowner do
 begin
   Editormode :=false;
   FWithoutFixup:=true;
 end;
 LockList;
 try
   FNodeList.Clear;
   inherited Clear;

//   if (FOwner <>nil) then
//      FOwner.FCachedRow.Node := nil;

   FMaxTag :=-1;
 finally
   UnlockList;
 end;
finally
if FOwner<>nil then
 with Fowner do
 begin
  FWithoutFixup:=false;
  FanchorNode := nil;
  LastSel := nil;
//  FlushSelection;    //??????????
//  ClearSelection;    //??????????
  HideEdit;
  FixupRows;
  Editormode :=false;
  Application.Processmessages;
 end;
end;

end;

function TFlyNodes._Add(AtIndex : Integer): TTreeCollectionClass;
var aVisIndex : integer;
begin
   //Result := TTreeCollectionClass(TFlyNode.Create(TTreeCollection(Self)));
   aVisIndex := FnodeList.IndexOf(GetPointer(AtIndex));
   Result := inherited _Add(AtIndex);
   TFlyNode(Result).FOwner := Self;
   //here inserting to FNodeList
   if aVisIndex <> -1 then
     FnodeList[aVisIndex] := Result;
   FSorted :=False
end;

function TFlyNodes.Add(Node: TFlyNode; const S: string): TFlyNode;
begin
   if Node <> nil then Node := Node.Parent;
   Result := InternalAddObject(Node, S, nil, taAdd);
end;

function TFlyNodes.AddObject(Node: TFlyNode; const S: string;
Ptr: Pointer): TFlyNode;
begin
   if Node <> nil then Node := Node.Parent;
   Result := InternalAddObject(Node, S, Ptr, taAdd);
end;

function TFlyNodes.Insert(Node: TFlyNode; const S: string): TFlyNode;
begin
   Result := InsertObject(Node, S, nil);
end;

procedure TFlyNodes.AddedNode(Value: TFlyNode);
begin
 if Updatecount<>0 then
 begin
   if Value <> nil then
   begin
      Value.HasChildren := True;
      Repaint(Value);
   end
   else
      if FOwner <> nil then
         FOwner.Repaint;
     If Assigned(OnChange) then
        Onchange(Self); 
 end;
end;

// 
function TFlyNodes.InsertObject(Node: TFlyNode; const S: string;
Ptr: Pointer): TFlyNode;
var aObj : TTreeCollection;
begin
 BeginUpdate;
 try
   Result:=nil;
   if Node<>nil then
   begin
      if Node.Parent <> nil then//if node has parent
         aObj := TTreeCollection(Node.Parent)
      else // if node in first level
         aObj := TTreeCollection(Self);
   end
   else
      aObj := TTreeCollection(Self);

   Result := TFlyNode.Create(aObj);

   //set index
   if Node<>nil then
     Result.Index := Node.Index
   else
     Result.Index:=0;

   //flagged not sorted
   if aObj is TFlyNodes then
      TFlyNodes(aObj).FSorted :=False
   else
      if aObj is TFlyNode then
         TFlyNode(aObj).FSorted :=False;


   Result.FOwner := Self;
   Result.Data := Ptr;
   Result.Caption := S;
  finally
    endUpdate;
  end;
end;

function TFlyNodes.InternalAddObject(Node: TFlyNode; const S: string;
Ptr: Pointer; AddMode: TAddMode): TFlyNode;
//var aObj : TTreeCollection;
begin
   if Node<>nil then
      Result := TFlyNode.Create(TTreeCollection(Node))
   else
      Result := TFlyNode.Create(TTreeCollection(Self));

   with Result do
   begin
     Data := Ptr;
     Caption := S;
   end;

   if addMode = taAddFirst then
      Result.Index:=0;

   if UpdateCount = 0 then
   begin
    if Node<>nil then
     AddedNode(Result.Parent)
    else
     AddedNode(nil);
   end;
end;

function TFlyNodes.AddChildFirst(Node: TFlyNode; const S: string): TFlyNode;
begin
   Result := AddChildObjectFirst(Node, S, nil);
end;

function TFlyNodes.AddChildObjectFirst(Node: TFlyNode; const S: string;
Ptr: Pointer): TFlyNode;
begin
   Result := InternalAddObject(Node, S, Ptr, taAddFirst);
   Result.Index := 0;
end;

function TFlyNodes.AddChild(Node: TFlyNode; const S: string): TFlyNode;
begin
   //Result := AddChildObject(Node, S, nil);
   Result := InternalAddObject(Node, S, nil, taAdd);
   {if Node<>nil then
   begin
    if Node.Count > 0 then
     Result.index := Node.Count-1;
   end
   else
     Result.index := Count-1;
   }  
end;

function TFlyNodes.AddChildObject(Node: TFlyNode; const S: string;
Ptr: Pointer): TFlyNode;
begin

   Result := InternalAddObject(Node, S, Ptr, taAdd);
   if Node<>nil then
   begin
      if Node.Count > 0 then
         Result.Index := Node.Count-1;
   end
   else Result.index:=Count-1;
end;

function TFlyNodes.AddFirst(Node: TFlyNode; const S: string): TFlyNode;
begin
   Result := InternalAddObject(Node, S, nil, taAddFirst);
end;

function TFlyNodes.AddObjectFirst(Node: TFlyNode; const S: string;
Ptr: Pointer): TFlyNode;
begin
   if Node <> nil then Node := Node.Parent;
   Result := InternalAddObject(Node, S, Ptr, taAddFirst);
end;

function TFlyNodes.InternalGetClass(aClassname : String) : TTreeCollectionClass;
begin
   Result :=TFlyNode;
end;


function TFlyNodes.SetItemText(text : String) : TFlyNode;
var aNode : TFlyNode;
    aStringlist : TStringlist;
    i:integer;
function FindNode(Node:TFlyNode; aText : String) : TFLyNode;
var i: integer;
begin
    Result:=nil;
    if Node<> nil then
    begin
     for i:=0 to Node.Count-1 do
      if Node[i].Text=aText then
      begin
          result:=Node[i];
          Break;
      end;
    end
    else
    begin
      for i:=0 to Count-1 do
      if item[i].Text=aText then
      begin
          result:=item[i];
          Break;
      end;
    end;
end;
begin
  aStringlist:=TStringlist.Create;
  try
     aStringlist.Text:=Text;
     aNode:=nil;
     Result:=nil;
     for i:=0 to aStringlist.count-1 do
     begin
       aNode := FindNode(aNode,aStringlist[i]);
       if aNode=nil then
         break;
       if i=aStringlist.Count-1 then
          Result:=aNode;
     end;
  finally
    aStringlist.Free;
  end;
end;

procedure TFlyNodes.ShowAll;
var i: integer;
    aSelNode : TFlyNode;
begin
   BeginUpdate;
   try
    aSelNode := Tree.Selected;
    for i:=0 to Count-1 do
      TFlyNode(items[i]).Show(True);
   finally
     EndUpdate;
   end;
   if (aSelNode <> nil) then
       Tree.Selected := aSelNode;
end;

procedure TFlyNodes.Hide(aNode : TFlyNode);
begin
    aNode.Hide;
end;

function TFlyNodes.GetItemText(Node: TFlyNode) : String;
var aNode : TFlyNode;
    aStringlist : TStringlist;
begin
   aNode:=Node;
   aStringlist:=TStringlist.Create;
   try
    while aNode<>nil do
    begin
      aStringlist.Insert(0,aNode.Text);
      aNode:=aNode.Parent;
    end;
      Result:=aStringlist.text;
    finally
      aStringlist.Free;
   end;
end;

function TFlyNodes.GetFirstSelectedNode : TFlyNode;
begin
  Result := GetNextSelectedNode(nil);
end;

function TFlyNodes.GetLastSelectedNode : TFlyNode;
begin
  Result := GetPrevSelectedNode(nil);
end;

function TFlyNodes.GetNextSelectedNode(aNode : TFlyNode) : TFlyNode;
var i, start : integer;
begin
 Result := nil;
 if Tree<> nil then
 with Tree do
 begin
  if aNode<>nil then
    start := FRootNode.FnodeList.IndexOf(aNode)+1
  else start := 0;

  for i:=Start to FRootNode.FnodeList.Count-1 do
  if TFLyNode(FRootNode.FnodeList[i]).Selected then
  begin
    Result:=TFLyNode(FRootNode.FnodeList[i]);
    Break;
  end;
 end;

end;

function TFlyNodes.GetPrevSelectedNode(aNode : TFlyNode) : TFlyNode;
var i, start : integer;
begin
 Result := nil;
 if Tree<> nil then
 with Tree do
 begin
  if aNode<>nil then
    start := FRootNode.FnodeList.IndexOf(aNode)-1
  else start := FRootNode.FnodeList.Count-1;

  for i:=Start downto 0 do
  if TFLyNode(FRootNode.FnodeList[i]).Selected then
  begin
    Result:=TFLyNode(FRootNode.FnodeList[i]);
    Break;
  end;
 end;

end;


procedure TFlyNodes.Repaint(Node: TFlyNode);
var
   i : integer;
begin
 if FOwner <> nil then
 if not (csLoading in FOwner.ComponentState ) then
 begin
  if (Node <> nil) then
  begin
     if Node.FExpanded then
     begin
       Fowner.invalidateRow(Node.GetRow);//InvalidateRect(FOwner.Handle, @R, True);
       for i:=0 to Count-1 do
         Fowner.invalidateRow(Node.GetRow);
     end;
  end
  else
  begin
    FOwner.FixupRows;
    FOwner.Invalidate;
  end;
 end;
end;



function TFlyNodes.GetFirstNode: TFlyNode;
begin
   if Count > 0 then
      Result := TFlyNode(Items[0])
   else
      Result := nil;
end;

function TFlyNodes.GetLastNode : TFlyNode;
begin
   if Count > 0 then
   begin
      Result := TFlyNode(Items[Count-1]);
      while Result.Count > 0 do
         Result := TFlyNode(Result.Items[Result.Count-1])
   end
   else
      Result := nil;
end;

// Usi
Function TFlyNodes.GetNodeOnUniqueTag(aTag : Integer) : TFlyNode;
var aNode : TFlyNode;
begin
   Result := nil;
   aNode := GetFirstNode;
   while aNode <> nil do
   begin
     if aNode.UniqueTag = aTag then
     begin
       Result := aNode;
       break;
     end;
     aNode := aNode.GetNext;
   end;
end;

procedure TFlyNodes.ClearCells;
var aNode : TFlyNode;
begin
  aNode := getFirstNode;
  while (aNode <> nil) do
  with aNode do
  begin
    if FCells <> nil then
    begin
      FCells.Clear;
      FCells.Free;
      FCells :=nil;
    end;
    aNode := aNode.GetNext;
  end;
end;

function TFlyNodes.GetNodeFromIndex(Index: Integer): TFlyNode;
begin
   if Index < 0 then
   {$ifdef DFS_COMPILER_3_UP}
      Error(sInvalidIndex);
   {$ELSE}
      Error(LoadStr(sInvalidIndex));
   {$ENDIF}
   Result := TFlyNode(Items[Index]);
end;

procedure TFlyNodes.SetItem(Index: Integer; Value: TFlyNode);
begin
   GetNodeFromIndex(Index).Assign(Value);
end;
{
procedure TFlyNodes.BeginUpdateMinCapacity(MinCapacity : integer);
begin
   if MinCapacity > FNodeList.Capacity then
     FNodeList.Capacity := MinCapacity;
      inherited;
end;
}
procedure TFlyNodes.BeginUpdate;
begin
   if UpdateCount = 0 then
   begin
     SetUpdateState(True);
     LockList;
   end;
   inherited;
end;

procedure TFlyNodes.EndUpdate;
begin
   inherited;
   if UpdateCount = 0 then
   begin
//     if (FOwner <>nil) then
//      FOwner.FCachedRow.Node := nil;

      UnLockList;
      SetUpdateState(False);
      If Assigned(OnChange) then
        Onchange(Self);
   end;
end;

procedure TFlyNodes.Update(Item: TTreeCollection);
begin
   inherited;
   if (FOwner <>nil) then
   begin
     if (Item=nil) or (Item = Self) then
      Fowner.FixupRows
     else if (Item <> nil) and (Item is TFlyNode) then
      Repaint(TFlyNode(item))
  end;
end;

procedure TFlyNodes.SetUpdateState(Updating: Boolean);
begin
  if Fowner<>nil then
  begin
      if FOwner.handleAllocated then
        SendMessage(FOwner.Handle, WM_SETREDRAW, Ord(not Updating), 0);

      if not Updating then
      begin
        Fowner.RefreshNodelist(nil);
        Fowner.FixupRows;
      end;
   end;
end;


procedure TFlyNodes.Assign(Source: TPersistent);
var
   TreeNodes : TFlyNodes;
   MemStream : TMemoryStream;
begin
   if Source is TFlyNodes then
   begin
      TreeNodes := TFlyNodes(Source);
      Clear;
      MemStream := TMemoryStream.Create;
      try
         //TreeNodes.Tree.WriteData(MemStream);
         TreeColl.WriteCollectionToStream(TreeNodes, MemStream);
         MemStream.Position := 0;
         //Tree.ReadData(MemStream);
         TreeColl.ReadCollectionFromStream(Self, MemStream);
      finally
         MemStream.Free;
      end;
      FMaxTag := TreeNodes.FMaxTag;
   end
   else inherited Assign(Source);

   if Tree<>nil then
   begin
      Tree.RefreshNodelist(nil);
      Tree.FixupRows;
   end;
end;

procedure TFlyNodes.LoadNodesFromStream(Stream: TStream);
var
  List, aCells: TStringList;
  ANode, NextNode: TFlyNode;
  ALevel, i,j: Integer;
  OptionsStr,CurrStr: string;
  SavedOptions : integer;//TSaveNodesOptions;
  aOptions : TSaveNodesOptions;
  aOption : TSaveNodesOption;

  function GetBufStart(Buffer: PChar; var Level: Integer): PChar;
  begin
    Level := 0;
    while Buffer^ in [' ', #9] do
    begin
      Inc(Buffer);
      Inc(Level);
    end;
    Result := Buffer;
  end;
begin
  List := TStringList.Create;
  aCells := TStringList.Create;
  SavedOptions :=0;
  BeginUpdate;
  try
    try
      Clear;
      List.LoadFromStream(Stream);
      ANode := nil;
      //analyze savedOptions
      aOptions :=[];
      if List.Count > 0 then
      begin
         if Pos(aSaveOptions, List[0]) = 0 then
            aOptions := [tsnIncludeCells]
         else
         begin
             OptionsStr := System.Copy(List[0], 1+Length(aSaveOptions), Length(List[0])- Length(aSaveOptions));
             if OptionsStr <>'' then
               SavedOptions := StrToInt(OptionsStr);

             for aOption:=Low(TSaveNodesOption) to High(TSaveNodesOption) do
               if ((1 shl Ord(aOption)) and SavedOptions) <> 0 then
                   include(aOptions, aOption);

             List.Delete(0);//delete options string
         end;
      end;

      for i := 0 to List.Count - 1 do
      begin
        CurrStr := GetBufStart(PChar(List[i]), ALevel);
        aCells.CommaText:=CurrStr;
        if ANode = nil then
          ANode := AddChild(nil, '')//aCells[0])
        else if ANode.Level = ALevel then
          ANode := AddChild(ANode.Parent, '')//, aCells[0])
        else if ANode.Level = (ALevel - 1) then
          ANode := AddChild(ANode, '')//aCells[0])
        else if ANode.Level > ALevel then
        begin
          NextNode := ANode.Parent;
          while NextNode.Level > ALevel do
            NextNode := NextNode.Parent;
          ANode := AddChild(NextNode.Parent, '');//, aCells[0]);
        end
        else
        {$ifdef DFS_COMPILER_3_UP}
        ErrorFmt(sInvalidLevelEx, [ALevel, aCells[0]+'(Line:'+inttostr(i)+')']);
        {$ELSE}
        ErrorFmt('Invalid Level', [ALevel, aCells[0]+'(Line:'+inttostr(i)+')']);
        {$ENDIF}
        // fill cells info

         with FOwner do
         begin
           if tsnIncludeImageIndex in aOptions then
           begin
              aNode.ImageIndex := strToInt(aCells[0]);
              aCells.Delete(0);
           end;
           if tsnIncludeSelectedIndex in aOptions then
           begin
              aNode.SelectedIndex := strToInt(aCells[0]);
              aCells.Delete(0);
           end;
           if tsnIncludeStateIndex in aOptions then
           begin
              aNode.StateIndex := strToInt(aCells[0]);
              aCells.Delete(0);
           end;
           if tsnIncludeExpands in aOptions then {new}
           begin
             if strToInt(aCells[0]) <> 0 then
               aNode.FExpanded := True;
              aCells.Delete(0);
           end;

           if tsnIncludeHiddens in aOptions then {new}
           begin
             if strToInt(aCells[0]) <> 0 then
               aNode.FHidden := True;
              aCells.Delete(0);
           end;

           if (tsnIncludeUniqueTags in aOptions) then {new}
           begin
              aNode.SetUniqueTag(StrToInt(aCells[0]));
              aCells.Delete(0);
           end;

           for j:=0 to aCells.Count-1 do
           begin
            if j = StructureCol then
              aNode.Text := aCells[j]
            else
              aNode.Cells[j] := aCells[j];
           end;
         end;

      end;
    finally
      if FOwner <> nil then
        FOwner.RefreshRowHeights;
      EndUpdate;
      List.Free;
      aCells.Free;
    end;
  except
    if FOwner <> nil then
      FOwner.Invalidate;  // force repaint on exception
    raise;
  end;
end;

procedure TFlyNodes.SaveNodesToStream(Stream: TStream; SaveOptions : TSaveNodesOptions);
var
  Flags, i : Integer;
  c : integer;
  j : TSaveNodesOption;
  ANode: TFlyNode;
  CacheStr, NodeStr: string;
  aStrings : TStringlist;
begin
  if Count > 0 then
  begin
   aStrings := TStringlist.Create;

   try
    Flags :=0;
    for j:=Low(TSaveNodesOption) to High(TSaveNodesOption) do
     if j in SaveOptions then
       Flags:= Flags + (1 shl Ord(j)); //2 shr ord(i)
    NodeStr := aSaveOptions+InttoStr(Flags)+ EndOfLine;
    c := 0;
    CacheStr := '';
    Stream.Write(Pointer(NodeStr)^, Length(NodeStr));
    ANode := GetFirstNode;
    while ANode <> nil do
    begin
      NodeStr := '';
      for i := 0 to ANode.Level - 1 do NodeStr := NodeStr + TabChar;
      aStrings.Clear;
      //aStrings.Add(aNode.Text);//add Node.text
       if tsnIncludeImageIndex in SaveOptions then
           aStrings.Add(InttoStr(aNode.ImageIndex));
        if tsnIncludeSelectedIndex in SaveOptions then
           aStrings.Add(InttoStr(aNode.SelectedIndex));
        if tsnIncludeStateIndex in SaveOptions then
           aStrings.Add(InttoStr(aNode.StateIndex));
        if tsnIncludeExpands in SaveOptions then
           aStrings.Add(InttoStr(Ord(aNode.Expanded)));
        if tsnIncludeHiddens in SaveOptions then
           aStrings.Add(InttoStr(Ord(aNode.Hidden)));
        if tsnIncludeUniqueTags in SaveOptions then
           aStrings.Add(InttoStr(aNode.UniqueTag));

       if (tsnIncludeCells in SaveOptions) {and (aNode.FCells <> nil) }then
       begin
        if aNode.FCells <> nil then
        begin
         for i:=0 to aNode.FCells.Count-1 do
           aStrings.Add(aNode.Cells[i]);//Tree.GetEditText(i, aNode.getRow));
        end
        else if Tree <> nil then
        begin
         for i:=0 to Tree.ColCount-1 do
           aStrings.Add(aNode.Cells[i]);//Tree.GetEditText(i, aNode.getRow));
        end;

       end
       else
          aStrings.Add(aNode.Text);

//      end
//      else
//         aStrings.Add(aNode.Text);

      ANode := ANode.GetNext;
      NodeStr := NodeStr + aStrings.CommaText + EndOfLine;
      //Stream.Write(Pointer(NodeStr)^, Length(NodeStr));
      if (c=1000) or (aNode = nil) then
      begin
        Stream.Write(Pointer(CacheStr)^, Length(CacheStr));
        c:=0;
        CacheStr := '';
      end
      else
      begin
        inc(c);
        CacheStr := CacheStr+NodeStr+#13#10;
      end;
    end;
   finally
      aStrings.Free;

   end
  end;
end;

procedure TFlyNodes.SaveNodesToFile(const FileName: string; SaveOptions : TSaveNodesOptions);
var
  Stream: TStream;
begin
  Stream := TFileStream.Create(FileName, fmCreate);
  try
    SaveNodesToStream(Stream,SaveOptions);
  finally
    Stream.Free;
  end;
end;

procedure TFlyNodes.LoadNodesFromFile(const FileName: string);
var
  Stream: TStream;
begin
  Stream := TFileStream.Create(FileName, fmOpenRead);
  try
    LoadNodesFromStream(Stream);
  finally
    Stream.Free;
  end;
end;



initialization
   //register classes for property editors
   {$IFNDEF Registered}
   {$IFNDEF ACTIVEX}
      ShowURToolTip('', false);
   {$ENDIF}
   {$ENDIF}


   InitDoubleChecks;
   GetCheckSize;
   if GetClass('TFlyNode') = nil then
   begin
      Classes.RegisterClass(TFlyNode);
      RegisterTreeCollectionClass(TFlyNode);
   end;

finalization
   if aDCBmp <> nil then
      aDCBmp.Free;
   if aGDCBmp <> nil then
      aGDCBmp.Free;

end.


